
This is a patch file against 0.2.0.

Change to directory g10-0.2.0 (or however you renamed it)
and give this command:

     zcat somepath/g10-0.2.1.diff.gz | patch -p1

It is a good idea to rename your current directory to g10-0.2.1 now.



Prereq: 0.2.0

diff -urN g10-0.2.0/VERSION g10-0.2.1/VERSION
--- g10-0.2.0/VERSION	Sun Jan 25 19:55:46 1998
+++ g10-0.2.1/VERSION	Wed Jan 28 15:33:55 1998
@@ -1 +1 @@
-0.2.0
+0.2.1
diff -urN g10-0.2.0/intl/VERSION g10-0.2.1/intl/VERSION
--- g10-0.2.0/intl/VERSION	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/VERSION	Mon Jan 26 20:10:55 1998
@@ -0,0 +1 @@
+GNU gettext library from gettext-0.10
diff -urN g10-0.2.0/intl/bindtextdom.c g10-0.2.1/intl/bindtextdom.c
--- g10-0.2.0/intl/bindtextdom.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/bindtextdom.c	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,172 @@
+/* bindtextdom.c -- implementation of the bindtextdomain(3) function
+   Copyright (C) 1995 Free Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#if defined STDC_HEADERS || defined _LIBC
+# include <stdlib.h>
+#else
+# ifdef HAVE_MALLOC_H
+#  include <malloc.h>
+# else
+void free ();
+# endif
+#endif
+
+#if defined HAVE_STRING_H || defined _LIBC
+# include <string.h>
+#else
+# include <strings.h>
+#endif
+
+#ifdef _LIBC
+# include <libintl.h>
+#else
+# include "libgettext.h"
+#endif
+#include "gettext.h"
+#include "gettextP.h"
+
+/* @@ end of prolog @@ */
+
+/* Contains the default location of the message catalogs.  */
+extern const char _nl_default_dirname[];
+
+/* List with bindings of specific domains.  */
+extern struct binding *_nl_domain_bindings;
+
+
+/* Names for the libintl functions are a problem.  They must not clash
+   with existing names and they should follow ANSI C.  But this source
+   code is also used in GNU C Library where the names have a __
+   prefix.  So we have to make a difference here.  */
+#ifdef _LIBC
+# define BINDTEXTDOMAIN __bindtextdomain
+#else
+# define BINDTEXTDOMAIN bindtextdomain__
+#endif
+
+/* Specify that the DOMAINNAME message catalog will be found
+   in DIRNAME rather than in the system locale data base.  */
+char *
+BINDTEXTDOMAIN (domainname, dirname)
+     const char *domainname;
+     const char *dirname;
+{
+  struct binding *binding;
+
+  /* Some sanity checks.  */
+  if (domainname == NULL || domainname[0] == '\0')
+    return NULL;
+
+  for (binding = _nl_domain_bindings; binding != NULL; binding = binding->next)
+    {
+      int compare = strcmp (domainname, binding->domainname);
+      if (compare == 0)
+	/* We found it!  */
+	break;
+      if (compare < 0)
+	{
+	  /* It is not in the list.  */
+	  binding = NULL;
+	  break;
+	}
+    }
+
+  if (dirname == NULL)
+    /* The current binding has be to returned.  */
+    return binding == NULL ? (char *) _nl_default_dirname : binding->dirname;
+
+  if (binding != NULL)
+    {
+      /* The domain is already bound.  Replace the old binding.  */
+      char *new_dirname;
+
+      if (strcmp (dirname, _nl_default_dirname) == 0)
+	new_dirname = (char *) _nl_default_dirname;
+      else
+	{
+	  size_t len = strlen (dirname) + 1;
+	  new_dirname = (char *) malloc (len);
+	  if (new_dirname == NULL)
+	    return NULL;
+
+	  memcpy (new_dirname, dirname, len);
+	}
+
+      if (strcmp (binding->dirname, _nl_default_dirname) != 0)
+        free (binding->dirname);
+
+      binding->dirname = new_dirname;
+    }
+  else
+    {
+      /* We have to create a new binding.  */
+      size_t len;
+      struct binding *new_binding =
+	(struct binding *) malloc (sizeof (*new_binding));
+
+      if (new_binding == NULL)
+	return NULL;
+
+      len = strlen (domainname) + 1;
+      new_binding->domainname = (char *) malloc (len);
+      if (new_binding->domainname == NULL)
+	  return NULL;
+      memcpy (new_binding->domainname, domainname, len);
+
+      if (strcmp (dirname, _nl_default_dirname) == 0)
+	new_binding->dirname = (char *) _nl_default_dirname;
+      else
+	{
+	  len = strlen (dirname) + 1;
+	  new_binding->dirname = (char *) malloc (len);
+	  if (new_binding->dirname == NULL)
+	    return NULL;
+	  memcpy (new_binding->dirname, dirname, len);
+	}
+
+      /* Now enqueue it.  */
+      if (_nl_domain_bindings == NULL
+	  || strcmp (domainname, _nl_domain_bindings->domainname) < 0)
+	{
+	  new_binding->next = _nl_domain_bindings;
+	  _nl_domain_bindings = new_binding;
+	}
+      else
+	{
+	  binding = _nl_domain_bindings;
+	  while (binding->next != NULL
+		 && strcmp (domainname, binding->next->domainname) > 0)
+	    binding = binding->next;
+
+	  new_binding->next = binding->next;
+	  binding->next = new_binding;
+	}
+
+      binding = new_binding;
+    }
+
+  return binding->dirname;
+}
+
+#ifdef _LIBC
+/* Alias for function name in GNU C Library.  */
+weak_alias (__bindtextdomain, bindtextdomain);
+#endif
diff -urN g10-0.2.0/intl/cat-compat.c g10-0.2.1/intl/cat-compat.c
--- g10-0.2.0/intl/cat-compat.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/cat-compat.c	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,252 @@
+/* Compatibility code for gettext-using-catgets interface.
+   Copyright (C) 1995 Free Software Foundation, Inc.
+
+The GNU C Library is free software; you can redistribute it and/or
+modify it under the terms of the GNU Library General Public License as
+published by the Free Software Foundation; either version 2 of the
+License, or (at your option) any later version.
+
+The GNU C Library is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+Library General Public License for more details.
+
+You should have received a copy of the GNU Library General Public
+License along with the GNU C Library; see the file COPYING.LIB.  If
+not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#include <stdio.h>
+
+#ifdef STDC_HEADERS
+# include <stdlib.h>
+# include <string.h>
+#else
+char *getenv ();
+# ifdef HAVE_MALLOC_H
+#  include <malloc.h>
+# endif
+#endif
+
+#ifdef HAVE_NL_TYPES_H
+# include <nl_types.h>
+#endif
+
+#include "libgettext.h"
+
+/* @@ end of prolog @@ */
+
+/* The catalog descriptor.  */
+static nl_catd catalog = (nl_catd) -1;
+
+/* Name of the default catalog.  */
+static const char default_catalog_name[] = "messages";
+
+/* Name of currently used catalog.  */
+static const char *catalog_name = default_catalog_name;
+
+/* Get ID for given string.  If not found return -1.  */
+static int msg_to_cat_id __P ((const char *msg));
+
+/* Substitution for systems lacking this function in their C library.  */
+#if !_LIBC && !HAVE_STPCPY
+static char *stpcpy __P ((char *dest, const char *src));
+#endif
+
+
+/* Set currently used domain/catalog.  */
+char *
+textdomain (domainname)
+     const char *domainname;
+{
+  nl_catd new_catalog;
+  char *new_name;
+  size_t new_name_len;
+  char *lang;
+
+#if HAVE_SETLOCALE && HAVE_LC_MESSAGES && HAVE_SETLOCALE_NULL
+  lang = setlocale (LC_MESSAGES, NULL);
+#else
+  lang = getenv ("LC_ALL");
+  if (lang == NULL || lang[0] == '\0')
+    {
+      lang = getenv ("LC_MESSAGES");
+      if (lang == NULL || lang[0] == '\0')
+	lang = getenv ("LANG");
+    }
+#endif
+  if (lang == NULL || lang[0] == '\0')
+    lang = "C";
+
+  /* See whether name of currently used domain is asked.  */
+  if (domainname == NULL)
+    return (char *) catalog_name;
+
+  if (domainname[0] == '\0')
+    domainname = default_catalog_name;
+
+  /* Compute length of added path element.  */
+  new_name_len = sizeof (LOCALEDIR) - 1 + 1 + strlen (lang)
+		 + sizeof ("/LC_MESSAGES/") - 1 + sizeof (PACKAGE) - 1
+		 + sizeof (".cat");
+
+  new_name = (char *) malloc (new_name_len);
+  if (new_name == NULL)
+    return NULL;
+
+  strcpy (new_name, PACKAGE);
+  new_catalog = catopen (new_name, 0);
+
+  if (new_catalog == (nl_catd) -1)
+    {
+      /* NLSPATH search didn't work, try absolute path */
+      sprintf (new_name, "%s/%s/LC_MESSAGES/%s.cat", LOCALEDIR, lang,
+	       PACKAGE);
+      new_catalog = catopen (new_name, 0);
+
+      if (new_catalog == (nl_catd) -1)
+	{
+	  free (new_name);
+	  return (char *) catalog_name;
+	}
+    }
+
+  /* Close old catalog.  */
+  if (catalog != (nl_catd) -1)
+    catclose (catalog);
+  if (catalog_name != default_catalog_name)
+    free ((char *) catalog_name);
+
+  catalog = new_catalog;
+  catalog_name = new_name;
+
+  return (char *) catalog_name;
+}
+
+char *
+bindtextdomain (domainname, dirname)
+     const char *domainname;
+     const char *dirname;
+{
+#if HAVE_SETENV || HAVE_PUTENV
+  char *old_val, *new_val, *cp;
+  size_t new_val_len;
+
+  /* This does not make much sense here but to be compatible do it.  */
+  if (domainname == NULL)
+    return NULL;
+
+  /* Compute length of added path element.  If we use setenv we don't need
+     the first byts for NLSPATH=, but why complicate the code for this
+     peanuts.  */
+  new_val_len = sizeof ("NLSPATH=") - 1 + strlen (dirname)
+		+ sizeof ("/%L/LC_MESSAGES/%N.cat");
+
+  old_val = getenv ("NLSPATH");
+  if (old_val == NULL || old_val[0] == '\0')
+    {
+      old_val = NULL;
+      new_val_len += 1 + sizeof (LOCALEDIR) - 1
+	             + sizeof ("/%L/LC_MESSAGES/%N.cat");
+    }
+  else
+    new_val_len += strlen (old_val);
+
+  new_val = (char *) malloc (new_val_len);
+  if (new_val == NULL)
+    return NULL;
+
+# if HAVE_SETENV
+  cp = new_val;
+# else
+  cp = stpcpy (new_val, "NLSPATH=");
+# endif
+
+  cp = stpcpy (cp, dirname);
+  cp = stpcpy (cp, "/%L/LC_MESSAGES/%N.cat:");
+
+  if (old_val == NULL)
+    {
+# if __STDC__
+      stpcpy (cp, LOCALEDIR "/%L/LC_MESSAGES/%N.cat");
+# else
+
+      cp = stpcpy (cp, LOCALEDIR);
+      stpcpy (cp, "/%L/LC_MESSAGES/%N.cat");
+# endif
+    }
+  else
+    stpcpy (cp, old_val);
+
+# if HAVE_SETENV
+  setenv ("NLSPATH", new_val, 1);
+  free (new_val);
+# else
+  putenv (new_val);
+  /* Do *not* free the environment entry we just entered.  It is used
+     from now on.   */
+# endif
+
+#endif
+
+  return (char *) domainname;
+}
+
+#undef gettext
+char *
+gettext (msg)
+     const char *msg;
+{
+  int msgid;
+
+  if (msg == NULL || catalog == (nl_catd) -1)
+    return (char *) msg;
+
+  /* Get the message from the catalog.  We always use set number 1.
+     The message ID is computed by the function `msg_to_cat_id'
+     which works on the table generated by `po-to-tbl'.  */
+  msgid = msg_to_cat_id (msg);
+  if (msgid == -1)
+    return (char *) msg;
+
+  return catgets (catalog, 1, msgid, (char *) msg);
+}
+
+/* Look through the table `_msg_tbl' which has `_msg_tbl_length' entries
+   for the one equal to msg.  If it is found return the ID.  In case when
+   the string is not found return -1.  */
+static int
+msg_to_cat_id (msg)
+     const char *msg;
+{
+  int cnt;
+
+  for (cnt = 0; cnt < _msg_tbl_length; ++cnt)
+    if (strcmp (msg, _msg_tbl[cnt]._msg) == 0)
+      return _msg_tbl[cnt]._msg_number;
+
+  return -1;
+}
+
+
+/* @@ begin of epilog @@ */
+
+/* We don't want libintl.a to depend on any other library.  So we
+   avoid the non-standard function stpcpy.  In GNU C Library this
+   function is available, though.  Also allow the symbol HAVE_STPCPY
+   to be defined.  */
+#if !_LIBC && !HAVE_STPCPY
+static char *
+stpcpy (dest, src)
+     char *dest;
+     const char *src;
+{
+  while ((*dest++ = *src++) != '\0')
+    /* Do nothing. */ ;
+  return dest - 1;
+}
+#endif
diff -urN g10-0.2.0/intl/dcgettext.c g10-0.2.1/intl/dcgettext.c
--- g10-0.2.0/intl/dcgettext.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/dcgettext.c	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,522 @@
+/* dcgettext.c -- implemenatation of the dcgettext(3) function
+   Copyright (C) 1995 Free Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#include <sys/types.h>
+
+#ifdef __GNUC__
+# define alloca __builtin_alloca
+#else
+# if defined HAVE_ALLOCA_H || defined _LIBC
+#  include <alloca.h>
+# else
+#  ifdef _AIX
+ #pragma alloca
+#  else
+#   ifndef alloca
+char *alloca ();
+#   endif
+#  endif
+# endif
+#endif
+
+#include <errno.h>
+#ifndef errno
+extern int errno;
+#endif
+
+#if defined STDC_HEADERS || defined _LIBC
+# include <stdlib.h>
+#else
+char *getenv ();
+# ifdef HAVE_MALLOC_H
+#  include <malloc.h>
+# else
+void free ();
+# endif
+#endif
+
+#if defined HAVE_STRING_H || defined _LIBC
+# include <string.h>
+#else
+# include <strings.h>
+#endif
+#if !HAVE_STRCHR && !defined _LIBC
+# ifndef strchr
+#  define strchr index
+# endif
+#endif
+
+#if defined HAVE_UNISTD_H || defined _LIBC
+# include <unistd.h>
+#endif
+
+#include "gettext.h"
+#include "gettextP.h"
+#ifdef _LIBC
+# include <libintl.h>
+#else
+# include "libgettext.h"
+#endif
+#include "hash-string.h"
+
+/* @@ end of prolog @@ */
+
+#ifdef _LIBC
+/* Rename the non ANSI C functions.  This is required by the standard
+   because some ANSI C functions will require linking with this object
+   file and the name space must not be polluted.  */
+# define getcwd __getcwd
+# define stpcpy __stpcpy
+#endif
+
+#if !defined HAVE_GETCWD && !defined _LIBC
+char *getwd ();
+# define getcwd(buf, max) getwd (buf)
+#else
+char *getcwd ();
+#endif
+
+/* Amount to increase buffer size by in each try.  */
+#define PATH_INCR 32
+
+/* The following is from pathmax.h.  */
+/* Non-POSIX BSD systems might have gcc's limits.h, which doesn't define
+   PATH_MAX but might cause redefinition warnings when sys/param.h is
+   later included (as on MORE/BSD 4.3).  */
+#if defined(_POSIX_VERSION) || (defined(HAVE_LIMITS_H) && !defined(__GNUC__))
+# include <limits.h>
+#endif
+
+#ifndef _POSIX_PATH_MAX
+# define _POSIX_PATH_MAX 255
+#endif
+
+#if !defined(PATH_MAX) && defined(_PC_PATH_MAX)
+# define PATH_MAX (pathconf ("/", _PC_PATH_MAX) < 1 ? 1024 : pathconf ("/", _PC_PATH_MAX))
+#endif
+
+/* Don't include sys/param.h if it already has been.  */
+#if defined(HAVE_SYS_PARAM_H) && !defined(PATH_MAX) && !defined(MAXPATHLEN)
+# include <sys/param.h>
+#endif
+
+#if !defined(PATH_MAX) && defined(MAXPATHLEN)
+# define PATH_MAX MAXPATHLEN
+#endif
+
+#ifndef PATH_MAX
+# define PATH_MAX _POSIX_PATH_MAX
+#endif
+
+/* XPG3 defines the result of `setlocale (category, NULL)' as:
+   ``Directs `setlocale()' to query `category' and return the current
+     setting of `local'.''
+   However it does not specify the exact format.  And even worse: POSIX
+   defines this not at all.  So we can use this feature only on selected
+   system (e.g. those using GNU C Library).  */
+#ifdef _LIBC
+# define HAVE_LOCALE_NULL
+#endif
+
+/* Name of the default domain used for gettext(3) prior any call to
+   textdomain(3).  The default value for this is "messages".  */
+const char _nl_default_default_domain[] = "messages";
+
+/* Value used as the default domain for gettext(3).  */
+const char *_nl_current_default_domain = _nl_default_default_domain;
+
+/* Contains the default location of the message catalogs.  */
+const char _nl_default_dirname[] = GNULOCALEDIR;
+
+/* List with bindings of specific domains created by bindtextdomain()
+   calls.  */
+struct binding *_nl_domain_bindings;
+
+/* Prototypes for local functions.  */
+static char *find_msg __P ((struct loaded_domain *domain, const char *msgid));
+static const char *category_to_name __P((int category));
+static const char *guess_category_value __P((int category,
+					     const char *categoryname));
+
+
+/* Names for the libintl functions are a problem.  They must not clash
+   with existing names and they should follow ANSI C.  But this source
+   code is also used in GNU C Library where the names have a __
+   prefix.  So we have to make a difference here.  */
+#ifdef _LIBC
+# define DCGETTEXT __dcgettext
+#else
+# define DCGETTEXT dcgettext__
+#endif
+
+/* Look up MSGID in the DOMAINNAME message catalog for the current CATEGORY
+   locale.  */
+char *
+DCGETTEXT (domainname, msgid, category)
+     const char *domainname;
+     const char *msgid;
+     int category;
+{
+  struct loaded_domain *domain;
+  struct binding *binding;
+  const char *categoryname;
+  const char *categoryvalue;
+  char *dirname, *xdomainname;
+  char *single_locale;
+  char *retval;
+
+  /* If no real MSGID is given return NULL.  */
+  if (msgid == NULL)
+    return NULL;
+
+  /* If DOMAINNAME is NULL, we are interested in the default domain.  If
+     CATEGORY is not LC_MESSAGES this might not make much sense but the
+     defintion left this undefined.  */
+  if (domainname == NULL)
+    domainname = _nl_current_default_domain;
+
+  /* First find matching binding.  */
+  for (binding = _nl_domain_bindings; binding != NULL; binding = binding->next)
+    {
+      int compare = strcmp (domainname, binding->domainname);
+      if (compare == 0)
+	/* We found it!  */
+	break;
+      if (compare < 0)
+	{
+	  /* It is not in the list.  */
+	  binding = NULL;
+	  break;
+	}
+    }
+
+  if (binding == NULL)
+    dirname = (char *) _nl_default_dirname;
+  else if (binding->dirname[0] == '/')
+    dirname = binding->dirname;
+  else
+    {
+      /* We have a relative path.  Make it absolute now.  */
+      size_t dirname_len = strlen (binding->dirname) + 1;
+      size_t path_max;
+      char *ret;
+
+      path_max = (unsigned) PATH_MAX;
+      path_max += 2;		/* The getcwd docs say to do this.  */
+
+      dirname = (char *) alloca (path_max + dirname_len);
+
+      errno = 0;
+      while ((ret = getcwd (dirname, path_max)) == NULL && errno == ERANGE)
+	{
+	  path_max += PATH_INCR;
+	  dirname = (char *) alloca (path_max + dirname_len);
+	  errno = 0;
+	}
+
+      if (ret == NULL)
+	/* We cannot get the current working directory.  Don't signal an
+	   error but simply return the default string.  */
+	return (char *) msgid;
+
+      /* We don't want libintl.a to depend on any other library.  So
+	 we avoid the non-standard function stpcpy.  In GNU C Library
+	 this function is available, though.  Also allow the symbol
+	 HAVE_STPCPY to be defined.  */
+#if defined _LIBC || defined HAVE_STPCPY
+      stpcpy (stpcpy (strchr (dirname, '\0'), "/"), binding->dirname);
+#else
+      strcat (dirname, "/");
+      strcat (dirname, binding->dirname);
+#endif
+    }
+
+  /* Now determine the symbolic name of CATEGORY and its value.  */
+  categoryname = category_to_name (category);
+  categoryvalue = guess_category_value (category, categoryname);
+
+  xdomainname = (char *) alloca (strlen (categoryname)
+				 + strlen (domainname) + 5);
+  /* We don't want libintl.a to depend on any other library.  So we
+     avoid the non-standard function stpcpy.  In GNU C Library this
+     function is available, though.  Also allow the symbol HAVE_STPCPY
+     to be defined.  */
+#if defined _LIBC || defined HAVE_STPCPY
+  stpcpy (stpcpy (stpcpy (stpcpy (xdomainname, categoryname), "/"),
+		  domainname),
+	  ".mo");
+#else
+  strcpy (xdomainname, categoryname);
+  strcat (xdomainname, "/");
+  strcat (xdomainname, domainname);
+  strcat (xdomainname, ".mo");
+#endif
+
+  /* Creating working area.  */
+  single_locale = (char *) alloca (strlen (categoryvalue) + 1);
+
+
+  /* Search for the given string.  This is a loop because we perhaps
+     got an ordered list of languages to consider for th translation.  */
+  while (1)
+    {
+      /* Make CATEGORYVALUE point to the next element of the list.  */
+      while (categoryvalue[0] != '\0' && categoryvalue[0] == ':')
+	++categoryvalue;
+      if (categoryvalue[0] == '\0')
+	{
+	  /* The whole contents of CATEGORYVALUE has been searched but
+	     no valid entry has been found.  We solve this situation
+	     by implicitely appending a "C" entry, i.e. no translation
+	     will take place.  */
+	  single_locale[0] = 'C';
+	  single_locale[1] = '\0';
+	}
+      else
+	{
+	  char *cp = single_locale;
+	  while (categoryvalue[0] != '\0' && categoryvalue[0] != ':')
+	    *cp++ = *categoryvalue++;
+	  *cp = '\0';
+	}
+
+      /* If the current locale value is C (or POSIX) we don't load a
+	 domain.  Return the MSGID.  */
+      if (strcmp (single_locale, "C") == 0
+	  || strcmp (single_locale, "POSIX") == 0)
+	return (char *) msgid;
+
+
+      /* Find structure describing the message catalog matching the
+	 DOMAINNAME and CATEGORY.  */
+      domain = _nl_find_domain (dirname, single_locale, xdomainname);
+
+      if (domain != NULL)
+	{
+	  retval = find_msg (domain, msgid);
+
+	  if (retval == NULL)
+	    {
+	      int cnt;
+
+	      for (cnt = 0; domain->successor[cnt] != NULL; ++cnt)
+		{
+		  retval = find_msg (domain->successor[cnt], msgid);
+
+		  if (retval != NULL)
+		    break;
+		}
+	    }
+
+	  if (retval != NULL)
+	    return retval;
+	}
+    }
+  /* NOTREACHED */
+}
+
+#ifdef _LIBC
+/* Alias for function name in GNU C Library.  */
+weak_alias (__dcgettext, dcgettext);
+#endif
+
+
+static char *
+find_msg (domain, msgid)
+     struct loaded_domain *domain;
+     const char *msgid;
+{
+  size_t top, act, bottom;
+
+  if (domain->decided == 0)
+    _nl_load_domain (domain);
+
+  if (domain->data == NULL)
+    return NULL;
+
+  /* Locate the MSGID and its translation.  */
+  if (domain->hash_size > 2 && domain->hash_tab != NULL)
+    {
+      /* Use the hashing table.  */
+      nls_uint32 len = strlen (msgid);
+      nls_uint32 hash_val = hash_string (msgid);
+      nls_uint32 idx = hash_val % domain->hash_size;
+      nls_uint32 incr = 1 + (hash_val % (domain->hash_size - 2));
+      nls_uint32 nstr = W (domain->must_swap, domain->hash_tab[idx]);
+
+      if (nstr == 0)
+	/* Hash table entry is empty.  */
+	return NULL;
+
+      if (W (domain->must_swap, domain->orig_tab[nstr - 1].length) == len
+	  && strcmp (msgid,
+		     domain->data + W (domain->must_swap,
+				       domain->orig_tab[nstr - 1].offset)) == 0)
+	return (char *) domain->data + W (domain->must_swap,
+					  domain->trans_tab[nstr - 1].offset);
+
+      while (1)
+	{
+	  if (idx >= W (domain->must_swap, domain->hash_size) - incr)
+	    idx -= W (domain->must_swap, domain->hash_size) - incr;
+	  else
+	    idx += incr;
+
+	  nstr = W (domain->must_swap, domain->hash_tab[idx]);
+	  if (nstr == 0)
+	    /* Hash table entry is empty.  */
+	    return NULL;
+
+	  if (W (domain->must_swap, domain->orig_tab[nstr - 1].length) == len
+	      && strcmp (msgid,
+			 domain->data + W (domain->must_swap,
+					   domain->orig_tab[nstr - 1].offset))
+	         == 0)
+	    return (char *) domain->data
+	      + W (domain->must_swap, domain->trans_tab[nstr - 1].offset);
+	}
+      /* NOTREACHED */
+    }
+
+  /* Now we try the default method:  binary search in the sorted
+     array of messages.  */
+  bottom = 0;
+  top = domain->nstrings;
+  while (bottom < top)
+    {
+      int cmp_val;
+
+      act = (bottom + top) / 2;
+      cmp_val = strcmp (msgid, domain->data
+			       + W (domain->must_swap,
+				    domain->orig_tab[act].offset));
+      if (cmp_val < 0)
+	top = act;
+      else if (cmp_val > 0)
+	bottom = act + 1;
+      else
+	break;
+    }
+
+  /* If an translation is found return this.  */
+  return bottom >= top ? NULL : (char *) domain->data
+                                + W (domain->must_swap,
+				     domain->trans_tab[act].offset);
+}
+
+
+/* Return string representation of locale CATEGORY.  */
+static const char *category_to_name (category)
+     int category;
+{
+  const char *retval;
+
+  switch (category)
+  {
+#ifdef LC_COLLATE
+  case LC_COLLATE:
+    retval = "LC_COLLATE";
+    break;
+#endif
+#ifdef LC_CTYPE
+  case LC_CTYPE:
+    retval = "LC_CTYPE";
+    break;
+#endif
+#ifdef LC_MONETARY
+  case LC_MONETARY:
+    retval = "LC_MONETARY";
+    break;
+#endif
+#ifdef LC_NUMERIC
+  case LC_NUMERIC:
+    retval = "LC_NUMERIC";
+    break;
+#endif
+#ifdef LC_TIME
+  case LC_TIME:
+    retval = "LC_TIME";
+    break;
+#endif
+#ifdef LC_MESSAGES
+  case LC_MESSAGES:
+    retval = "LC_MESSAGES";
+    break;
+#endif
+#ifdef LC_RESPONSE
+  case LC_RESPONSE:
+    retval = "LC_RESPONSE";
+    break;
+#endif
+#ifdef LC_ALL
+  case LC_ALL:
+    /* This might not make sense but is perhaps better than any other
+       value.  */
+    retval = "LC_ALL";
+    break;
+#endif
+  default:
+    /* If you have a better idea for a default value let me know.  */
+    retval = "LC_XXX";
+  }
+
+  return retval;
+}
+
+/* Guess value of current locale from value of the environment variables.  */
+static const char *guess_category_value (category, categoryname)
+     int category;
+     const char *categoryname;
+{
+  const char *retval;
+
+  /* The highest priority value is the `LANGUAGE' environment
+     variable.  This is a GNU extension.  */
+  retval = getenv ("LANGUAGE");
+  if (retval != NULL && retval[0] != '\0')
+    return retval;
+
+  /* `LANGUAGE' is not set.  So we have to proceed with the POSIX
+     methods of looking to `LC_ALL', `LC_xxx', and `LANG'.  On some
+     systems this can be done by the `setlocale' function itself.  */
+#if defined HAVE_SETLOCALE && defined HAVE_LC_MESSAGES && defined HAVE_LOCALE_NULL
+  return setlocale (category, NULL);
+#else
+  /* Setting of LC_ALL overwrites all other.  */
+  retval = getenv ("LC_ALL");
+  if (retval != NULL && retval[0] != '\0')
+    return retval;
+
+  /* Next comes the name of the desired category.  */
+  retval = getenv (categoryname);
+  if (retval != NULL && retval[0] != '\0')
+    return retval;
+
+  /* Last possibility is the LANG environment variable.  */
+  retval = getenv ("LANG");
+  if (retval != NULL && retval[0] != '\0')
+    return retval;
+
+  /* We use C as the default domain.  POSIX says this is implementation
+     defined.  */
+  return "C";
+#endif
+}
diff -urN g10-0.2.0/intl/dgettext.c g10-0.2.1/intl/dgettext.c
--- g10-0.2.0/intl/dgettext.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/dgettext.c	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,59 @@
+/* dgettext.c -- implementation of the dgettext(3) function
+   Copyright (C) 1995 Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#if defined HAVE_LOCALE_H || defined _LIBC
+# include <locale.h>
+#endif
+
+#ifdef _LIBC
+# include <libintl.h>
+#else
+# include "libgettext.h"
+#endif
+
+/* @@ end of prolog @@ */
+
+/* Names for the libintl functions are a problem.  They must not clash
+   with existing names and they should follow ANSI C.  But this source
+   code is also used in GNU C Library where the names have a __
+   prefix.  So we have to make a difference here.  */
+#ifdef _LIBC
+# define DGETTEXT __dgettext
+# define DCGETTEXT __dcgettext
+#else
+# define DGETTEXT dgettext__
+# define DCGETTEXT dcgettext__
+#endif
+
+/* Look up MSGID in the DOMAINNAME message catalog of the current
+   LC_MESSAGES locale.  */
+char *
+DGETTEXT (domainname, msgid)
+     const char *domainname;
+     const char *msgid;
+{
+  return DCGETTEXT (domainname, msgid, LC_MESSAGES);
+}
+
+#ifdef _LIBC
+/* Alias for function name in GNU C Library.  */
+weak_alias (__dgettext, dgettext);
+#endif
diff -urN g10-0.2.0/intl/finddomain.c g10-0.2.1/intl/finddomain.c
--- g10-0.2.0/intl/finddomain.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/finddomain.c	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,503 @@
+/* finddomain.c -- handle list of needed message catalogs
+   Copyright (C) 1995 Software Foundation, Inc.
+   Written by Ulrich Drepper <drepper@gnu.ai.mit.edu>, 1995.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#include <errno.h>
+#include <stdio.h>
+#include <sys/types.h>
+
+#if defined STDC_HEADERS || defined _LIBC
+# include <stdlib.h>
+#else
+# ifdef HAVE_MALLOC_H
+#  include <malloc.h>
+# else
+void free ();
+# endif
+#endif
+
+#if defined HAVE_STRING_H || defined _LIBC
+# include <string.h>
+#else
+# include <strings.h>
+#endif
+#if !HAVE_STRCHR && !defined _LIBC
+# ifndef strchr
+#  define strchr index
+# endif
+#endif
+
+#if defined HAVE_UNISTD_H || defined _LIBC
+# include <unistd.h>
+#endif
+
+#include "gettext.h"
+#include "gettextP.h"
+#ifdef _LIBC
+# include <libintl.h>
+#else
+# include "libgettext.h"
+#endif
+
+/* @@ end of prolog @@ */
+
+#ifdef _LIBC
+/* Rename the non ANSI C functions.  This is required by the standard
+   because some ANSI C functions will require linking with this object
+   file and the name space must not be polluted.  */
+# define stpcpy __stpcpy
+#endif
+
+/* Encoding of locale name parts.  */
+#define CEN_REVISION	1
+#define CEN_SPONSOR	2
+#define CEN_SPECIAL	4
+#define XPG_CODESET	8
+#define TERRITORY	16
+#define CEN_AUDIENCE	32
+#define XPG_MODIFIER	64
+
+#define CEN_SPECIFIC	(CEN_REVISION|CEN_SPONSOR|CEN_SPECIAL|CEN_AUDIENCE)
+#define XPG_SPECIFIC	(XPG_CODESET|XPG_MODIFIER)
+
+
+/* List of already loaded domains.  */
+static struct loaded_domain *_nl_loaded_domains;
+
+/* Prototypes for local functions.  */
+static struct loaded_domain *make_entry_rec __P ((const char *dirname,
+						  int mask,
+						  const char *language,
+						  const char *territory,
+						  const char *codeset,
+						  const char *modifier,
+						  const char *special,
+						  const char *sponsor,
+						  const char *revision,
+						  const char *domainname,
+						  int do_allocate));
+
+/* Substitution for systems lacking this function in their C library.  */
+#if !_LIBC && !HAVE_STPCPY
+static char *stpcpy __P ((char *dest, const char *src));
+#endif
+
+
+/* Return a data structure describing the message catalog described by
+   the DOMAINNAME and CATEGORY parameters with respect to the currently
+   established bindings.  */
+struct loaded_domain *
+_nl_find_domain (dirname, locale, domainname)
+     const char *dirname;
+     char *locale;
+     const char *domainname;
+{
+  enum { undecided, xpg, cen } syntax;
+  struct loaded_domain *retval;
+  const char *language;
+  const char *modifier = NULL;
+  const char *territory = NULL;
+  const char *codeset = NULL;
+  const char *special = NULL;
+  const char *sponsor = NULL;
+  const char *revision = NULL;
+  const char *alias_value = NULL;
+  char *cp;
+  int mask;
+
+  /* CATEGORYVALUE now possibly contains a colon separated list of
+     locales.  Each single locale can consist of up to four recognized
+     parts for the XPG syntax:
+
+		language[_territory[.codeset]][@modifier]
+
+     and six parts for the CEN syntax:
+
+	language[_territory][+audience][+special][,sponsor][_revision]
+
+     Beside the first all of them are allowed to be missing.  If the
+     full specified locale is not found, the less specific one are
+     looked for.  The various part will be stripped of according to
+     the following order:
+		(1) revision
+		(2) sponsor
+		(3) special
+		(4) codeset
+		(5) territory
+		(6) audience/modifier
+   */
+
+  /* If we have already tested for this locale entry there has to
+     be one data set in the list of loaded domains.  */
+  retval = make_entry_rec (dirname, 0, locale, NULL, NULL, NULL,
+			   NULL, NULL, NULL, domainname, 0);
+  if (retval != NULL)
+    {
+      /* We know something about this locale.  */
+      int cnt;
+
+      if (retval->decided == 0)
+	_nl_load_domain (retval); /* @@@ */
+
+      if (retval->data != NULL)
+	return retval;
+
+      for (cnt = 0; retval->successor[cnt] != NULL; ++cnt)
+	{
+	  if (retval->successor[cnt]->decided == 0)
+	    _nl_load_domain (retval->successor[cnt]);
+
+	  if (retval->successor[cnt]->data != NULL)
+	    break;
+	}
+
+      /* We really found some usable information.  */
+      return cnt >= 0 ? retval : NULL;
+      /* NOTREACHED */
+    }
+
+  /* See whether the locale value is an alias.  If yes its value
+     *overwrites* the alias name.  No test for the original value is
+     done.  */
+  alias_value = _nl_expand_alias (locale);
+  if (alias_value != NULL)
+    {
+      size_t len = strlen (alias_value) + 1;
+      locale = (char *) malloc (len);
+      if (locale == NULL)
+	return NULL;
+
+      memcpy (locale, alias_value, len);
+    }
+
+  /* Now we determine the single parts of the locale name.  First
+     look for the language.  Termination symbols are `_' and `@' if
+     we use XPG4 style, and `_', `+', and `,' if we use CEN syntax.  */
+  mask = 0;
+  syntax = undecided;
+  language = cp = locale;
+  while (cp[0] != '\0' && cp[0] != '_' && cp[0] != '@'
+	 && cp[0] != '+' && cp[0] != ',')
+    ++cp;
+
+  if (language == cp)
+    /* This does not make sense: language has to be specified.  Use
+       this entry as it is without exploding.  Perhaps it is an alias.  */
+    cp = strchr (language, '\0');
+  else if (cp[0] == '_')
+    {
+      /* Next is the territory.  */
+      cp[0] = '\0';
+      territory = ++cp;
+
+      while (cp[0] != '\0' && cp[0] != '.' && cp[0] != '@'
+	     && cp[0] != '+' && cp[0] != ',' && cp[0] != '_')
+	++cp;
+
+      mask |= TERRITORY;
+
+      if (cp[0] == '.')
+	{
+	  /* Next is the codeset.  */
+	  syntax = xpg;
+	  cp[0] = '\0';
+	  codeset = ++cp;
+
+	  while (cp[0] != '\0' && cp[0] != '@')
+	    ++cp;
+
+	  mask |= XPG_CODESET;
+	}
+    }
+
+  if (cp[0] == '@' || (syntax != xpg && cp[0] == '+'))
+    {
+      /* Next is the modifier.  */
+      syntax = cp[0] == '@' ? xpg : cen;
+      cp[0] = '\0';
+      modifier = ++cp;
+
+      while (syntax == cen && cp[0] != '\0' && cp[0] != '+'
+	     && cp[0] != ',' && cp[0] != '_')
+	++cp;
+
+      mask |= XPG_MODIFIER | CEN_AUDIENCE;
+    }
+
+  if (syntax != xpg && (cp[0] == '+' || cp[0] == ',' || cp[0] == '_'))
+    {
+      syntax = cen;
+
+      if (cp[0] == '+')
+	{
+ 	  /* Next is special application (CEN syntax).  */
+	  cp[0] = '\0';
+	  special = ++cp;
+
+	  while (cp[0] != '\0' && cp[0] != ',' && cp[0] != '_')
+	    ++cp;
+
+	  mask |= CEN_SPECIAL;
+	}
+
+      if (cp[0] == ',')
+	{
+ 	  /* Next is sponsor (CEN syntax).  */
+	  cp[0] = '\0';
+	  sponsor = ++cp;
+
+	  while (cp[0] != '\0' && cp[0] != '_')
+	    ++cp;
+
+	  mask |= CEN_SPONSOR;
+	}
+
+      if (cp[0] == '_')
+	{
+ 	  /* Next is revision (CEN syntax).  */
+	  cp[0] = '\0';
+	  revision = ++cp;
+
+	  mask |= CEN_REVISION;
+	}
+    }
+
+  /* For CEN sytnax values it might be important to have the
+     separator character in the file name, not for XPG syntax.  */
+  if (syntax == xpg)
+    {
+      if (territory != NULL && territory[0] == '\0')
+	mask &= ~TERRITORY;
+
+      if (codeset != NULL && codeset[0] == '\0')
+	mask &= ~XPG_CODESET;
+
+      if (modifier != NULL && modifier[0] == '\0')
+	mask &= ~XPG_MODIFIER;
+    }
+
+  /* Create all possible locale entries which might be interested in
+     generalzation.  */
+  retval = make_entry_rec (dirname, mask, language, territory, codeset,
+			   modifier, special, sponsor, revision,
+			   domainname, 1);
+  if (retval == NULL)
+    /* This means we are out of core.  */
+    return NULL;
+
+  if (retval->decided == 0)
+    _nl_load_domain (retval);
+  if (retval->data == NULL)
+    {
+      int cnt;
+      for (cnt = 0; retval->successor[cnt] != NULL; ++cnt)
+	{
+	  if (retval->successor[cnt]->decided == 0)
+	    _nl_load_domain (retval->successor[cnt]);
+	  if (retval->successor[cnt]->data != NULL)
+	    break;
+
+	  /* Signal that locale is not available.  */
+	  retval->successor[cnt] = NULL;
+	}
+      if (retval->successor[cnt] == NULL)
+	retval = NULL;
+    }
+
+  /* The room for an alias was dynamically allocated.  Free it now.  */
+  if (alias_value != NULL)
+    free (locale);
+
+  return retval;
+}
+
+
+static struct loaded_domain *
+make_entry_rec (dirname, mask, language, territory, codeset, modifier,
+		special, sponsor, revision, domain, do_allocate)
+     const char *dirname;
+     int mask;
+     const char *language;
+     const char *territory;
+     const char *codeset;
+     const char *modifier;
+     const char *special;
+     const char *sponsor;
+     const char *revision;
+     const char *domain;
+     int do_allocate;
+{
+  char *filename = NULL;
+  struct loaded_domain *last = NULL;
+  struct loaded_domain *retval;
+  char *cp;
+  size_t entries;
+  int cnt;
+
+
+  /* Process the current entry described by the MASK only when it is
+     valid.  Because the mask can have in the first call bits from
+     both syntaces set this is necessary to prevent constructing
+     illegal local names.  */
+  /* FIXME: Rewrite because test is necessary only in first round.  */
+  if ((mask & CEN_SPECIFIC) == 0 || (mask & XPG_SPECIFIC) == 0)
+    {
+      /* Allocate room for the full file name.  */
+      filename = (char *) malloc (strlen (dirname) + 1
+				  + strlen (language)
+				  + ((mask & TERRITORY) != 0
+				     ? strlen (territory) : 0)
+				  + ((mask & XPG_CODESET) != 0
+				     ? strlen (codeset) : 0)
+				  + ((mask & XPG_MODIFIER) != 0 ?
+				     strlen (modifier) : 0)
+				  + ((mask & CEN_SPECIAL) != 0
+				     ? strlen (special) : 0)
+				  + ((mask & CEN_SPONSOR) != 0
+				     ? strlen (sponsor) : 0)
+				  + ((mask & CEN_REVISION) != 0
+				     ? strlen (revision) : 0) + 1
+				  + strlen (domain) + 1);
+
+      if (filename == NULL)
+	return NULL;
+
+      retval = NULL;
+      last = NULL;
+
+      /* Construct file name.  */
+      cp = stpcpy (filename, dirname);
+      *cp++ = '/';
+      cp = stpcpy (cp, language);
+
+      if ((mask & TERRITORY) != 0)
+	{
+	  *cp++ = '_';
+	  cp = stpcpy (cp, territory);
+	}
+      if ((mask & XPG_CODESET) != 0)
+	{
+	  *cp++ = '.';
+      cp = stpcpy (cp, codeset);
+	}
+      if ((mask & (XPG_MODIFIER | CEN_AUDIENCE)) != 0)
+	{
+	  /* This component can be part of both syntaces but has different
+	     leading characters.  For CEN we use `+', else `@'.  */
+	  *cp++ = (mask & CEN_AUDIENCE) != 0 ? '+' : '@';
+	  cp = stpcpy (cp, modifier);
+	}
+      if ((mask & CEN_SPECIAL) != 0)
+	{
+	  *cp++ = '+';
+	  cp = stpcpy (cp, special);
+	}
+      if ((mask & CEN_SPONSOR) != 0)
+	{
+	  *cp++ = ',';
+	  cp = stpcpy (cp, sponsor);
+	}
+      if ((mask & CEN_REVISION) != 0)
+	{
+	  *cp++ = '_';
+	  cp = stpcpy (cp, revision);
+	}
+
+      *cp++ = '/';
+      stpcpy (cp, domain);
+
+      /* Look in list of already loaded domains whether it is already
+	 available.  */
+      last = NULL;
+      for (retval = _nl_loaded_domains; retval != NULL; retval = retval->next)
+	if (retval->filename != NULL)
+	  {
+	    int compare = strcmp (retval->filename, filename);
+	    if (compare == 0)
+	      /* We found it!  */
+	      break;
+	    if (compare < 0)
+	      {
+		/* It's not in the list.  */
+		retval = NULL;
+		break;
+	      }
+
+	    last = retval;
+	  }
+
+      if (retval != NULL || do_allocate == 0)
+	{
+	  free (filename);
+	  return retval;
+	}
+    }
+
+  retval = (struct loaded_domain *) malloc (sizeof (*retval));
+  if (retval == NULL)
+    return NULL;
+
+  retval->filename = filename;
+  retval->decided = 0;
+
+  if (last == NULL)
+    {
+      retval->next = _nl_loaded_domains;
+      _nl_loaded_domains = retval;
+    }
+  else
+    {
+      retval->next = last->next;
+      last->next = retval;
+    }
+
+  entries = 0;
+  for (cnt = 126; cnt >= 0; --cnt)
+    if (cnt < mask && (cnt & ~mask) == 0
+	&& ((cnt & CEN_SPECIFIC) == 0 || (cnt & XPG_SPECIFIC) == 0))
+      retval->successor[entries++] = make_entry_rec (dirname, cnt,
+						     language, territory,
+						     codeset, modifier,
+						     special, sponsor,
+						     revision, domain, 1);
+  retval->successor[entries] = NULL;
+
+  return retval;
+}
+
+
+/* @@ begin of epilog @@ */
+
+/* We don't want libintl.a to depend on any other library.  So we
+   avoid the non-standard function stpcpy.  In GNU C Library this
+   function is available, though.  Also allow the symbol HAVE_STPCPY
+   to be defined.  */
+#if !_LIBC && !HAVE_STPCPY
+static char *
+stpcpy (dest, src)
+     char *dest;
+     const char *src;
+{
+  while ((*dest++ = *src++) != '\0')
+    /* Do nothing. */ ;
+  return dest - 1;
+}
+#endif
diff -urN g10-0.2.0/intl/gettext.c g10-0.2.1/intl/gettext.c
--- g10-0.2.0/intl/gettext.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/gettext.c	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,70 @@
+/* gettext.c -- implementation of gettext(3) function
+   Copyright (C) 1995 Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#ifdef _LIBC
+# define __need_NULL
+# include <stddef.h>
+#else
+# ifdef STDC_HEADERS
+#  include <stdlib.h>		/* Just for NULL.  */
+# else
+#  ifdef HAVE_STRING_H
+#   include <string.h>
+#  else
+#   define NULL ((void *) 0)
+#  endif
+# endif
+#endif
+
+#ifdef _LIBC
+# include <libintl.h>
+#else
+# include "libgettext.h"
+#endif
+
+/* @@ end of prolog @@ */
+
+/* Names for the libintl functions are a problem.  They must not clash
+   with existing names and they should follow ANSI C.  But this source
+   code is also used in GNU C Library where the names have a __
+   prefix.  So we have to make a difference here.  */
+#ifdef _LIBC
+# define GETTEXT __gettext
+# define DGETTEXT __dgettext
+#else
+# define GETTEXT gettext__
+# define DGETTEXT dgettext__
+#endif
+
+/* Look up MSGID in the current default message catalog for the current
+   LC_MESSAGES locale.  If not found, returns MSGID itself (the default
+   text).  */
+char *
+GETTEXT (msgid)
+     const char *msgid;
+{
+  return DGETTEXT (NULL, msgid);
+}
+
+#ifdef _LIBC
+/* Alias for function name in GNU C Library.  */
+weak_alias (__gettext, gettext);
+#endif
diff -urN g10-0.2.0/intl/gettext.h g10-0.2.1/intl/gettext.h
--- g10-0.2.0/intl/gettext.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/gettext.h	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,105 @@
+/* gettext.h - internal header for GNU gettext internationalization functions
+   Copyright (C) 1995 Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU Library General Public
+License along with the GNU C Library; see the file COPYING.LIB.  If
+not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#ifndef _GETTEXT_H
+#define _GETTEXT_H 1
+
+#include <stdio.h>
+
+#if HAVE_LIMITS_H || _LIBC
+# include <limits.h>
+#endif
+
+/* @@ end of prolog @@ */
+
+/* The magic number of the GNU message catalog format.  */
+#define _MAGIC 0x950412de
+#define _MAGIC_SWAPPED 0xde120495
+
+/* Revision number of the currently used .mo (binary) file format.  */
+#define MO_REVISION_NUMBER 0
+
+/* The following contortions are an attempt to use the C preprocessor
+   to determine an unsigned integral type that is 32 bits wide.  An
+   alternative approach is to use autoconf's AC_CHECK_SIZEOF macro, but
+   doing that would require that the configure script compile and *run*
+   the resulting executable.  Locally running cross-compiled executables
+   is usually not possible.  */
+
+#if __STDC__
+# define UINT_MAX_32_BITS 4294967295U
+#else
+# define UINT_MAX_32_BITS 0xFFFFFFFF
+#endif
+
+/* If UINT_MAX isn't defined, assume it's a 32-bit type.
+   This should be valid for all systems GNU cares about because
+   that doesn't include 16-bit systems, and only modern systems
+   (that certainly have <limits.h>) have 64+-bit integral types.  */
+
+#ifndef UINT_MAX
+# define UINT_MAX UINT_MAX_32_BITS
+#endif
+
+#if UINT_MAX == UINT_MAX_32_BITS
+typedef unsigned nls_uint32;
+#else
+# if USHRT_MAX == UINT_MAX_32_BITS
+typedef unsigned short nls_uint32;
+# else
+#  if ULONG_MAX == UINT_MAX_32_BITS
+typedef unsigned long nls_uint32;
+#  else
+  /* The following line is intended to throw an error.  Using #error is
+     not portable enough.  */
+  "Cannot determine unsigned 32-bit data type."
+#  endif
+# endif
+#endif
+
+
+/* Header for binary .mo file format.  */
+struct mo_file_header
+{
+  /* The magic number.  */
+  nls_uint32 magic;
+  /* The revision number of the file format.  */
+  nls_uint32 revision;
+  /* The number of strings pairs.  */
+  nls_uint32 nstrings;
+  /* Offset of table with start offsets of original strings.  */
+  nls_uint32 orig_tab_offset;
+  /* Offset of table with start offsets of translation strings.  */
+  nls_uint32 trans_tab_offset;
+  /* Size of hashing table.  */
+  nls_uint32 hash_tab_size;
+  /* Offset of first hashing entry.  */
+  nls_uint32 hash_tab_offset;
+};
+
+struct string_desc
+{
+  /* Length of addressed string.  */
+  nls_uint32 length;
+  /* Offset of string in file.  */
+  nls_uint32 offset;
+};
+
+/* @@ begin of epilog @@ */
+
+#endif	/* gettext.h  */
diff -urN g10-0.2.0/intl/gettextP.h g10-0.2.1/intl/gettextP.h
--- g10-0.2.0/intl/gettextP.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/gettextP.h	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,79 @@
+/* gettextP.h -- header describing internals of gettext library
+   Copyright (C) 1995 Free Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifndef _GETTEXTP_H
+#define _GETTEXTP_H
+
+/* @@ end of prolog @@ */
+
+#ifndef __P
+# if __STDC__
+#  define __P(args) args
+# else
+#  define __P(args) ()
+# endif
+#endif
+
+#ifndef W
+# define W(flag, data) ((flag) ? SWAP (data) : (data))
+#endif
+
+
+static nls_uint32 SWAP __P ((nls_uint32 i));
+
+static inline nls_uint32
+SWAP (i)
+     nls_uint32 i;
+{
+  return (i << 24) | ((i & 0xff00) << 8) | ((i >> 8) & 0xff00) | (i >> 24);
+}
+
+
+struct loaded_domain
+{
+  struct loaded_domain *next;
+  struct loaded_domain *successor[31];
+
+  const char *filename;
+  int decided;
+
+  const char *data;
+  int must_swap;
+  nls_uint32 nstrings;
+  struct string_desc *orig_tab;
+  struct string_desc *trans_tab;
+  nls_uint32 hash_size;
+  nls_uint32 *hash_tab;
+};
+
+struct binding
+{
+  struct binding *next;
+  char *domainname;
+  char *dirname;
+};
+
+struct loaded_domain *_nl_find_domain __P ((const char *__dirname,
+					    char *__locale,
+					    const char *__domainname));
+void _nl_load_domain __P ((struct loaded_domain *__domain));
+
+const char *_nl_expand_alias __P ((const char *__name));
+
+/* @@ begin of epilog @@ */
+
+#endif /* gettextP.h  */
diff -urN g10-0.2.0/intl/hash-string.h g10-0.2.1/intl/hash-string.h
--- g10-0.2.0/intl/hash-string.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/hash-string.h	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,62 @@
+/* hash-string - Implements a string hashing function.
+   Copyright (C) 1995 Free Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_VALUES_H
+# include <values.h>
+#endif
+
+/* @@ end of prolog @@ */
+
+#ifndef __P
+# if __STDC__
+#  define __P(Args) Args
+# else
+#  define __P(Args) ()
+# endif
+#endif
+
+/* We assume to have `unsigned long int' value with at least 32 bits.  */
+#define HASHWORDBITS 32
+
+
+/* Defines the so called `hashpjw' function by P.J. Weinberger
+   [see Aho/Sethi/Ullman, COMPILERS: Principles, Techniques and Tools,
+   1986, 1987 Bell Telephone Laboratories, Inc.]  */
+static unsigned long hash_string __P ((const char *__str_param));
+
+static inline unsigned long
+hash_string (str_param)
+     const char *str_param;
+{
+  unsigned long int hval, g;
+  const char *str = str_param;
+
+  /* Compute the hash value for the given string.  */
+  hval = 0;
+  while (*str != '\0')
+    {
+      hval <<= 4;
+      hval += (unsigned long) *str++;
+      g = hval & ((unsigned long) 0xf << (HASHWORDBITS - 4));
+      if (g != 0)
+	{
+	  hval ^= g >> (HASHWORDBITS - 8);
+	  hval ^= g;
+	}
+    }
+  return hval;
+}
diff -urN g10-0.2.0/intl/intl-compat.c g10-0.2.1/intl/intl-compat.c
--- g10-0.2.0/intl/intl-compat.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/intl-compat.c	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,76 @@
+/* intl-compat.c - Stub functions to call gettext functions from GNU gettext
+   Library.
+   Copyright (C) 1995 Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#include "libgettext.h"
+
+/* @@ end of prolog @@ */
+
+
+#undef gettext
+#undef dgettext
+#undef dcgettext
+#undef textdomain
+#undef bindtextdomain
+
+
+char *
+bindtextdomain (domainname, dirname)
+     const char *domainname;
+     const char *dirname;
+{
+  return bindtextdomain__ (domainname, dirname);
+}
+
+
+char *
+dcgettext (domainname, msgid, category)
+     const char *domainname;
+     const char *msgid;
+     int category;
+{
+  return dcgettext__ (domainname, msgid, category);
+}
+
+
+char *
+dgettext (domainname, msgid)
+     const char *domainname;
+     const char *msgid;
+{
+  return dgettext__ (domainname, msgid);
+}
+
+
+char *
+gettext (msgid)
+     const char *msgid;
+{
+  return gettext__ (msgid);
+}
+
+
+char *
+textdomain (domainname)
+     const char *domainname;
+{
+  return textdomain__ (domainname);
+}
diff -urN g10-0.2.0/intl/libgettext.h g10-0.2.1/intl/libgettext.h
--- g10-0.2.0/intl/libgettext.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/libgettext.h	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,177 @@
+/* libgettext.h -- Message catalogs for internationalization.
+   Copyright (C) 1995 Free Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+/* Because on some systems (e.g. Solaris) we sometimes have to include
+   the systems libintl.h as well as this file we have more complex
+   include protection above.  But the systems header might perhaps also
+   define _LIBINTL_H and therefore we have to protect the definition here.  */
+
+#if !defined (_LIBINTL_H) || !defined (_LIBGETTEXT_H)
+#if !_LIBINTL_H
+# define _LIBINTL_H	1
+#endif
+#define _LIBGETTEXT_H	1
+
+/* We define an additional symbol to signal that we use the GNU
+   implementation of gettext.  */
+#define __USE_GNU_GETTEXT 1
+
+#include <sys/types.h>
+
+#if HAVE_LOCALE_H
+# include <locale.h>
+#endif
+
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/* @@ end of prolog @@ */
+
+#ifndef __P
+# if __STDC__
+#  define __P(args) args
+# else
+#  define __P(args) ()
+# endif
+#endif
+
+#ifndef NULL
+# if !defined __cplusplus || defined __GNUC__
+#  define NULL ((void *) 0)
+# else
+#  define NULL (0)
+# endif
+#endif
+
+#if !HAVE_LC_MESSAGES
+/* This value determines the behaviour of the gettext() and dgettext()
+   function.  But some system does not have this defined.  Define it
+   to a default value.  */
+# define LC_MESSAGES (-1)
+#endif
+
+
+/* Declarations for gettext-using-catgets interface.  Derived from
+   Jim Meyering's libintl.h.  */
+struct _msg_ent
+{
+  const char *_msg;
+  int _msg_number;
+};
+
+
+#if HAVE_CATGETS
+/* These two variables are defined in the automatically by po-to-tbl.sed
+   generated file `cat-id-tbl.c'.  */
+extern const struct _msg_ent _msg_tbl[];
+extern int _msg_tbl_length;
+#endif
+
+
+/* For automatical extraction of messages sometimes no real
+   translation is needed.  Instead the string itself is the result.  */
+#define gettext_noop(Str) (Str)
+
+/* Look up MSGID in the current default message catalog for the current
+   LC_MESSAGES locale.  If not found, returns MSGID itself (the default
+   text).  */
+extern char *gettext __P ((const char *__msgid));
+extern char *gettext__ __P ((const char *__msgid));
+
+/* Look up MSGID in the DOMAINNAME message catalog for the current
+   LC_MESSAGES locale.  */
+extern char *dgettext __P ((const char *__domainname, const char *__msgid));
+extern char *dgettext__ __P ((const char *__domainname, const char *__msgid));
+
+/* Look up MSGID in the DOMAINNAME message catalog for the current CATEGORY
+   locale.  */
+extern char *dcgettext __P ((const char *__domainname, const char *__msgid,
+			     int __category));
+extern char *dcgettext__ __P ((const char *__domainname, const char *__msgid,
+			       int __category));
+
+
+/* Set the current default message catalog to DOMAINNAME.
+   If DOMAINNAME is null, return the current default.
+   If DOMAINNAME is "", reset to the default of "messages".  */
+extern char *textdomain __P ((const char *__domainname));
+extern char *textdomain__ __P ((const char *__domainname));
+
+/* Specify that the DOMAINNAME message catalog will be found
+   in DIRNAME rather than in the system locale data base.  */
+extern char *bindtextdomain __P ((const char *__domainname,
+				  const char *__dirname));
+extern char *bindtextdomain__ __P ((const char *__domainname,
+				    const char *__dirname));
+
+#if ENABLE_NLS
+
+/* Solaris 2.3 has the gettext function but dcgettext is missing.
+   So we omit this optimization for Solaris 2.3.  BTW, Solaris 2.4
+   has dcgettext.  */
+# if !HAVE_CATGETS && (!HAVE_GETTEXT || HAVE_DCGETTEXT)
+
+#  define gettext(Msgid) \
+     dgettext (NULL, Msgid)
+
+#  define dgettext(Domainname, Msgid) \
+     dcgettext (Domainname, Msgid, LC_MESSAGES)
+
+#  if defined __GNUC__ && __GNUC__ == 2 && __GNUC_MINOR__ >= 7
+#   define dcgettext(Domainname, Msgid, Category) \
+  (__extension__							      \
+   ({									      \
+     char *result;							      \
+     if (__builtin_constant_p (Msgid))					      \
+       {								      \
+	 extern int _nl_msg_cat_cntr;					      \
+	 static char *__translation__;					      \
+	 static int __catalog_counter__;				      \
+	 if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr)    \
+	   {								      \
+	     __translation__ =						      \
+	       dcgettext__ ((Domainname), (Msgid), (Category));		      \
+	     __catalog_counter__ = _nl_msg_cat_cntr;			      \
+	   }								      \
+	 result = __translation__;					      \
+       }								      \
+     else								      \
+       result = dcgettext__ ((Domainname), (Msgid), (Category));	      \
+     result;								      \
+    }))
+#  endif
+# endif
+
+#else
+
+# define gettext(Msgid) (Msgid)
+# define dgettext(Domainname, Msgid) (Msgid)
+# define dcgettext(Domainname, Msgid, Category) (Msgid)
+# define textdomain(Domainname) while (0) /* nothing */
+# define bindtextdomain(Domainname, Dirname) while (0) /* nothing */
+
+#endif
+
+/* @@ begin of epilog @@ */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff -urN g10-0.2.0/intl/linux-msg.sed g10-0.2.1/intl/linux-msg.sed
--- g10-0.2.0/intl/linux-msg.sed	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/linux-msg.sed	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,100 @@
+# po2msg.sed - Convert Uniforum style .po file to Linux style .msg file
+# Copyright (C) 1995 Free Software Foundation, Inc.
+# Ulrich Drepper <drepper@gnu.ai.mit.edu>, 1995.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+#
+#
+# The first directive in the .msg should be the definition of the
+# message set number.  We use always set number 1.
+#
+1 {
+  i\
+$set 1 # Automatically created by po2msg.sed
+  h
+  s/.*/0/
+  x
+}
+#
+# Mitch's old catalog format does not allow comments.
+#
+# We copy the original message as a comment into the .msg file.
+#
+/^msgid/ {
+  s/msgid[ 	]*"//
+#
+# This does not work now with the new format.
+# /"$/! {
+#   s/\\$//
+#   s/$/ ... (more lines following)"/
+# }
+  x
+# The following nice solution is by
+# Bruno <Haible@ma2s2.mathematik.uni-karlsruhe.de>
+  td
+# Increment a decimal number in pattern space.
+# First hide trailing `9' digits.
+  :d
+  s/9\(_*\)$/_\1/
+  td
+# Assure at least one digit is available.
+  s/^\(_*\)$/0\1/
+# Increment the last digit.
+  s/8\(_*\)$/9\1/
+  s/7\(_*\)$/8\1/
+  s/6\(_*\)$/7\1/
+  s/5\(_*\)$/6\1/
+  s/4\(_*\)$/5\1/
+  s/3\(_*\)$/4\1/
+  s/2\(_*\)$/3\1/
+  s/1\(_*\)$/2\1/
+  s/0\(_*\)$/1\1/
+# Convert the hidden `9' digits to `0's.
+  s/_/0/g
+  x
+  G
+  s/\(.*\)"\n\([0-9]*\)/$ #\2 Original Message:(\1)/p
+}
+#
+# The .msg file contains, other then the .po file, only the translations
+# but each given a unique ID.  Starting from 1 and incrementing by 1 for
+# each message we assign them to the messages.
+# It is important that the .po file used to generate the cat-id-tbl.c file
+# (with po-to-tbl) is the same as the one used here.  (At least the order
+# of declarations must not be changed.)
+#
+/^msgstr/ {
+  s/msgstr[ 	]*"\(.*\)"/# \1/
+# Clear substitution flag.
+  tb
+# Append the next line.
+  :b
+  N
+# Look whether second part is continuation line.
+  s/\(.*\n\)"\(.*\)"/\1\2/
+# Yes, then branch.
+  ta
+  P
+  D
+# Note that D includes a jump to the start!!
+# We found a continuation line.  But before printing insert '\'.
+  :a
+  s/\(.*\)\(\n.*\)/\1\\\2/
+  P
+# We cannot use D here.
+  s/.*\n\(.*\)/\1/
+  tb
+}
+d


diff -urN g10-0.2.0/ABOUT-NLS g10-0.2.1/ABOUT-NLS
--- g10-0.2.0/ABOUT-NLS	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/ABOUT-NLS	Mon Sep 22 11:25:50 1997
@@ -0,0 +1,203 @@
+Notes on the GNU Translation Project
+************************************
+
+   GNU is going international!  The GNU Translation Project is a way to
+get maintainers, translators and users all together, so GNU will
+gradually become able to speak many native languages.  A few packages
+already provide native language translation for their messages.
+
+   If you found this `ABOUT-NLS' file inside a GNU distribution, you
+may assume that the distributed package does use GNU `gettext'
+internally, itself available at your nearest GNU archive site.  But you
+do not need to install GNU `gettext' prior to configuring, installing
+or using this package with messages translated.
+
+   Installers will find here some useful hints.  These notes also
+explain how users should proceed for getting the programs to use the
+available translations.  They tell how people wanting to contribute and
+work at translations should contact the appropriate team.
+
+   When reporting bugs in the `intl/' directory or bugs which may be
+related to internationalization, you should tell about the version of
+`gettext' which is used.  The information can be found in the
+`intl/VERSION' file, in internationalized packages.
+
+One advise in advance
+=====================
+
+   If you want to exploit the full power of the GNU `gettext' package
+you should configure it using
+
+             --with-gnu-gettext.
+
+   No existing implementation at this point provides so many useful
+features (such as locale alias or message inheritance).  It is also not
+possible to provide this additional functionality on top of a catgets
+implementation.
+
+   Future versions of GNU `gettext' will very likely provide even more
+functionality.  So it might be a good idea to change to GNU `gettext'
+as soon as possible.
+
+INSTALL Matters
+===============
+
+   Some GNU packages are "localizable" when properly installed; the
+programs they contain can be made to speak your own native language.
+Most such packages use GNU `gettext'.  Other packages have their own
+ways to internationalization, predating GNU `gettext'.
+
+   By default, this package will be installed to allow translation of
+messages.  It will automatically detect whether the system provides
+usable `catgets' or `gettext' functions.  If neither is available, the
+GNU `gettext' own library will be used.  However, installers may use
+special options at configuration time for changing this behaviour.  The
+commands:
+
+     ./configure --with-gnu-gettext
+     ./configure --disable-nls
+
+will respectively bypass system `catgets' or `gettext' to use GNU
+`gettext', or else, totally disable translation of messages.
+
+   When you already have GNU `gettext' installed on your system and run
+configure without an option for your new package, configure will
+probably detect the previously built and installed `libintl.a' file and
+will decide to use this.  This might be not what is desirable.  You
+should use the more recent version of the GNU `gettext' library.  I.e.
+if the file `intl/VERSION' shows that the library which comes with this
+package is more recent, you should use
+
+     ./configure --with-gnu-gettext
+
+to prevent auto-detection.
+
+   Internationalized packages have usually many `po/LL.po' files, where
+LL gives an ISO 639 two-letter code identifying the language.  Unless
+translations are disabled, all those available are installed together
+with the package.  However, the environment variable `LINGUAS' may be
+set, prior to configuration, to limit the installed set.  `LINGUAS'
+should then contain a space separated list of two-letter codes, stating
+which languages are allowed.
+
+Using This Package
+==================
+
+   As a user, if your language has been installed for this package, you
+only have to set the `LANG' environment variable to the appropriate
+ISO 639 `LL' two-letter code prior to using the programs in the
+package.  For example, let's suppose that you speak German.  At the
+shell prompt, merely execute `setenv LANG de' (in `csh') or
+`export LANG; LANG=de' (in `sh').  This can be done from your `.login'
+or `.profile' file, once and for all.  Packages which are not
+internationalized will merely ignore the setting of this variable.
+
+Translating Teams
+=================
+
+   The GNU `gettext' tool set contains *everything* maintainers need
+for internationalizing their packages for messages.  It also contains
+quite useful tools for helping translators at localizing messages to
+their native language, once a package has already been
+internationalized.
+
+   To achieve the GNU Translation Project, we need many interested
+people who like their own language and write it well, and who are also
+able to synergize with other translators speaking the same language.
+Each translating team has its own mailing list, courtesy of Linux
+International.  You may reach your translating team at the address
+`LL@li.org', replacing LL by the two-letter ISO 639 code for your
+language.  Language codes are *not* the same as country codes given in
+ISO 3166.  The following translating teams exist, as of November 1995:
+
+     Chinese `zh', Czech `cs', Danish `da', Dutch `nl', English `en',
+     Esperanto `eo', Finnish `fi', French `fr', Irish `ga', German
+     `de', Greek `el', Italian `it', Japanese `ja', Indonesian `in',
+     Norwegian `no', Persian `fa', Polish `pl', Portuguese `pt',
+     Russian `ru', Spanish `es', Swedish `sv', Telugu `te' and Turkish
+     `tr'.
+
+For example, you may reach the Chinese translating team by writing to
+`zh@li.org'.
+
+   If you'd like to volunteer to *work* at translating messages, you
+should become a member of the translating team for your own language.
+The subscribing address is *not* the same as the list itself, it has
+`-request' appended.  For example, Swedish people can send a message to
+`sv-request@li.org', having this message body:
+
+     subscribe
+
+   Keep in mind that team members should be interested in *working* at
+translations, or at solving translational difficulties, rather than
+merely lurking around.  If your team does not exist yet and you want to
+start one, please write to `gnu-translation@prep.ai.mit.edu'; you will
+then reach the GNU coordinator for all translator teams.
+
+   The English team is special.  It works at improving and uniformizing
+the terminology used in GNU.  Proven linguistic skill are praised more
+than programming skill, here.  For the time being, please avoid
+subscribing to the English team unless explicitely invited to do so.
+
+Available Packages
+==================
+
+   Languages are not equally supported in all GNU packages.  The
+following matrix shows the current state of GNU internationalization,
+as of November 1995.  Listed are: internationalized packages, and
+languages for which work is in progress, or about to start.
+
+          See note    cs de en fr it ja nl no pt sv
+                \   .-------------------------------.
+     chess      (1) |    X  /                    X  |
+     clisp          |    X  X  X                    |
+     diffutils  (2) |       /  .                    |
+     fileutils      |    .  /                       |
+     flex       (3) |       /  .                    |
+     m4             |    -  /  -  -  .           -  |
+     gettext        |    X  /  X           X     X  |
+     ptx            |    -  /  -                 -  |
+     recode         |    -  /  -        -     -     |
+     sh-utils       |    .  /  .                    |
+     sharutils      |    X  /  X     X  X     X  X  |
+     tar            |    X  /  X           -  X  X  |
+     textutils      |    .  /  .                    |
+     wdiff          | -  -  /  -  -                 |
+                    `-------------------------------'
+                      cs de en fr it ja nl no pt sv
+
+   The interpretation legend and notes are:
+
+`/'
+     There is no PO file, this package merely defaults to this language.
+
+`.'
+     The effort of localizing this package has been undertaken by
+     someone, or by a translating team, and work is, or should be in
+     progress.
+
+`-'
+     A PO file for this package and this language is completed and is
+     currently available in a pretest release, or is all ready for
+     inclusion in the next release of this package.
+
+`X'
+     The localization of this package to this particular language is
+     fully completed, and now distributed through an official release.
+
+(1)
+     This package is translated to specific languages by methods
+     predating GNU `gettext'.  Translations are all kept on disk files,
+     and sources contain numbers where one normally expects strings.
+
+(2)
+     This package is planned to switch to GNU `gettext'.  For the time
+     being, it uses temporary means for internationalization.
+
+(3)
+     This package has its translatable strings marked, but does not use
+     GNU `gettext'.  A convenience patch may be available separately.
+
+   If November 1995 seems to be old, you may fetch a more recent copy
+of this `ABOUT-NLS' file on most GNU archive sites.
+
diff -urN g10-0.2.0/Makefile.am g10-0.2.1/Makefile.am
--- g10-0.2.0/Makefile.am	Wed Jan  7 11:26:15 1998
+++ g10-0.2.1/Makefile.am	Tue Jan 27 15:55:42 1998
@@ -1,6 +1,6 @@
 ## Process this file with automake to produce Makefile.in
 
-SUBDIRS =  util mpi cipher tools g10
+SUBDIRS =  @INTLSUB@ @POSUB@ util mpi cipher tools g10
 EXTRA_DIST = VERSION
 
 
diff -urN g10-0.2.0/Makefile.in g10-0.2.1/Makefile.in
--- g10-0.2.0/Makefile.in	Sun Jan 25 20:22:12 1998
+++ g10-0.2.1/Makefile.in	Wed Jan 28 16:36:56 1998
@@ -38,15 +38,16 @@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 transform = @program_transform_name@
 
-SUBDIRS =  util mpi cipher tools g10
+SUBDIRS =  @INTLSUB@ @POSUB@ util mpi cipher tools g10
 EXTRA_DIST = VERSION
+ACLOCAL = aclocal.m4
 ACCONFIG = acconfig.h
 CONFIG_HEADER_IN = config.h.in
 mkinstalldirs = $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ./config.h
-DIST_COMMON = README AUTHORS COPYING ChangeLog INSTALL Makefile.am \
-Makefile.in NEWS README TODO acconfig.h config.h.in configure \
-configure.in stamp-h.in
+DIST_COMMON = README ABOUT-NLS AUTHORS COPYING ChangeLog INSTALL \
+Makefile.am Makefile.in NEWS README TODO acconfig.h aclocal.m4 \
+config.h.in configure configure.in stamp-h.in
 
 
 PACKAGE = @PACKAGE@
diff -urN g10-0.2.0/NEWS g10-0.2.1/NEWS
--- g10-0.2.0/NEWS	Sun Jan 25 19:55:35 1998
+++ g10-0.2.1/NEWS	Wed Jan 28 15:33:37 1998
@@ -1,4 +1,12 @@
 
+    * We have secure memeory on systems which support mlock().
+      It is not complete yet, because we do not have signal handler
+      which does a cleanup in very case.
+      We should also check the ulimit for the user in the case
+      that the admin does not have set a limit on locked pages.
+
+    * started with internationalization support.
+
     * The logic to handle the web of trust is now implemented. It is
       has some bugs; but I'm going to change the algorithm anyway.
       It works by calculating the trustlevel on the fly.  It may ask
@@ -14,12 +22,10 @@
 
     * Read support for new version packets (OpenPGP).
 
-    * Comment packets are now of coorect OpenPGP type 16. Old comment
-      packets writen by G10 are detected because they always start with
+    * Comment packets are now of correct OpenPGP type 16. Old comment
+      packets written by G10 are detected because they always start with
       a hash which is an invalid version byte.
 
     * The string "(INSECURE!)" is appended to a new user-id if this
       is generated on a system without a good random number generator.
-
-    * works (more or less) on a UltraPenguin (sparc64--gnu-linux)
 
diff -urN g10-0.2.0/README g10-0.2.1/README
--- g10-0.2.0/README	Sun Jan 25 19:49:46 1998
+++ g10-0.2.1/README	Wed Jan 28 15:32:35 1998
@@ -10,6 +10,9 @@
 
     * Some features are not yet implemented
 
+    PLEASE USE "--no-armor" BECAUSE THERE IS STILL A BUG IN IT!
+    (put it into the option file)
+
 
     Please subscribe to g10@net.lut.ac.uk by sending a mail with
     the word "subscribe" in the body to "g10-request@net.lut.ac.uk".
@@ -158,6 +161,59 @@
 	g10 -se -r heine -u Suttner file
 
     Ditto, but sign the file with the user id "Suttner"
+
+
+    How to Specify a UserID
+    -----------------------
+    There are several ways to specify a userID, here are some examples:
+
+    * Only by the short keyid (prepend a zero if it start with A..F):
+
+	"234567C4"
+	"0F34E556E"
+	"01347A56A"
+
+    * By a complete keyid:
+
+	"234AABBCC34567C4"
+	"0F323456784E56EAB"
+	"01AB3FED1347A5612"
+
+    * By a fingerprint (not yet implemented):
+
+	"1234343434343434C434343434343434"
+	"123434343434343C3434343434343734349A3434"
+	"0E12343434343434343434EAB3484343434343434"
+
+      The first one is MD5 the others are ripemd160 or sha1.
+
+    * By an exact string (not yet implemented):
+
+	"=Heinrich Heine <heinrichh@uni-duesseldorf.de>"
+
+    * By an email address:
+
+	"<heinrichh@uni-duesseldorf.de>"
+
+      This can be used by a keyserver instead of a substring to
+      find this key faster.
+
+    * By the Local ID (from the trustdb):
+
+	"#34"
+
+      This can be used by a MUA to specify an exact key after selecting
+      a key from G10 (by the use of a special option or an extra utility)
+
+
+    * Or by the usual substring:
+
+	"Heine"
+	"*Heine"
+
+      The '*' indicates substring search explicitly.
+
+
 
 
     Batch mode
diff -urN g10-0.2.0/TODO g10-0.2.1/TODO
--- g10-0.2.0/TODO	Sun Jan 25 19:16:20 1998
+++ g10-0.2.1/TODO	Wed Jan 28 15:31:12 1998
@@ -5,9 +5,7 @@
     * add a way to difference between errors and eof in the underflow/flush
       function of iobuf.
     * check that all output is filtered when displayed.
-    * add trust stuff
     * add checking of armor trailers
-    * add real secure memory
     * look for a way to reuse RSA signatures
     * remove all "Fixmes"
     * speed up the RIPE-MD-160
@@ -25,21 +23,13 @@
     * complete cipher/cast.c
     * complete cipher/dsa.c
 
-    * define a standard way to specify keyid/userid and other stuff
-      to identify a user.  We could look at the first character and
-      say: If it's a digit, a keyid follows (need to add a zero in
-      case the keyid starts with A..F); if it is a left angle bracket,
-      this is a email address and should be used, all others are substrings
-      of the userid.
-      [can be handles in get_pubkey_by_name()]
-
     * armor has now some problems.
 
     * add g10 stuff to Mutt's pgpinvoke.c
 
     * Burn the buffers used by fopen().
 
-    * bug: g10/trustdb.c#build_sigrecs caled to often by do_list_path
+    * bug: g10/trustdb.c#build_sigrecs called to often by do_list_path
       and remove the bad kludge. Maybe we should put all sigs into the trustdb
       and mark them as valid/invalid/nopubkey, and how do we check, that
       we have a self-signature -> put this stuff into a kind of directory
diff -urN g10-0.2.0/acconfig.h g10-0.2.1/acconfig.h
--- g10-0.2.0/acconfig.h	Thu Jan 22 18:44:33 1998
+++ g10-0.2.1/acconfig.h	Mon Jan 26 20:32:14 1998
@@ -26,6 +26,22 @@
 #undef M_DEBUG
 #undef VERSION
 #undef PACKAGE
+#undef G10_LOCALEDIR
+
+/* Define if your locale.h file contains LC_MESSAGES.  */
+#undef HAVE_LC_MESSAGES
+
+/* Define to 1 if NLS is requested.  */
+#undef ENABLE_NLS
+
+/* Define as 1 if you have catgets and don't want to use GNU gettext.  */
+#undef HAVE_CATGETS
+
+/* Define as 1 if you have gettext and don't want to use GNU gettext.  */
+#undef HAVE_GETTEXT
+
+#undef HAVE_STPCPY
+
 
 #undef BIG_ENDIAN_HOST
 #undef LITTLE_ENDIAN_HOST
diff -urN g10-0.2.0/aclocal.m4 g10-0.2.1/aclocal.m4
--- g10-0.2.0/aclocal.m4	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/aclocal.m4	Wed Jan 28 09:46:30 1998
@@ -0,0 +1,357 @@
+dnl aclocal.m4	for g10
+
+AC_PREREQ(2.5)
+
+dnl --------------------------------------------------
+dnl NLS stuff taken from gettext-0.10 (wk 28.01.98)
+dnl --------------------------------------------------
+AC_DEFUN(md_TYPE_PTRDIFF_T,
+  [AC_CACHE_CHECK([for ptrdiff_t], ac_cv_type_ptrdiff_t,
+     [AC_TRY_COMPILE(stddef.h, [ptrdiff_t p], ac_cv_type_ptrdiff_t=yes,
+		     ac_cv_type_ptrdiff_t=no)])
+   if test $ac_cv_type_ptrdiff_t = yes; then
+     AC_DEFINE(HAVE_PTRDIFF_T)
+   fi
+])
+
+AC_DEFUN(md_PATH_PROG,
+  [AC_PATH_PROG($1,$2,$3)dnl
+   if echo $$1 | grep openwin > /dev/null; then
+     echo "WARNING: Do not use OpenWin's $2.  (Better remove it.) >&AC_FD_MSG"
+     ac_cv_path_$1=$2
+     $1=$2
+   fi
+])
+
+
+dnl --------------------------------------------------------- ##
+dnl Use AC_PROG_INSTALL, supplementing it with INSTALL_SCRIPT ##
+dnl substitution.					      ##
+dnl --------------------------------------------------------- ##
+
+AC_DEFUN(fp_PROG_INSTALL,
+[AC_PROG_INSTALL
+test -z "$INSTALL_SCRIPT" && INSTALL_SCRIPT='${INSTALL} -m 755'
+AC_SUBST(INSTALL_SCRIPT)dnl
+])
+
+dnl Check NLS options
+
+AC_DEFUN(ud_LC_MESSAGES,
+  [if test $ac_cv_header_locale_h = yes; then
+    AC_CACHE_CHECK([for LC_MESSAGES], ud_cv_val_LC_MESSAGES,
+      [AC_TRY_LINK([#include <locale.h>], [return LC_MESSAGES],
+       ud_cv_val_LC_MESSAGES=yes, ud_cv_val_LC_MESSAGES=no)])
+    if test $ud_cv_val_LC_MESSAGES = yes; then
+      AC_DEFINE(HAVE_LC_MESSAGES)
+    fi
+  fi])
+
+AC_DEFUN(ud_WITH_NLS,
+  [AC_MSG_CHECKING([whether NLS is requested])
+    dnl Default is enabled NLS
+    AC_ARG_ENABLE(nls,
+      [  --disable-nls		 do not use Native Language Support],
+      nls_cv_use_nls=$enableval, nls_cv_use_nls=yes)
+    AC_MSG_RESULT($nls_cv_use_nls)
+
+    dnl If we use NLS figure out what method
+    if test "$nls_cv_use_nls" = "yes"; then
+      AC_DEFINE(ENABLE_NLS)
+      AC_MSG_CHECKING([for explicitly using GNU gettext])
+      AC_ARG_WITH(gnu-gettext,
+	[  --with-gnu-gettext	   use the GNU gettext library],
+	nls_cv_force_use_gnu_gettext=$withval,
+	nls_cv_force_use_gnu_gettext=no)
+      AC_MSG_RESULT($nls_cv_force_use_gnu_gettext)
+
+      if test "$nls_cv_force_use_gnu_gettext" = "yes"; then
+	nls_cv_use_gnu_gettext=yes
+      else
+	dnl User does not insist on using GNU NLS library.  Figure out what
+	dnl to use.  If gettext or catgets are available (in this order) we
+	dnl use this.  Else we have to fall back to GNU NLS library.
+	AC_CHECK_LIB(intl, main)
+	AC_CHECK_LIB(i, main)
+	CATOBJEXT=NONE
+	AC_CHECK_FUNC(gettext,
+	  [AC_DEFINE(HAVE_GETTEXT)
+	   md_PATH_PROG(MSGFMT, msgfmt, no)dnl
+	   if test "$MSGFMT" != "no"; then
+	     AC_CHECK_FUNCS(dcgettext)
+	     md_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
+	     md_PATH_PROG(XGETTEXT, xgettext, xgettext)
+	     CATOBJEXT=.mo
+	     INSTOBJEXT=.mo
+	     DATADIRNAME=lib
+	   fi])
+
+	if test "$CATOBJEXT" = "NONE"; then
+	  dnl No gettext in C library.	Try catgets next.
+	  AC_CHECK_FUNC(catgets,
+	    [AC_DEFINE(HAVE_CATGETS)
+	     INTLOBJS="\$(CATOBJS)"
+	     AC_PATH_PROG(GENCAT, gencat, no)dnl
+	     if test "$GENCAT" != "no"; then
+	       AC_PATH_PROGS(GMSGFMT, [gmsgfmt msgfmt], msgfmt)
+	       md_PATH_PROG(XGETTEXT, xgettext, xgettext)
+	       CATOBJEXT=.cat
+	       INSTOBJEXT=.cat
+	       DATADIRNAME=lib
+	       INTLDEPS="../intl/libintl.a"
+	       INTLLIBS=$INTLDEPS
+	       LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+	       nls_cv_header_intl=intl/libintl.h
+	       nls_cv_header_libgt=intl/libgettext.h
+	     fi])
+	fi
+
+	if test "$CATOBJEXT" = "NONE"; then
+	  dnl Neither gettext nor catgets in included in the C library.
+	  dnl Fall back on GNU gettext library.
+	  nls_cv_use_gnu_gettext=yes
+	fi
+      fi
+
+      if test "$nls_cv_use_gnu_gettext" = "yes"; then
+	dnl Mark actions used to generate GNU NLS library.
+	INTLOBJS="\$(GETTOBJS)"
+	md_PATH_PROG(MSGFMT, msgfmt, msgfmt)
+	md_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
+	md_PATH_PROG(XGETTEXT, xgettext, xgettext)
+	AC_SUBST(MSGFMT)
+	CATOBJEXT=.gmo
+	INSTOBJEXT=.mo
+	DATADIRNAME=share
+	INTLDEPS="../intl/libintl.a"
+	INTLLIBS=$INTLDEPS
+	LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+	nls_cv_header_intl=intl/libintl.h
+	nls_cv_header_libgt=intl/libgettext.h
+      fi
+
+      # We need to process the intl/ and po/ directory.
+      INTLSUB=intl
+      POSUB=po
+    else
+      DATADIRNAME=share
+      nls_cv_header_intl=intl/libintl.h
+      nls_cv_header_libgt=intl/libgettext.h
+    fi
+
+    dnl These rules are solely for the distribution goal.  While doing this
+    dnl we only have to keep exactly one list of the available catalogs
+    dnl in configure.in.
+    for lang in $ALL_LINGUAS; do
+      GMOFILES="$GMOFILES $lang.gmo"
+      POFILES="$POFILES $lang.po"
+    done
+
+    dnl Make all variables we use known to autoconf.
+    AC_SUBST(CATALOGS)
+    AC_SUBST(CATOBJEXT)
+    AC_SUBST(DATADIRNAME)
+    AC_SUBST(GMOFILES)
+    AC_SUBST(INSTOBJEXT)
+    AC_SUBST(INTLDEPS)
+    AC_SUBST(INTLLIBS)
+    AC_SUBST(INTLOBJS)
+    AC_SUBST(INTLSUB)
+    AC_SUBST(POFILES)
+    AC_SUBST(POSUB)
+  ])
+
+AC_DEFUN(ud_GNU_GETTEXT,
+  [AC_REQUIRE([AC_PROG_MAKE_SET])dnl
+   AC_REQUIRE([AC_PROG_CC])dnl
+   AC_REQUIRE([AC_PROG_RANLIB])dnl
+   AC_REQUIRE([AC_HEADER_STDC])dnl
+   AC_REQUIRE([AC_C_CONST])dnl
+   AC_REQUIRE([AC_C_INLINE])dnl
+   AC_REQUIRE([AC_TYPE_OFF_T])dnl
+   AC_REQUIRE([AC_TYPE_SIZE_T])dnl
+   AC_REQUIRE([AC_FUNC_ALLOCA])dnl
+   AC_REQUIRE([AC_FUNC_MMAP])dnl
+
+   AC_CHECK_HEADERS([limits.h locale.h nl_types.h malloc.h string.h unistd.h values.h])
+   AC_CHECK_FUNCS([getcwd munmap putenv setenv setlocale strchr strcasecmp])
+
+   if test "${ac_cv_func_stpcpy+set}" != "set"; then
+     AC_CHECK_FUNCS(stpcpy)
+   fi
+   if test "${ac_cv_func_stpcpy}" = "yes"; then
+     AC_DEFINE(HAVE_STPCPY)
+   fi
+
+   ud_LC_MESSAGES
+   ud_WITH_NLS
+
+   if test "x$CATOBJEXT" != "x"; then
+     if test "x$ALL_LINGUAS" = "x"; then
+       LINGUAS=
+     else
+       AC_MSG_CHECKING(for catalogs to be installed)
+       NEW_LINGUAS=
+       for lang in ${LINGUAS=$ALL_LINGUAS}; do
+	 case "$ALL_LINGUAS" in
+	  *$lang*) NEW_LINGUAS="$NEW_LINGUAS $lang" ;;
+	 esac
+       done
+       LINGUAS=$NEW_LINGUAS
+       AC_MSG_RESULT($LINGUAS)
+     fi
+
+     dnl Construct list of names of catalog files to be constructed.
+     if test -n "$LINGUAS"; then
+       for lang in $LINGUAS; do CATALOGS="$CATALOGS $lang$CATOBJEXT"; done
+     fi
+   fi
+
+   dnl Determine which catalog format we have (if any is needed)
+   dnl For now we know about two different formats:
+   dnl	 Linux and the normal X/Open format
+   test -d intl || mkdir intl
+   if test "$CATOBJEXT" = ".cat"; then
+     AC_CHECK_HEADER(linux/version.h, msgformat=linux, msgformat=xopen)
+
+     dnl Transform the SED scripts while copying because some dumb SEDs
+     dnl cannot handle comments.
+     sed -e '/^#/d' $srcdir/intl/$msgformat-msg.sed > intl/po2msg.sed
+   fi
+   dnl po2tbl.sed is always needed.
+   sed -e '/^#.*[^\\]$/d' -e '/^#$/d' \
+     $srcdir/intl/po2tbl.sed.in > intl/po2tbl.sed
+
+   dnl Generate list of files to be processed by xgettext which will
+   dnl be included in po/Makefile.
+   test -d po || mkdir po
+   if test "x$srcdir" != "x."; then
+     if test "x`echo $srcdir | sed 's@/.*@@'`" = "x"; then
+       posrcprefix="$srcdir/"
+     else
+       posrcprefix="../$srcdir/"
+     fi
+   else
+     posrcprefix="../"
+   fi
+   sed -e "/^#/d" -e "/^\$/d" -e "s,.*, $posrcprefix& \\\\," -e "\$s/\(.*\) \\\\/\1/" \
+	< $srcdir/po/POTFILES.in > po/POTFILES
+  ])
+
+
+
+dnl ----------------------------------------------------
+dnl ------------- macros for g10 -----------------------
+dnl ----------------------------------------------------
+
+
+dnl WK_MSG_PRINT(STRING)
+dnl print a message
+dnl
+define(WK_MSG_PRINT,
+  [ echo $ac_n "$1"" $ac_c" 1>&AC_FD_MSG
+  ])
+
+
+dnl WK_CHECK_TYPEDEF(TYPE, HAVE_NAME)
+dnl Check wether a typedef exists and create a #define $2 if it exists
+dnl
+AC_DEFUN(WK_CHECK_TYPEDEF,
+  [ AC_MSG_CHECKING(for $1 typedef)
+    AC_CACHE_VAL(wk_cv_typedef_$1,
+    [AC_TRY_COMPILE([#include <stdlib.h>
+    #include <sys/types.h>], [
+    #undef $1
+    int a = sizeof($1);
+    ], wk_cv_typedef_$1=yes, wk_cv_typedef_$1=no )])
+    AC_MSG_RESULT($wk_cv_typedef_$1)
+    if test "$wk_cv_typedef_$1" = yes; then
+	AC_DEFINE($2)
+    fi
+  ])
+
+
+dnl WK_LINK_FILES( SRC, DEST )
+dnl same as AC_LINK_FILES, but collet the files to link in
+dnl some special variables and do the link macro
+dnl when WK_DO_LINK_FILES is called
+dnl This is a workaround for AC_LINK_FILES, because it does not work
+dnl correct when using a caching scheme
+dnl
+define(WK_LINK_FILES,
+  [ if test "x$wk_link_files_src" = "x"; then
+	wk_link_files_src="$1"
+	wk_link_files_dst="$2"
+    else
+	wk_link_files_src="$wk_link_files_src $1"
+	wk_link_files_dst="$wk_link_files_dst $2"
+    fi
+  ])
+define(WK_DO_LINK_FILES,
+  [ AC_LINK_FILES( $wk_link_files_src, $wk_link_files_dst )
+  ])
+
+
+dnl WK_CHECK_ENDIAN
+dnl define either LITTLE_ENDIAN_HOST or BIG_ENDIAN_HOST
+dnl
+define(WK_CHECK_ENDIAN,
+  [ if test "$cross_compiling" = yes; then
+	AC_MSG_WARN(cross compiling; assuming little endianess)
+    fi
+    AC_MSG_CHECKING(endianess)
+    AC_CACHE_VAL(wk_cv_c_endian,
+      [ wk_cv_c_endian=unknown
+	# See if sys/param.h defines the BYTE_ORDER macro.
+	AC_TRY_COMPILE([#include <sys/types.h>
+	#include <sys/param.h>], [
+	#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
+	 bogus endian macros
+	#endif], [# It does; now see whether it defined to BIG_ENDIAN or not.
+	AC_TRY_COMPILE([#include <sys/types.h>
+	#include <sys/param.h>], [
+	#if BYTE_ORDER != BIG_ENDIAN
+	 not big endian
+	#endif], wk_cv_c_endian=big, wk_cv_c_endian=big)])
+	if test "$wk_cv_c_endian" = unknown; then
+	    AC_TRY_RUN([main () {
+	      /* Are we little or big endian?  From Harbison&Steele.  */
+	      union
+	      {
+		long l;
+		char c[sizeof (long)];
+	      } u;
+	      u.l = 1;
+	      exit (u.c[sizeof (long) - 1] == 1);
+	      }],
+	      wk_cv_c_endian=little,
+	      wk_cv_c_endian=big,
+	      wk_cv_c_endian=little
+	    )
+	fi
+      ])
+    AC_MSG_RESULT([$wk_cv_c_endian])
+    if test "$wk_cv_c_endian" = little; then
+      AC_DEFINE(LITTLE_ENDIAN_HOST)
+    else
+      AC_DEFINE(BIG_ENDIAN_HOST)
+    fi
+  ])
+
+dnl WK_CHECK_CACHE
+dnl
+define(WK_CHECK_CACHE,
+  [ AC_MSG_CHECKING(cached information)
+    wk_hostcheck="$target"
+    AC_CACHE_VAL(wk_cv_hostcheck, [ wk_cv_hostcheck="$wk_hostcheck" ])
+    if test "$wk_cv_hostcheck" != "$wk_hostcheck"; then
+	AC_MSG_RESULT(changed)
+	AC_MSG_WARN(config.cache exists!)
+	AC_MSG_ERROR(you must do 'make distclean' first to compile for
+		 different target or different parameters.)
+    else
+	AC_MSG_RESULT(ok)
+    fi
+  ])
+
+
diff -urN g10-0.2.0/cipher/Makefile.in g10-0.2.1/cipher/Makefile.in
--- g10-0.2.0/cipher/Makefile.in	Sun Jan 25 20:22:13 1998
+++ g10-0.2.1/cipher/Makefile.in	Wed Jan 28 16:36:56 1998
@@ -177,8 +177,9 @@
  ../include/../cipher/elgamal.h dsa.h
 elgamal.o: elgamal.c ../include/util.h ../include/types.h \
  ../include/errors.h ../include/mpi.h ../include/iobuf.h \
- ../include/memory.h ../include/cipher.h ../include/../cipher/md5.h \
+ ../include/memory.h ../include/cipher.h ../include/../cipher/md.h \
  ../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+ ../include/../cipher/md5.h ../include/../cipher/rsa.h \
  ../include/../cipher/blowfish.h ../include/../cipher/gost.h \
  ../include/../cipher/elgamal.h elgamal.h
 gost.o: gost.c ../include/util.h ../include/types.h \
@@ -213,7 +214,7 @@
  ../include/../cipher/rmd.h ../include/../cipher/sha1.h \
  ../include/../cipher/md5.h ../include/../cipher/rsa.h \
  ../include/../cipher/blowfish.h ../include/../cipher/gost.h \
- ../include/../cipher/elgamal.h ../include/ttyio.h
+ ../include/../cipher/elgamal.h ../include/ttyio.h ../include/i18n.h
 rmd160.o: rmd160.c ../include/util.h ../include/types.h \
  ../include/errors.h ../include/mpi.h ../include/iobuf.h \
  ../include/memory.h rmd.h
diff -urN g10-0.2.0/cipher/random.c g10-0.2.1/cipher/random.c
--- g10-0.2.0/cipher/random.c	Wed Jan 21 18:56:53 1998
+++ g10-0.2.1/cipher/random.c	Tue Jan 27 15:26:28 1998
@@ -31,6 +31,7 @@
 #include "util.h"
 #include "cipher.h"
 #include "ttyio.h"
+#include "i18n.h"
 
 struct cache {
     int len;
@@ -51,7 +52,11 @@
     int last = quick_test;
     if( onoff != -1 )
 	quick_test = onoff;
+  #ifdef HAVE_DEV_RANDOM
     return last;
+  #else
+    return 1; /* insecure RNG */
+  #endif
 }
 
 
@@ -137,9 +142,9 @@
 	tv.tv_usec = 0;
 	if( !(rc=select(fd+1, &rfds, NULL, NULL, &tv)) ) {
 	    if( !warn )
-		tty_printf(
+		tty_printf( _(
 "\nNot enough random bytes available.  Please do some other work to give
-the OS a chance to collect more entropy! (Need %d more bytes)\n", length );
+the OS a chance to collect more entropy! (Need %d more bytes)\n"), length );
 	    warn = 1;
 	    continue;
 	}
@@ -177,10 +182,10 @@
     static int initialized=0;
 
     if( !initialized ) {
-	log_info("warning: using insecure random number generator!!\n");
-	tty_printf("The random number generator is only a kludge to let\n"
+	log_info(_("warning: using insecure random number generator!!\n"));
+	tty_printf(_("The random number generator is only a kludge to let\n"
 		   "it compile - it is in no way a strong RNG!\n\n"
-		   "DON'T USE ANY DATA GENERATED BY THIS PROGRAM!!\n\n");
+		   "DON'T USE ANY DATA GENERATED BY THIS PROGRAM!!\n\n"));
 	initialized=1;
       #ifdef HAVE_RAND
 	srand(make_timestamp()*getpid());
diff -urN g10-0.2.0/config.h.in g10-0.2.1/config.h.in
--- g10-0.2.0/config.h.in	Thu Jan 22 18:44:57 1998
+++ g10-0.2.1/config.h.in	Wed Jan 28 14:45:29 1998
@@ -23,27 +23,70 @@
 
 
 
+/* Define if using alloca.c.  */
+#undef C_ALLOCA
+
 /* Define to empty if the keyword does not work.  */
 #undef const
 
+/* Define to one of _getb67, GETB67, getb67 for Cray-2 and Cray-YMP systems.
+   This function is required for alloca.c support on those systems.  */
+#undef CRAY_STACKSEG_END
+
+/* Define if you have alloca, as a function or macro.  */
+#undef HAVE_ALLOCA
+
+/* Define if you have <alloca.h> and it should be used (not on Ultrix).  */
+#undef HAVE_ALLOCA_H
+
 /* Define if you don't have vprintf but do have _doprnt.  */
 #undef HAVE_DOPRNT
 
+/* Define if you have a working `mmap' system call.  */
+#undef HAVE_MMAP
+
 /* Define if you have the vprintf function.  */
 #undef HAVE_VPRINTF
 
 /* Define as __inline if that's what the C compiler calls it.  */
 #undef inline
 
+/* Define to `long' if <sys/types.h> doesn't define.  */
+#undef off_t
+
 /* Define to `unsigned' if <sys/types.h> doesn't define.  */
 #undef size_t
 
+/* If using the C implementation of alloca, define if you know the
+   direction of stack growth for your system; otherwise it will be
+   automatically deduced at run-time.
+ STACK_DIRECTION > 0 => grows toward higher addresses
+ STACK_DIRECTION < 0 => grows toward lower addresses
+ STACK_DIRECTION = 0 => direction of growth unknown
+ */
+#undef STACK_DIRECTION
+
 /* Define if you have the ANSI C header files.  */
 #undef STDC_HEADERS
 
 #undef M_DEBUG
 #undef VERSION
 #undef PACKAGE
+#undef G10_LOCALEDIR
+
+/* Define if your locale.h file contains LC_MESSAGES.  */
+#undef HAVE_LC_MESSAGES
+
+/* Define to 1 if NLS is requested.  */
+#undef ENABLE_NLS
+
+/* Define as 1 if you have catgets and don't want to use GNU gettext.  */
+#undef HAVE_CATGETS
+
+/* Define as 1 if you have gettext and don't want to use GNU gettext.  */
+#undef HAVE_GETTEXT
+
+#undef HAVE_STPCPY
 
 #undef BIG_ENDIAN_HOST
 #undef LITTLE_ENDIAN_HOST
@@ -72,12 +115,45 @@
 /* The number of bytes in a unsigned short.  */
 #undef SIZEOF_UNSIGNED_SHORT
 
+/* Define if you have the dcgettext function.  */
+#undef HAVE_DCGETTEXT
+
+/* Define if you have the getcwd function.  */
+#undef HAVE_GETCWD
+
+/* Define if you have the getpagesize function.  */
+#undef HAVE_GETPAGESIZE
+
+/* Define if you have the mlock function.  */
+#undef HAVE_MLOCK
+
+/* Define if you have the mmap function.  */
+#undef HAVE_MMAP
+
+/* Define if you have the munmap function.  */
+#undef HAVE_MUNMAP
+
+/* Define if you have the putenv function.  */
+#undef HAVE_PUTENV
+
 /* Define if you have the rand function.  */
 #undef HAVE_RAND
 
+/* Define if you have the setenv function.  */
+#undef HAVE_SETENV
+
+/* Define if you have the setlocale function.  */
+#undef HAVE_SETLOCALE
+
 /* Define if you have the stpcpy function.  */
 #undef HAVE_STPCPY
 
+/* Define if you have the strcasecmp function.  */
+#undef HAVE_STRCASECMP
+
+/* Define if you have the strchr function.  */
+#undef HAVE_STRCHR
+
 /* Define if you have the strerror function.  */
 #undef HAVE_STRERROR
 
@@ -90,11 +166,35 @@
 /* Define if you have the tcgetattr function.  */
 #undef HAVE_TCGETATTR
 
+/* Define if you have the <limits.h> header file.  */
+#undef HAVE_LIMITS_H
+
+/* Define if you have the <locale.h> header file.  */
+#undef HAVE_LOCALE_H
+
+/* Define if you have the <malloc.h> header file.  */
+#undef HAVE_MALLOC_H
+
+/* Define if you have the <nl_types.h> header file.  */
+#undef HAVE_NL_TYPES_H
+
+/* Define if you have the <string.h> header file.  */
+#undef HAVE_STRING_H
+
 /* Define if you have the <unistd.h> header file.  */
 #undef HAVE_UNISTD_H
 
+/* Define if you have the <values.h> header file.  */
+#undef HAVE_VALUES_H
+
 /* Define if you have the <zlib.h> header file.  */
 #undef HAVE_ZLIB_H
+
+/* Define if you have the i library (-li).  */
+#undef HAVE_LIBI
+
+/* Define if you have the intl library (-lintl).  */
+#undef HAVE_LIBINTL
 
 
 /* The AC_CHECK_SIZEOF() fails for some machines.
diff -urN g10-0.2.0/configure g10-0.2.1/configure
--- g10-0.2.0/configure	Thu Jan 22 18:45:01 1998
+++ g10-0.2.1/configure	Wed Jan 28 14:45:13 1998
@@ -13,6 +13,10 @@
 # Any additions from configure.in:
 ac_help="$ac_help
   --enable-m-debug    Enable debugging of memory allocation"
+ac_help="$ac_help
+  --disable-nls		 do not use Native Language Support"
+ac_help="$ac_help
+  --with-gnu-gettext	   use the GNU gettext library"
 
 # Initialize some variables set by options.
 # The variables have the same names as the options, with
@@ -542,8 +546,22 @@
 
 
 
+if test "x$exec_prefix" = xNONE ; then
+    if test "x$prefix" = xNONE ; then
+	g10_prefix="$ac_default_prefix"
+    else
+	g10_prefix="$prefix"
+    fi
+else
+    g10_prefix="$exec_prefix"
+fi
+
+
 VERSION=`cat $srcdir/VERSION`
 PACKAGE=g10
+ALL_LINGUAS="de"
+G10_LOCALEDIR="$g10_prefix/share/locale"
+
 
 
 cat >> confdefs.h <<EOF
@@ -554,6 +572,10 @@
 #define PACKAGE "$PACKAGE"
 EOF
 
+cat >> confdefs.h <<EOF
+#define G10_LOCALEDIR "$G10_LOCALEDIR"
+EOF
+
 
 # Check whether --enable-m-debug or --disable-m-debug was given.
 if test "${enable_m_debug+set}" = set; then
@@ -572,12 +594,6 @@
 
 
 
-
-
-
-
-
-
 # Do some error checking and defaulting for the host and target type.
 # The inputs are:
 #    configure --host=HOST --target=TARGET --build=BUILD NONOPT
@@ -605,7 +621,7 @@
 fi
 
 echo $ac_n "checking host system type""... $ac_c" 1>&6
-echo "configure:609: checking host system type" >&5
+echo "configure:625: checking host system type" >&5
 
 host_alias=$host
 case "$host_alias" in
@@ -626,7 +642,7 @@
 echo "$ac_t""$host" 1>&6
 
 echo $ac_n "checking target system type""... $ac_c" 1>&6
-echo "configure:630: checking target system type" >&5
+echo "configure:646: checking target system type" >&5
 
 target_alias=$target
 case "$target_alias" in
@@ -644,7 +660,7 @@
 echo "$ac_t""$target" 1>&6
 
 echo $ac_n "checking build system type""... $ac_c" 1>&6
-echo "configure:648: checking build system type" >&5
+echo "configure:664: checking build system type" >&5
 
 build_alias=$build
 case "$build_alias" in
@@ -666,28 +682,28 @@
     NONENONEs,x,x, &&
   program_prefix=${target_alias}-
 
-echo $ac_n "checking cached information""... $ac_c" 1>&6
-echo "configure:671: checking cached information" >&5
-hostcheck="$target"
-if eval "test \"`echo '$''{'ac_cv_mpi_hostcheck'+set}'`\" = set"; then
+ echo $ac_n "checking cached information""... $ac_c" 1>&6
+echo "configure:687: checking cached information" >&5
+    wk_hostcheck="$target"
+    if eval "test \"`echo '$''{'wk_cv_hostcheck'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-   ac_cv_mpi_hostcheck="$hostcheck" 
-fi
-
-if test "$ac_cv_mpi_hostcheck" != "$hostcheck"; then
-    echo "$ac_t""changed" 1>&6
-    echo "configure: warning: config.cache exists!" 1>&2
-    { echo "configure: error: you must do 'make distclean' first to compile for
-different target or different parameters." 1>&2; exit 1; }
-else
-    echo "$ac_t""ok" 1>&6
+   wk_cv_hostcheck="$wk_hostcheck" 
 fi
 
+    if test "$wk_cv_hostcheck" != "$wk_hostcheck"; then
+	echo "$ac_t""changed" 1>&6
+	echo "configure: warning: config.cache exists!" 1>&2
+	{ echo "configure: error: you must do 'make distclean' first to compile for
+		 different target or different parameters." 1>&2; exit 1; }
+    else
+	echo "$ac_t""ok" 1>&6
+    fi
+  
 
 
 echo $ac_n "checking whether ${MAKE-make} sets \${MAKE}""... $ac_c" 1>&6
-echo "configure:691: checking whether ${MAKE-make} sets \${MAKE}" >&5
+echo "configure:707: checking whether ${MAKE-make} sets \${MAKE}" >&5
 set dummy ${MAKE-make}; ac_make=`echo "$2" | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_prog_make_${ac_make}_set'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -727,7 +743,7 @@
 # Extract the first word of "ranlib", so it can be a program name with args.
 set dummy ranlib; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:731: checking for $ac_word" >&5
+echo "configure:747: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_RANLIB'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -764,7 +780,7 @@
 # SVR4 /usr/ucb/install, which tries to use the nonexistent group "staff"
 # ./install, which can be erroneously created by make from ./install.sh.
 echo $ac_n "checking for a BSD compatible install""... $ac_c" 1>&6
-echo "configure:768: checking for a BSD compatible install" >&5
+echo "configure:784: checking for a BSD compatible install" >&5
 if test -z "$INSTALL"; then
 if eval "test \"`echo '$''{'ac_cv_path_install'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -816,7 +832,7 @@
 # Extract the first word of "gcc", so it can be a program name with args.
 set dummy gcc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:820: checking for $ac_word" >&5
+echo "configure:836: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -845,7 +861,7 @@
   # Extract the first word of "cc", so it can be a program name with args.
 set dummy cc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:849: checking for $ac_word" >&5
+echo "configure:865: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -893,7 +909,7 @@
 fi
 
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works""... $ac_c" 1>&6
-echo "configure:897: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
+echo "configure:913: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
 
 ac_ext=c
 # CFLAGS is not in ac_cpp because -g, -O, etc. are not valid cpp options.
@@ -903,11 +919,11 @@
 cross_compiling=$ac_cv_prog_cc_cross
 
 cat > conftest.$ac_ext <<EOF
-#line 907 "configure"
+#line 923 "configure"
 #include "confdefs.h"
 main(){return(0);}
 EOF
-if { (eval echo configure:911: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:927: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   ac_cv_prog_cc_works=yes
   # If we can't run a trivial program, we are probably using a cross compiler.
   if (./conftest; exit) 2>/dev/null; then
@@ -927,12 +943,12 @@
   { echo "configure: error: installation or configuration problem: C compiler cannot create executables." 1>&2; exit 1; }
 fi
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler""... $ac_c" 1>&6
-echo "configure:931: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
+echo "configure:947: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
 echo "$ac_t""$ac_cv_prog_cc_cross" 1>&6
 cross_compiling=$ac_cv_prog_cc_cross
 
 echo $ac_n "checking whether we are using GNU C""... $ac_c" 1>&6
-echo "configure:936: checking whether we are using GNU C" >&5
+echo "configure:952: checking whether we are using GNU C" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_gcc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -941,7 +957,7 @@
   yes;
 #endif
 EOF
-if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:945: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
+if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:961: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
   ac_cv_prog_gcc=yes
 else
   ac_cv_prog_gcc=no
@@ -956,7 +972,7 @@
   ac_save_CFLAGS="$CFLAGS"
   CFLAGS=
   echo $ac_n "checking whether ${CC-cc} accepts -g""... $ac_c" 1>&6
-echo "configure:960: checking whether ${CC-cc} accepts -g" >&5
+echo "configure:976: checking whether ${CC-cc} accepts -g" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_cc_g'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -984,7 +1000,7 @@
 fi
 
 echo $ac_n "checking how to run the C preprocessor""... $ac_c" 1>&6
-echo "configure:988: checking how to run the C preprocessor" >&5
+echo "configure:1004: checking how to run the C preprocessor" >&5
 # On Suns, sometimes $CPP names a directory.
 if test -n "$CPP" && test -d "$CPP"; then
   CPP=
@@ -999,13 +1015,13 @@
   # On the NeXT, cc -E runs the code through the compiler's parser,
   # not just through cpp.
   cat > conftest.$ac_ext <<EOF
-#line 1003 "configure"
+#line 1019 "configure"
 #include "confdefs.h"
 #include <assert.h>
 Syntax Error
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1009: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1025: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   :
@@ -1016,13 +1032,13 @@
   rm -rf conftest*
   CPP="${CC-cc} -E -traditional-cpp"
   cat > conftest.$ac_ext <<EOF
-#line 1020 "configure"
+#line 1036 "configure"
 #include "confdefs.h"
 #include <assert.h>
 Syntax Error
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1026: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1042: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   :
@@ -1070,12 +1086,12 @@
 
 
 echo $ac_n "checking for ANSI C header files""... $ac_c" 1>&6
-echo "configure:1074: checking for ANSI C header files" >&5
+echo "configure:1090: checking for ANSI C header files" >&5
 if eval "test \"`echo '$''{'ac_cv_header_stdc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1079 "configure"
+#line 1095 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 #include <stdarg.h>
@@ -1083,7 +1099,7 @@
 #include <float.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1087: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1103: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -1100,7 +1116,7 @@
 if test $ac_cv_header_stdc = yes; then
   # SunOS 4.x string.h does not declare mem*, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1104 "configure"
+#line 1120 "configure"
 #include "confdefs.h"
 #include <string.h>
 EOF
@@ -1118,7 +1134,7 @@
 if test $ac_cv_header_stdc = yes; then
   # ISC 2.0.2 stdlib.h does not declare free, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1122 "configure"
+#line 1138 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 EOF
@@ -1139,7 +1155,7 @@
   :
 else
   cat > conftest.$ac_ext <<EOF
-#line 1143 "configure"
+#line 1159 "configure"
 #include "confdefs.h"
 #include <ctype.h>
 #define ISLOWER(c) ('a' <= (c) && (c) <= 'z')
@@ -1150,7 +1166,7 @@
 exit (0); }
 
 EOF
-if { (eval echo configure:1154: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1170: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   :
 else
@@ -1177,17 +1193,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:1181: checking for $ac_hdr" >&5
+echo "configure:1197: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1186 "configure"
+#line 1202 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1191: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1207: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -1214,14 +1230,13 @@
 done
 
 
-
 echo $ac_n "checking for working const""... $ac_c" 1>&6
-echo "configure:1220: checking for working const" >&5
+echo "configure:1235: checking for working const" >&5
 if eval "test \"`echo '$''{'ac_cv_c_const'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1225 "configure"
+#line 1240 "configure"
 #include "confdefs.h"
 
 int main() {
@@ -1270,7 +1285,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:1274: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1289: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_c_const=yes
 else
@@ -1291,21 +1306,21 @@
 fi
 
 echo $ac_n "checking for inline""... $ac_c" 1>&6
-echo "configure:1295: checking for inline" >&5
+echo "configure:1310: checking for inline" >&5
 if eval "test \"`echo '$''{'ac_cv_c_inline'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   ac_cv_c_inline=no
 for ac_kw in inline __inline__ __inline; do
   cat > conftest.$ac_ext <<EOF
-#line 1302 "configure"
+#line 1317 "configure"
 #include "confdefs.h"
 
 int main() {
 } $ac_kw foo() {
 ; return 0; }
 EOF
-if { (eval echo configure:1309: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1324: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_c_inline=$ac_kw; break
 else
@@ -1330,13 +1345,13 @@
  ;;
 esac
 
-echo $ac_n "checking for size_t""... $ac_c" 1>&6
-echo "configure:1335: checking for size_t" >&5
-if eval "test \"`echo '$''{'ac_cv_type_size_t'+set}'`\" = set"; then
+echo $ac_n "checking for off_t""... $ac_c" 1>&6
+echo "configure:1350: checking for off_t" >&5
+if eval "test \"`echo '$''{'ac_cv_type_off_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1340 "configure"
+#line 1355 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #if STDC_HEADERS
@@ -1345,400 +1360,2025 @@
 #endif
 EOF
 if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
-  egrep "size_t[^a-zA-Z_0-9]" >/dev/null 2>&1; then
+  egrep "off_t[^a-zA-Z_0-9]" >/dev/null 2>&1; then
   rm -rf conftest*
-  ac_cv_type_size_t=yes
+  ac_cv_type_off_t=yes
 else
   rm -rf conftest*
-  ac_cv_type_size_t=no
+  ac_cv_type_off_t=no
 fi
 rm -f conftest*
 
 fi
-echo "$ac_t""$ac_cv_type_size_t" 1>&6
-if test $ac_cv_type_size_t = no; then
+echo "$ac_t""$ac_cv_type_off_t" 1>&6
+if test $ac_cv_type_off_t = no; then
   cat >> confdefs.h <<\EOF
-#define size_t unsigned
+#define off_t long
 EOF
 
 fi
 
-
-
-if test "$cross_compiling" = yes; then
-    echo "configure: warning: cross compiling; assuming little endianess" 1>&2
-fi
-echo $ac_n "checking for little endianess""... $ac_c" 1>&6
-echo "configure:1373: checking for little endianess" >&5
-if eval "test \"`echo '$''{'ac_cv_c_littleendian'+set}'`\" = set"; then
+echo $ac_n "checking for size_t""... $ac_c" 1>&6
+echo "configure:1383: checking for size_t" >&5
+if eval "test \"`echo '$''{'ac_cv_type_size_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  ac_cv_c_littleendian=unknown
-# See if sys/param.h defines the BYTE_ORDER macro.
-cat > conftest.$ac_ext <<EOF
-#line 1380 "configure"
-#include "confdefs.h"
-#include <sys/types.h>
-#include <sys/param.h>
-int main() {
-
-#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
- bogus endian macros
-#endif
-; return 0; }
-EOF
-if { (eval echo configure:1391: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
-  rm -rf conftest*
-  # It does; now see whether it defined to BIG_ENDIAN or not.
-cat > conftest.$ac_ext <<EOF
-#line 1395 "configure"
+  cat > conftest.$ac_ext <<EOF
+#line 1388 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
-#include <sys/param.h>
-int main() {
-
-#if BYTE_ORDER != BIG_ENDIAN
- not big endian
+#if STDC_HEADERS
+#include <stdlib.h>
+#include <stddef.h>
 #endif
-; return 0; }
 EOF
-if { (eval echo configure:1406: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
+  egrep "size_t[^a-zA-Z_0-9]" >/dev/null 2>&1; then
   rm -rf conftest*
-  ac_cv_c_littleendian=no
+  ac_cv_type_size_t=yes
 else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
   rm -rf conftest*
-  ac_cv_c_littleendian=yes
-fi
-rm -f conftest*
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
+  ac_cv_type_size_t=no
 fi
 rm -f conftest*
-if test "$ac_cv_c_littleendian" = unknown; then
-if test "$cross_compiling" = yes; then
-  ac_cv_c_littleendian=yes
-else
-  cat > conftest.$ac_ext <<EOF
-#line 1426 "configure"
-#include "confdefs.h"
-main () {
-  /* Are we little or big endian?  From Harbison&Steele.  */
-  union
-  {
-    long l;
-    char c[sizeof (long)];
-  } u;
-  u.l = 1;
-  exit (u.c[sizeof (long) - 1] == 1);
-}
-EOF
-if { (eval echo configure:1439: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
-then
-  ac_cv_c_littleendian=yes
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -fr conftest*
-  ac_cv_c_littleendian=no
-fi
-rm -fr conftest*
-fi
 
 fi
-fi
-
-echo "$ac_t""$ac_cv_c_littleendian" 1>&6
-
-if test "$ac_cv_c_littleendian" = yes; then
-  cat >> confdefs.h <<\EOF
-#define LITTLE_ENDIAN_HOST 1
-EOF
-
-else
+echo "$ac_t""$ac_cv_type_size_t" 1>&6
+if test $ac_cv_type_size_t = no; then
   cat >> confdefs.h <<\EOF
-#define BIG_ENDIAN_HOST 1
+#define size_t unsigned
 EOF
 
 fi
 
-
-echo $ac_n "checking for byte typedef""... $ac_c" 1>&6
-echo "configure:1470: checking for byte typedef" >&5
-if eval "test \"`echo '$''{'wk_cv_typedef_byte'+set}'`\" = set"; then
+# The Ultrix 4.2 mips builtin alloca declared by alloca.h only works
+# for constant arguments.  Useless!
+echo $ac_n "checking for working alloca.h""... $ac_c" 1>&6
+echo "configure:1418: checking for working alloca.h" >&5
+if eval "test \"`echo '$''{'ac_cv_header_alloca_h'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1475 "configure"
+#line 1423 "configure"
 #include "confdefs.h"
-#include <stdlib.h>
-#include <sys/types.h>
+#include <alloca.h>
 int main() {
-
-#undef byte
-int a = sizeof(byte);
-
+char *p = alloca(2 * sizeof(int));
 ; return 0; }
 EOF
-if { (eval echo configure:1486: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1430: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  wk_cv_typedef_byte=yes
+  ac_cv_header_alloca_h=yes
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  wk_cv_typedef_byte=no 
+  ac_cv_header_alloca_h=no
 fi
 rm -f conftest*
 fi
 
-echo "$ac_t""$wk_cv_typedef_byte" 1>&6
-if test "$wk_cv_typedef_byte" = yes; then
-    cat >> confdefs.h <<\EOF
-#define HAVE_BYTE_TYPEDEF 1
+echo "$ac_t""$ac_cv_header_alloca_h" 1>&6
+if test $ac_cv_header_alloca_h = yes; then
+  cat >> confdefs.h <<\EOF
+#define HAVE_ALLOCA_H 1
 EOF
 
 fi
 
-echo $ac_n "checking for ushort typedef""... $ac_c" 1>&6
-echo "configure:1507: checking for ushort typedef" >&5
-if eval "test \"`echo '$''{'wk_cv_typedef_ushort'+set}'`\" = set"; then
+echo $ac_n "checking for alloca""... $ac_c" 1>&6
+echo "configure:1451: checking for alloca" >&5
+if eval "test \"`echo '$''{'ac_cv_func_alloca_works'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1512 "configure"
+#line 1456 "configure"
 #include "confdefs.h"
-#include <stdlib.h>
-#include <sys/types.h>
-int main() {
 
-#undef ushort
-int a = sizeof(ushort);
+#ifdef __GNUC__
+# define alloca __builtin_alloca
+#else
+# if HAVE_ALLOCA_H
+#  include <alloca.h>
+# else
+#  ifdef _AIX
+ #pragma alloca
+#  else
+#   ifndef alloca /* predefined by HP cc +Olibcalls */
+char *alloca ();
+#   endif
+#  endif
+# endif
+#endif
 
+int main() {
+char *p = (char *) alloca(1);
 ; return 0; }
 EOF
-if { (eval echo configure:1523: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1479: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  wk_cv_typedef_ushort=yes
+  ac_cv_func_alloca_works=yes
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  wk_cv_typedef_ushort=no 
+  ac_cv_func_alloca_works=no
 fi
 rm -f conftest*
 fi
 
-echo "$ac_t""$wk_cv_typedef_ushort" 1>&6
-if test "$wk_cv_typedef_ushort" = yes; then
-    cat >> confdefs.h <<\EOF
-#define HAVE_USHORT_TYPEDEF 1
+echo "$ac_t""$ac_cv_func_alloca_works" 1>&6
+if test $ac_cv_func_alloca_works = yes; then
+  cat >> confdefs.h <<\EOF
+#define HAVE_ALLOCA 1
 EOF
 
 fi
 
-echo $ac_n "checking for ulong typedef""... $ac_c" 1>&6
-echo "configure:1544: checking for ulong typedef" >&5
-if eval "test \"`echo '$''{'wk_cv_typedef_ulong'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  cat > conftest.$ac_ext <<EOF
-#line 1549 "configure"
-#include "confdefs.h"
-#include <stdlib.h>
-#include <sys/types.h>
-int main() {
-
-#undef ulong
-int a = sizeof(ulong);
-
-; return 0; }
-EOF
-if { (eval echo configure:1560: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
-  rm -rf conftest*
-  wk_cv_typedef_ulong=yes
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  wk_cv_typedef_ulong=no 
-fi
-rm -f conftest*
-fi
-
-echo "$ac_t""$wk_cv_typedef_ulong" 1>&6
-if test "$wk_cv_typedef_ulong" = yes; then
-    cat >> confdefs.h <<\EOF
-#define HAVE_ULONG_TYPEDEF 1
+if test $ac_cv_func_alloca_works = no; then
+  # The SVR3 libPW and SVR4 libucb both contain incompatible functions
+  # that cause trouble.  Some versions do not even contain alloca or
+  # contain a buggy version.  If you still want to use their alloca,
+  # use ar to extract alloca.o from them instead of compiling alloca.c.
+  ALLOCA=alloca.o
+  cat >> confdefs.h <<\EOF
+#define C_ALLOCA 1
 EOF
 
-fi
 
-echo $ac_n "checking for u16 typedef""... $ac_c" 1>&6
-echo "configure:1581: checking for u16 typedef" >&5
-if eval "test \"`echo '$''{'wk_cv_typedef_u16'+set}'`\" = set"; then
+echo $ac_n "checking whether alloca needs Cray hooks""... $ac_c" 1>&6
+echo "configure:1511: checking whether alloca needs Cray hooks" >&5
+if eval "test \"`echo '$''{'ac_cv_os_cray'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1586 "configure"
+#line 1516 "configure"
 #include "confdefs.h"
-#include <stdlib.h>
-#include <sys/types.h>
-int main() {
-
-#undef u16
-int a = sizeof(u16);
+#if defined(CRAY) && ! defined(CRAY2)
+webecray
+#else
+wenotbecray
+#endif
 
-; return 0; }
 EOF
-if { (eval echo configure:1597: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
+  egrep "webecray" >/dev/null 2>&1; then
   rm -rf conftest*
-  wk_cv_typedef_u16=yes
+  ac_cv_os_cray=yes
 else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
   rm -rf conftest*
-  wk_cv_typedef_u16=no 
+  ac_cv_os_cray=no
 fi
 rm -f conftest*
-fi
-
-echo "$ac_t""$wk_cv_typedef_u16" 1>&6
-if test "$wk_cv_typedef_u16" = yes; then
-    cat >> confdefs.h <<\EOF
-#define HAVE_U16_TYPEDEF 1
-EOF
 
 fi
 
-echo $ac_n "checking for u32 typedef""... $ac_c" 1>&6
-echo "configure:1618: checking for u32 typedef" >&5
-if eval "test \"`echo '$''{'wk_cv_typedef_u32'+set}'`\" = set"; then
+echo "$ac_t""$ac_cv_os_cray" 1>&6
+if test $ac_cv_os_cray = yes; then
+for ac_func in _getb67 GETB67 getb67; do
+  echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:1541: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1623 "configure"
+#line 1546 "configure"
 #include "confdefs.h"
-#include <stdlib.h>
-#include <sys/types.h>
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char $ac_func(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char $ac_func();
+
 int main() {
 
-#undef u32
-int a = sizeof(u32);
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
+choke me
+#else
+$ac_func();
+#endif
 
 ; return 0; }
 EOF
-if { (eval echo configure:1634: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1569: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  wk_cv_typedef_u32=yes
+  eval "ac_cv_func_$ac_func=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  wk_cv_typedef_u32=no 
+  eval "ac_cv_func_$ac_func=no"
 fi
 rm -f conftest*
 fi
 
-echo "$ac_t""$wk_cv_typedef_u32" 1>&6
-if test "$wk_cv_typedef_u32" = yes; then
-    cat >> confdefs.h <<\EOF
-#define HAVE_U32_TYPEDEF 1
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+  cat >> confdefs.h <<EOF
+#define CRAY_STACKSEG_END $ac_func
 EOF
 
+  break
+else
+  echo "$ac_t""no" 1>&6
 fi
 
+done
+fi
 
-echo $ac_n "checking size of unsigned short""... $ac_c" 1>&6
-echo "configure:1656: checking size of unsigned short" >&5
-if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_short'+set}'`\" = set"; then
+echo $ac_n "checking stack direction for C alloca""... $ac_c" 1>&6
+echo "configure:1596: checking stack direction for C alloca" >&5
+if eval "test \"`echo '$''{'ac_cv_c_stack_direction'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   if test "$cross_compiling" = yes; then
-  ac_cv_sizeof_unsigned_short=2
+  ac_cv_c_stack_direction=0
 else
   cat > conftest.$ac_ext <<EOF
-#line 1664 "configure"
+#line 1604 "configure"
 #include "confdefs.h"
-#include <stdio.h>
-main()
+find_stack_direction ()
 {
-  FILE *f=fopen("conftestval", "w");
-  if (!f) exit(1);
-  fprintf(f, "%d\n", sizeof(unsigned short));
-  exit(0);
+  static char *addr = 0;
+  auto char dummy;
+  if (addr == 0)
+    {
+      addr = &dummy;
+      return find_stack_direction ();
+    }
+  else
+    return (&dummy > addr) ? 1 : -1;
+}
+main ()
+{
+  exit (find_stack_direction() < 0);
 }
 EOF
-if { (eval echo configure:1675: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1623: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
-  ac_cv_sizeof_unsigned_short=`cat conftestval`
+  ac_cv_c_stack_direction=1
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -fr conftest*
-  ac_cv_sizeof_unsigned_short=0
+  ac_cv_c_stack_direction=-1
 fi
 rm -fr conftest*
 fi
 
 fi
-echo "$ac_t""$ac_cv_sizeof_unsigned_short" 1>&6
+
+echo "$ac_t""$ac_cv_c_stack_direction" 1>&6
 cat >> confdefs.h <<EOF
-#define SIZEOF_UNSIGNED_SHORT $ac_cv_sizeof_unsigned_short
+#define STACK_DIRECTION $ac_cv_c_stack_direction
 EOF
 
+fi
 
-echo $ac_n "checking size of unsigned int""... $ac_c" 1>&6
-echo "configure:1695: checking size of unsigned int" >&5
-if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_int'+set}'`\" = set"; then
+for ac_hdr in unistd.h
+do
+ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
+echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
+echo "configure:1648: checking for $ac_hdr" >&5
+if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  if test "$cross_compiling" = yes; then
-  ac_cv_sizeof_unsigned_int=4
-else
   cat > conftest.$ac_ext <<EOF
-#line 1703 "configure"
+#line 1653 "configure"
 #include "confdefs.h"
-#include <stdio.h>
-main()
-{
-  FILE *f=fopen("conftestval", "w");
-  if (!f) exit(1);
-  fprintf(f, "%d\n", sizeof(unsigned int));
-  exit(0);
-}
+#include <$ac_hdr>
 EOF
-if { (eval echo configure:1714: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
-then
-  ac_cv_sizeof_unsigned_int=`cat conftestval`
+ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
+{ (eval echo configure:1658: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+ac_err=`grep -v '^ *+' conftest.out`
+if test -z "$ac_err"; then
+  rm -rf conftest*
+  eval "ac_cv_header_$ac_safe=yes"
 else
+  echo "$ac_err" >&5
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
-  rm -fr conftest*
-  ac_cv_sizeof_unsigned_int=0
-fi
-rm -fr conftest*
+  rm -rf conftest*
+  eval "ac_cv_header_$ac_safe=no"
 fi
-
+rm -f conftest*
 fi
-echo "$ac_t""$ac_cv_sizeof_unsigned_int" 1>&6
-cat >> confdefs.h <<EOF
-#define SIZEOF_UNSIGNED_INT $ac_cv_sizeof_unsigned_int
+if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_hdr=HAVE_`echo $ac_hdr | sed 'y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_hdr 1
 EOF
-
-
-echo $ac_n "checking size of unsigned long""... $ac_c" 1>&6
-echo "configure:1734: checking size of unsigned long" >&5
-if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_long'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
+ 
+else
+  echo "$ac_t""no" 1>&6
+fi
+done
+
+for ac_func in getpagesize
+do
+echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:1687: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 1692 "configure"
+#include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char $ac_func(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char $ac_func();
+
+int main() {
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
+choke me
+#else
+$ac_func();
+#endif
+
+; return 0; }
+EOF
+if { (eval echo configure:1715: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=no"
+fi
+rm -f conftest*
+fi
+
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_func 1
+EOF
+ 
+else
+  echo "$ac_t""no" 1>&6
+fi
+done
+
+echo $ac_n "checking for working mmap""... $ac_c" 1>&6
+echo "configure:1740: checking for working mmap" >&5
+if eval "test \"`echo '$''{'ac_cv_func_mmap_fixed_mapped'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  if test "$cross_compiling" = yes; then
+  ac_cv_func_mmap_fixed_mapped=no
+else
+  cat > conftest.$ac_ext <<EOF
+#line 1748 "configure"
+#include "confdefs.h"
+
+/* Thanks to Mike Haertel and Jim Avera for this test.
+   Here is a matrix of mmap possibilities:
+	mmap private not fixed
+	mmap private fixed at somewhere currently unmapped
+	mmap private fixed at somewhere already mapped
+	mmap shared not fixed
+	mmap shared fixed at somewhere currently unmapped
+	mmap shared fixed at somewhere already mapped
+   For private mappings, we should verify that changes cannot be read()
+   back from the file, nor mmap's back from the file at a different
+   address.  (There have been systems where private was not correctly
+   implemented like the infamous i386 svr4.0, and systems where the
+   VM page cache was not coherent with the filesystem buffer cache
+   like early versions of FreeBSD and possibly contemporary NetBSD.)
+   For shared mappings, we should conversely verify that changes get
+   propogated back to all the places they're supposed to be.
+
+   Grep wants private fixed already mapped.
+   The main things grep needs to know about mmap are:
+   * does it exist and is it safe to write into the mmap'd area
+   * how to use it (BSD variants)  */
+#include <sys/types.h>
+#include <fcntl.h>
+#include <sys/mman.h>
+
+/* This mess was copied from the GNU getpagesize.h.  */
+#ifndef HAVE_GETPAGESIZE
+# ifdef HAVE_UNISTD_H
+#  include <unistd.h>
+# endif
+
+/* Assume that all systems that can run configure have sys/param.h.  */
+# ifndef HAVE_SYS_PARAM_H
+#  define HAVE_SYS_PARAM_H 1
+# endif
+
+# ifdef _SC_PAGESIZE
+#  define getpagesize() sysconf(_SC_PAGESIZE)
+# else /* no _SC_PAGESIZE */
+#  ifdef HAVE_SYS_PARAM_H
+#   include <sys/param.h>
+#   ifdef EXEC_PAGESIZE
+#    define getpagesize() EXEC_PAGESIZE
+#   else /* no EXEC_PAGESIZE */
+#    ifdef NBPG
+#     define getpagesize() NBPG * CLSIZE
+#     ifndef CLSIZE
+#      define CLSIZE 1
+#     endif /* no CLSIZE */
+#    else /* no NBPG */
+#     ifdef NBPC
+#      define getpagesize() NBPC
+#     else /* no NBPC */
+#      ifdef PAGESIZE
+#       define getpagesize() PAGESIZE
+#      endif /* PAGESIZE */
+#     endif /* no NBPC */
+#    endif /* no NBPG */
+#   endif /* no EXEC_PAGESIZE */
+#  else /* no HAVE_SYS_PARAM_H */
+#   define getpagesize() 8192	/* punt totally */
+#  endif /* no HAVE_SYS_PARAM_H */
+# endif /* no _SC_PAGESIZE */
+
+#endif /* no HAVE_GETPAGESIZE */
+
+#ifdef __cplusplus
+extern "C" { void *malloc(unsigned); }
+#else
+char *malloc();
+#endif
+
+int
+main()
+{
+	char *data, *data2, *data3;
+	int i, pagesize;
+	int fd;
+
+	pagesize = getpagesize();
+
+	/*
+	 * First, make a file with some known garbage in it.
+	 */
+	data = malloc(pagesize);
+	if (!data)
+		exit(1);
+	for (i = 0; i < pagesize; ++i)
+		*(data + i) = rand();
+	umask(0);
+	fd = creat("conftestmmap", 0600);
+	if (fd < 0)
+		exit(1);
+	if (write(fd, data, pagesize) != pagesize)
+		exit(1);
+	close(fd);
+
+	/*
+	 * Next, try to mmap the file at a fixed address which
+	 * already has something else allocated at it.  If we can,
+	 * also make sure that we see the same garbage.
+	 */
+	fd = open("conftestmmap", O_RDWR);
+	if (fd < 0)
+		exit(1);
+	data2 = malloc(2 * pagesize);
+	if (!data2)
+		exit(1);
+	data2 += (pagesize - ((int) data2 & (pagesize - 1))) & (pagesize - 1);
+	if (data2 != mmap(data2, pagesize, PROT_READ | PROT_WRITE,
+	    MAP_PRIVATE | MAP_FIXED, fd, 0L))
+		exit(1);
+	for (i = 0; i < pagesize; ++i)
+		if (*(data + i) != *(data2 + i))
+			exit(1);
+
+	/*
+	 * Finally, make sure that changes to the mapped area
+	 * do not percolate back to the file as seen by read().
+	 * (This is a bug on some variants of i386 svr4.0.)
+	 */
+	for (i = 0; i < pagesize; ++i)
+		*(data2 + i) = *(data2 + i) + 1;
+	data3 = malloc(pagesize);
+	if (!data3)
+		exit(1);
+	if (read(fd, data3, pagesize) != pagesize)
+		exit(1);
+	for (i = 0; i < pagesize; ++i)
+		if (*(data + i) != *(data3 + i))
+			exit(1);
+	close(fd);
+	unlink("conftestmmap");
+	exit(0);
+}
+
+EOF
+if { (eval echo configure:1888: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+then
+  ac_cv_func_mmap_fixed_mapped=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -fr conftest*
+  ac_cv_func_mmap_fixed_mapped=no
+fi
+rm -fr conftest*
+fi
+
+fi
+
+echo "$ac_t""$ac_cv_func_mmap_fixed_mapped" 1>&6
+if test $ac_cv_func_mmap_fixed_mapped = yes; then
+  cat >> confdefs.h <<\EOF
+#define HAVE_MMAP 1
+EOF
+
+fi
+
+                           
+   for ac_hdr in limits.h locale.h nl_types.h malloc.h string.h unistd.h values.h
+do
+ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
+echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
+echo "configure:1915: checking for $ac_hdr" >&5
+if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 1920 "configure"
+#include "confdefs.h"
+#include <$ac_hdr>
+EOF
+ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
+{ (eval echo configure:1925: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+ac_err=`grep -v '^ *+' conftest.out`
+if test -z "$ac_err"; then
+  rm -rf conftest*
+  eval "ac_cv_header_$ac_safe=yes"
+else
+  echo "$ac_err" >&5
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_header_$ac_safe=no"
+fi
+rm -f conftest*
+fi
+if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_hdr=HAVE_`echo $ac_hdr | sed 'y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_hdr 1
+EOF
+ 
+else
+  echo "$ac_t""no" 1>&6
+fi
+done
+
+   for ac_func in getcwd munmap putenv setenv setlocale strchr strcasecmp
+do
+echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:1954: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 1959 "configure"
+#include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char $ac_func(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char $ac_func();
+
+int main() {
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
+choke me
+#else
+$ac_func();
+#endif
+
+; return 0; }
+EOF
+if { (eval echo configure:1982: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=no"
+fi
+rm -f conftest*
+fi
+
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_func 1
+EOF
+ 
+else
+  echo "$ac_t""no" 1>&6
+fi
+done
+
+
+   if test "${ac_cv_func_stpcpy+set}" != "set"; then
+     for ac_func in stpcpy
+do
+echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:2011: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 2016 "configure"
+#include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char $ac_func(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char $ac_func();
+
+int main() {
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
+choke me
+#else
+$ac_func();
+#endif
+
+; return 0; }
+EOF
+if { (eval echo configure:2039: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=no"
+fi
+rm -f conftest*
+fi
+
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_func 1
+EOF
+ 
+else
+  echo "$ac_t""no" 1>&6
+fi
+done
+
+   fi
+   if test "${ac_cv_func_stpcpy}" = "yes"; then
+     cat >> confdefs.h <<\EOF
+#define HAVE_STPCPY 1
+EOF
+
+   fi
+
+   if test $ac_cv_header_locale_h = yes; then
+    echo $ac_n "checking for LC_MESSAGES""... $ac_c" 1>&6
+echo "configure:2073: checking for LC_MESSAGES" >&5
+if eval "test \"`echo '$''{'ud_cv_val_LC_MESSAGES'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 2078 "configure"
+#include "confdefs.h"
+#include <locale.h>
+int main() {
+return LC_MESSAGES
+; return 0; }
+EOF
+if { (eval echo configure:2085: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  ud_cv_val_LC_MESSAGES=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  ud_cv_val_LC_MESSAGES=no
+fi
+rm -f conftest*
+fi
+
+echo "$ac_t""$ud_cv_val_LC_MESSAGES" 1>&6
+    if test $ud_cv_val_LC_MESSAGES = yes; then
+      cat >> confdefs.h <<\EOF
+#define HAVE_LC_MESSAGES 1
+EOF
+
+    fi
+  fi
+   echo $ac_n "checking whether NLS is requested""... $ac_c" 1>&6
+echo "configure:2106: checking whether NLS is requested" >&5
+        # Check whether --enable-nls or --disable-nls was given.
+if test "${enable_nls+set}" = set; then
+  enableval="$enable_nls"
+  nls_cv_use_nls=$enableval
+else
+  nls_cv_use_nls=yes
+fi
+
+    echo "$ac_t""$nls_cv_use_nls" 1>&6
+
+        if test "$nls_cv_use_nls" = "yes"; then
+      cat >> confdefs.h <<\EOF
+#define ENABLE_NLS 1
+EOF
+
+      echo $ac_n "checking for explicitly using GNU gettext""... $ac_c" 1>&6
+echo "configure:2123: checking for explicitly using GNU gettext" >&5
+      # Check whether --with-gnu-gettext or --without-gnu-gettext was given.
+if test "${with_gnu_gettext+set}" = set; then
+  withval="$with_gnu_gettext"
+  nls_cv_force_use_gnu_gettext=$withval
+else
+  nls_cv_force_use_gnu_gettext=no
+fi
+
+      echo "$ac_t""$nls_cv_force_use_gnu_gettext" 1>&6
+
+      if test "$nls_cv_force_use_gnu_gettext" = "yes"; then
+	nls_cv_use_gnu_gettext=yes
+      else
+				echo $ac_n "checking for main in -lintl""... $ac_c" 1>&6
+echo "configure:2138: checking for main in -lintl" >&5
+ac_lib_var=`echo intl'_'main | sed 'y%./+-%__p_%'`
+if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  ac_save_LIBS="$LIBS"
+LIBS="-lintl  $LIBS"
+cat > conftest.$ac_ext <<EOF
+#line 2146 "configure"
+#include "confdefs.h"
+
+int main() {
+main()
+; return 0; }
+EOF
+if { (eval echo configure:2153: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_lib_$ac_lib_var=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_lib_$ac_lib_var=no"
+fi
+rm -f conftest*
+LIBS="$ac_save_LIBS"
+
+fi
+if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_lib=HAVE_LIB`echo intl | sed -e 's/[^a-zA-Z0-9_]/_/g' \
+    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_lib 1
+EOF
+
+  LIBS="-lintl $LIBS"
+
+else
+  echo "$ac_t""no" 1>&6
+fi
+
+	echo $ac_n "checking for main in -li""... $ac_c" 1>&6
+echo "configure:2181: checking for main in -li" >&5
+ac_lib_var=`echo i'_'main | sed 'y%./+-%__p_%'`
+if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  ac_save_LIBS="$LIBS"
+LIBS="-li  $LIBS"
+cat > conftest.$ac_ext <<EOF
+#line 2189 "configure"
+#include "confdefs.h"
+
+int main() {
+main()
+; return 0; }
+EOF
+if { (eval echo configure:2196: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_lib_$ac_lib_var=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_lib_$ac_lib_var=no"
+fi
+rm -f conftest*
+LIBS="$ac_save_LIBS"
+
+fi
+if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_lib=HAVE_LIB`echo i | sed -e 's/[^a-zA-Z0-9_]/_/g' \
+    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_lib 1
+EOF
+
+  LIBS="-li $LIBS"
+
+else
+  echo "$ac_t""no" 1>&6
+fi
+
+	CATOBJEXT=NONE
+	echo $ac_n "checking for gettext""... $ac_c" 1>&6
+echo "configure:2225: checking for gettext" >&5
+if eval "test \"`echo '$''{'ac_cv_func_gettext'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 2230 "configure"
+#include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char gettext(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char gettext();
+
+int main() {
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_gettext) || defined (__stub___gettext)
+choke me
+#else
+gettext();
+#endif
+
+; return 0; }
+EOF
+if { (eval echo configure:2253: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_func_gettext=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_func_gettext=no"
+fi
+rm -f conftest*
+fi
+
+if eval "test \"`echo '$ac_cv_func_'gettext`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+  cat >> confdefs.h <<\EOF
+#define HAVE_GETTEXT 1
+EOF
+
+	   # Extract the first word of "msgfmt", so it can be a program name with args.
+set dummy msgfmt; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2274: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$MSGFMT" in
+  /*)
+  ac_cv_path_MSGFMT="$MSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_MSGFMT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_MSGFMT" && ac_cv_path_MSGFMT="no"
+  ;;
+esac
+fi
+MSGFMT="$ac_cv_path_MSGFMT"
+if test -n "$MSGFMT"; then
+  echo "$ac_t""$MSGFMT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+   if echo $MSGFMT | grep openwin > /dev/null; then
+     echo "WARNING: Do not use OpenWin's msgfmt.  (Better remove it.) >&6"
+     ac_cv_path_MSGFMT=msgfmt
+     MSGFMT=msgfmt
+   fi
+	   if test "$MSGFMT" != "no"; then
+	     for ac_func in dcgettext
+do
+echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:2311: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 2316 "configure"
+#include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char $ac_func(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char $ac_func();
+
+int main() {
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
+choke me
+#else
+$ac_func();
+#endif
+
+; return 0; }
+EOF
+if { (eval echo configure:2339: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=no"
+fi
+rm -f conftest*
+fi
+
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_func 1
+EOF
+ 
+else
+  echo "$ac_t""no" 1>&6
+fi
+done
+
+	     # Extract the first word of "gmsgfmt", so it can be a program name with args.
+set dummy gmsgfmt; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2366: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$GMSGFMT" in
+  /*)
+  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_GMSGFMT" && ac_cv_path_GMSGFMT="$MSGFMT"
+  ;;
+esac
+fi
+GMSGFMT="$ac_cv_path_GMSGFMT"
+if test -n "$GMSGFMT"; then
+  echo "$ac_t""$GMSGFMT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+   if echo $GMSGFMT | grep openwin > /dev/null; then
+     echo "WARNING: Do not use OpenWin's gmsgfmt.  (Better remove it.) >&6"
+     ac_cv_path_GMSGFMT=gmsgfmt
+     GMSGFMT=gmsgfmt
+   fi
+
+	     # Extract the first word of "xgettext", so it can be a program name with args.
+set dummy xgettext; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2403: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$XGETTEXT" in
+  /*)
+  ac_cv_path_XGETTEXT="$XGETTEXT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_XGETTEXT" && ac_cv_path_XGETTEXT="xgettext"
+  ;;
+esac
+fi
+XGETTEXT="$ac_cv_path_XGETTEXT"
+if test -n "$XGETTEXT"; then
+  echo "$ac_t""$XGETTEXT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+   if echo $XGETTEXT | grep openwin > /dev/null; then
+     echo "WARNING: Do not use OpenWin's xgettext.  (Better remove it.) >&6"
+     ac_cv_path_XGETTEXT=xgettext
+     XGETTEXT=xgettext
+   fi
+
+	     CATOBJEXT=.mo
+	     INSTOBJEXT=.mo
+	     DATADIRNAME=lib
+	   fi
+else
+  echo "$ac_t""no" 1>&6
+fi
+
+
+	if test "$CATOBJEXT" = "NONE"; then
+	  	  echo $ac_n "checking for catgets""... $ac_c" 1>&6
+echo "configure:2448: checking for catgets" >&5
+if eval "test \"`echo '$''{'ac_cv_func_catgets'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 2453 "configure"
+#include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char catgets(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char catgets();
+
+int main() {
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_catgets) || defined (__stub___catgets)
+choke me
+#else
+catgets();
+#endif
+
+; return 0; }
+EOF
+if { (eval echo configure:2476: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_func_catgets=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_func_catgets=no"
+fi
+rm -f conftest*
+fi
+
+if eval "test \"`echo '$ac_cv_func_'catgets`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+  cat >> confdefs.h <<\EOF
+#define HAVE_CATGETS 1
+EOF
+
+	     INTLOBJS="\$(CATOBJS)"
+	     # Extract the first word of "gencat", so it can be a program name with args.
+set dummy gencat; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2498: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_GENCAT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$GENCAT" in
+  /*)
+  ac_cv_path_GENCAT="$GENCAT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_GENCAT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_GENCAT" && ac_cv_path_GENCAT="no"
+  ;;
+esac
+fi
+GENCAT="$ac_cv_path_GENCAT"
+if test -n "$GENCAT"; then
+  echo "$ac_t""$GENCAT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+	     if test "$GENCAT" != "no"; then
+	       for ac_prog in gmsgfmt msgfmt
+do
+# Extract the first word of "$ac_prog", so it can be a program name with args.
+set dummy $ac_prog; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2532: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$GMSGFMT" in
+  /*)
+  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  ;;
+esac
+fi
+GMSGFMT="$ac_cv_path_GMSGFMT"
+if test -n "$GMSGFMT"; then
+  echo "$ac_t""$GMSGFMT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+
+test -n "$GMSGFMT" && break
+done
+test -n "$GMSGFMT" || GMSGFMT="msgfmt"
+
+	       # Extract the first word of "xgettext", so it can be a program name with args.
+set dummy xgettext; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2567: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$XGETTEXT" in
+  /*)
+  ac_cv_path_XGETTEXT="$XGETTEXT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_XGETTEXT" && ac_cv_path_XGETTEXT="xgettext"
+  ;;
+esac
+fi
+XGETTEXT="$ac_cv_path_XGETTEXT"
+if test -n "$XGETTEXT"; then
+  echo "$ac_t""$XGETTEXT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+   if echo $XGETTEXT | grep openwin > /dev/null; then
+     echo "WARNING: Do not use OpenWin's xgettext.  (Better remove it.) >&6"
+     ac_cv_path_XGETTEXT=xgettext
+     XGETTEXT=xgettext
+   fi
+
+	       CATOBJEXT=.cat
+	       INSTOBJEXT=.cat
+	       DATADIRNAME=lib
+	       INTLDEPS="../intl/libintl.a"
+	       INTLLIBS=$INTLDEPS
+	       LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+	       nls_cv_header_intl=intl/libintl.h
+	       nls_cv_header_libgt=intl/libgettext.h
+	     fi
+else
+  echo "$ac_t""no" 1>&6
+fi
+
+	fi
+
+	if test "$CATOBJEXT" = "NONE"; then
+	  	  	  nls_cv_use_gnu_gettext=yes
+	fi
+      fi
+
+      if test "$nls_cv_use_gnu_gettext" = "yes"; then
+		INTLOBJS="\$(GETTOBJS)"
+	# Extract the first word of "msgfmt", so it can be a program name with args.
+set dummy msgfmt; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2626: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$MSGFMT" in
+  /*)
+  ac_cv_path_MSGFMT="$MSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_MSGFMT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_MSGFMT" && ac_cv_path_MSGFMT="msgfmt"
+  ;;
+esac
+fi
+MSGFMT="$ac_cv_path_MSGFMT"
+if test -n "$MSGFMT"; then
+  echo "$ac_t""$MSGFMT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+   if echo $MSGFMT | grep openwin > /dev/null; then
+     echo "WARNING: Do not use OpenWin's msgfmt.  (Better remove it.) >&6"
+     ac_cv_path_MSGFMT=msgfmt
+     MSGFMT=msgfmt
+   fi
+
+	# Extract the first word of "gmsgfmt", so it can be a program name with args.
+set dummy gmsgfmt; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2663: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$GMSGFMT" in
+  /*)
+  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_GMSGFMT" && ac_cv_path_GMSGFMT="$MSGFMT"
+  ;;
+esac
+fi
+GMSGFMT="$ac_cv_path_GMSGFMT"
+if test -n "$GMSGFMT"; then
+  echo "$ac_t""$GMSGFMT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+   if echo $GMSGFMT | grep openwin > /dev/null; then
+     echo "WARNING: Do not use OpenWin's gmsgfmt.  (Better remove it.) >&6"
+     ac_cv_path_GMSGFMT=gmsgfmt
+     GMSGFMT=gmsgfmt
+   fi
+
+	# Extract the first word of "xgettext", so it can be a program name with args.
+set dummy xgettext; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2700: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$XGETTEXT" in
+  /*)
+  ac_cv_path_XGETTEXT="$XGETTEXT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_XGETTEXT" && ac_cv_path_XGETTEXT="xgettext"
+  ;;
+esac
+fi
+XGETTEXT="$ac_cv_path_XGETTEXT"
+if test -n "$XGETTEXT"; then
+  echo "$ac_t""$XGETTEXT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+   if echo $XGETTEXT | grep openwin > /dev/null; then
+     echo "WARNING: Do not use OpenWin's xgettext.  (Better remove it.) >&6"
+     ac_cv_path_XGETTEXT=xgettext
+     XGETTEXT=xgettext
+   fi
+
+	
+	CATOBJEXT=.gmo
+	INSTOBJEXT=.mo
+	DATADIRNAME=share
+	INTLDEPS="../intl/libintl.a"
+	INTLLIBS=$INTLDEPS
+	LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+	nls_cv_header_intl=intl/libintl.h
+	nls_cv_header_libgt=intl/libgettext.h
+      fi
+
+      # We need to process the intl/ and po/ directory.
+      INTLSUB=intl
+      POSUB=po
+    else
+      DATADIRNAME=share
+      nls_cv_header_intl=intl/libintl.h
+      nls_cv_header_libgt=intl/libgettext.h
+    fi
+
+                for lang in $ALL_LINGUAS; do
+      GMOFILES="$GMOFILES $lang.gmo"
+      POFILES="$POFILES $lang.po"
+    done
+
+        
+    
+    
+    
+    
+    
+    
+    
+    
+    
+    
+  
+
+   if test "x$CATOBJEXT" != "x"; then
+     if test "x$ALL_LINGUAS" = "x"; then
+       LINGUAS=
+     else
+       echo $ac_n "checking for catalogs to be installed""... $ac_c" 1>&6
+echo "configure:2777: checking for catalogs to be installed" >&5
+       NEW_LINGUAS=
+       for lang in ${LINGUAS=$ALL_LINGUAS}; do
+	 case "$ALL_LINGUAS" in
+	  *$lang*) NEW_LINGUAS="$NEW_LINGUAS $lang" ;;
+	 esac
+       done
+       LINGUAS=$NEW_LINGUAS
+       echo "$ac_t""$LINGUAS" 1>&6
+     fi
+
+          if test -n "$LINGUAS"; then
+       for lang in $LINGUAS; do CATALOGS="$CATALOGS $lang$CATOBJEXT"; done
+     fi
+   fi
+
+            test -d intl || mkdir intl
+   if test "$CATOBJEXT" = ".cat"; then
+     ac_safe=`echo "linux/version.h" | sed 'y%./+-%__p_%'`
+echo $ac_n "checking for linux/version.h""... $ac_c" 1>&6
+echo "configure:2797: checking for linux/version.h" >&5
+if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 2802 "configure"
+#include "confdefs.h"
+#include <linux/version.h>
+EOF
+ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
+{ (eval echo configure:2807: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+ac_err=`grep -v '^ *+' conftest.out`
+if test -z "$ac_err"; then
+  rm -rf conftest*
+  eval "ac_cv_header_$ac_safe=yes"
+else
+  echo "$ac_err" >&5
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_header_$ac_safe=no"
+fi
+rm -f conftest*
+fi
+if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+  msgformat=linux
+else
+  echo "$ac_t""no" 1>&6
+msgformat=xopen
+fi
+
+
+               sed -e '/^#/d' $srcdir/intl/$msgformat-msg.sed > intl/po2msg.sed
+   fi
+      sed -e '/^#.*[^\\]$/d' -e '/^#$/d' \
+     $srcdir/intl/po2tbl.sed.in > intl/po2tbl.sed
+
+         test -d po || mkdir po
+   if test "x$srcdir" != "x."; then
+     if test "x`echo $srcdir | sed 's@/.*@@'`" = "x"; then
+       posrcprefix="$srcdir/"
+     else
+       posrcprefix="../$srcdir/"
+     fi
+   else
+     posrcprefix="../"
+   fi
+   sed -e "/^#/d" -e "/^\$/d" -e "s,.*, $posrcprefix& \\\\," -e "\$s/\(.*\) \\\\/\1/" \
+	< $srcdir/po/POTFILES.in > po/POTFILES
+  
+ if test "x$wk_link_files_src" = "x"; then
+	wk_link_files_src="$nls_cv_header_libgt"
+	wk_link_files_dst="$nls_cv_header_intl "
+    else
+	wk_link_files_src="$wk_link_files_src $nls_cv_header_libgt"
+	wk_link_files_dst="$wk_link_files_dst $nls_cv_header_intl "
+    fi
+  
+
+
+echo $ac_n "checking for working const""... $ac_c" 1>&6
+echo "configure:2859: checking for working const" >&5
+if eval "test \"`echo '$''{'ac_cv_c_const'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 2864 "configure"
+#include "confdefs.h"
+
+int main() {
+
+/* Ultrix mips cc rejects this.  */
+typedef int charset[2]; const charset x;
+/* SunOS 4.1.1 cc rejects this.  */
+char const *const *ccp;
+char **p;
+/* NEC SVR4.0.2 mips cc rejects this.  */
+struct point {int x, y;};
+static struct point const zero = {0,0};
+/* AIX XL C 1.02.0.0 rejects this.
+   It does not let you subtract one const X* pointer from another in an arm
+   of an if-expression whose if-part is not a constant expression */
+const char *g = "string";
+ccp = &g + (g ? g-g : 0);
+/* HPUX 7.0 cc rejects these. */
+++ccp;
+p = (char**) ccp;
+ccp = (char const *const *) p;
+{ /* SCO 3.2v4 cc rejects this.  */
+  char *t;
+  char const *s = 0 ? (char *) 0 : (char const *) 0;
+
+  *t++ = 0;
+}
+{ /* Someone thinks the Sun supposedly-ANSI compiler will reject this.  */
+  int x[] = {25, 17};
+  const int *foo = &x[0];
+  ++foo;
+}
+{ /* Sun SC1.0 ANSI compiler rejects this -- but not the above. */
+  typedef const int *iptr;
+  iptr p = 0;
+  ++p;
+}
+{ /* AIX XL C 1.02.0.0 rejects this saying
+     "k.c", line 2.27: 1506-025 (S) Operand must be a modifiable lvalue. */
+  struct s { int j; const int *ap[3]; };
+  struct s *b; b->j = 5;
+}
+{ /* ULTRIX-32 V3.1 (Rev 9) vcc rejects this */
+  const int foo = 10;
+}
+
+; return 0; }
+EOF
+if { (eval echo configure:2913: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  ac_cv_c_const=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  ac_cv_c_const=no
+fi
+rm -f conftest*
+fi
+
+echo "$ac_t""$ac_cv_c_const" 1>&6
+if test $ac_cv_c_const = no; then
+  cat >> confdefs.h <<\EOF
+#define const 
+EOF
+
+fi
+
+echo $ac_n "checking for inline""... $ac_c" 1>&6
+echo "configure:2934: checking for inline" >&5
+if eval "test \"`echo '$''{'ac_cv_c_inline'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  ac_cv_c_inline=no
+for ac_kw in inline __inline__ __inline; do
+  cat > conftest.$ac_ext <<EOF
+#line 2941 "configure"
+#include "confdefs.h"
+
+int main() {
+} $ac_kw foo() {
+; return 0; }
+EOF
+if { (eval echo configure:2948: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  ac_cv_c_inline=$ac_kw; break
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+fi
+rm -f conftest*
+done
+
+fi
+
+echo "$ac_t""$ac_cv_c_inline" 1>&6
+case "$ac_cv_c_inline" in
+  inline | yes) ;;
+  no) cat >> confdefs.h <<\EOF
+#define inline 
+EOF
+ ;;
+  *)  cat >> confdefs.h <<EOF
+#define inline $ac_cv_c_inline
+EOF
+ ;;
+esac
+
+echo $ac_n "checking for size_t""... $ac_c" 1>&6
+echo "configure:2974: checking for size_t" >&5
+if eval "test \"`echo '$''{'ac_cv_type_size_t'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 2979 "configure"
+#include "confdefs.h"
+#include <sys/types.h>
+#if STDC_HEADERS
+#include <stdlib.h>
+#include <stddef.h>
+#endif
+EOF
+if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
+  egrep "size_t[^a-zA-Z_0-9]" >/dev/null 2>&1; then
+  rm -rf conftest*
+  ac_cv_type_size_t=yes
+else
+  rm -rf conftest*
+  ac_cv_type_size_t=no
+fi
+rm -f conftest*
+
+fi
+echo "$ac_t""$ac_cv_type_size_t" 1>&6
+if test $ac_cv_type_size_t = no; then
+  cat >> confdefs.h <<\EOF
+#define size_t unsigned
+EOF
+
+fi
+
+
+ if test "$cross_compiling" = yes; then
+	echo "configure: warning: cross compiling; assuming little endianess" 1>&2
+    fi
+    echo $ac_n "checking endianess""... $ac_c" 1>&6
+echo "configure:3011: checking endianess" >&5
+    if eval "test \"`echo '$''{'wk_cv_c_endian'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+   wk_cv_c_endian=unknown
+	# See if sys/param.h defines the BYTE_ORDER macro.
+	cat > conftest.$ac_ext <<EOF
+#line 3018 "configure"
+#include "confdefs.h"
+#include <sys/types.h>
+	#include <sys/param.h>
+int main() {
+
+	#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
+	 bogus endian macros
+	#endif
+; return 0; }
+EOF
+if { (eval echo configure:3029: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  # It does; now see whether it defined to BIG_ENDIAN or not.
+	cat > conftest.$ac_ext <<EOF
+#line 3033 "configure"
+#include "confdefs.h"
+#include <sys/types.h>
+	#include <sys/param.h>
+int main() {
+
+	#if BYTE_ORDER != BIG_ENDIAN
+	 not big endian
+	#endif
+; return 0; }
+EOF
+if { (eval echo configure:3044: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  wk_cv_c_endian=big
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  wk_cv_c_endian=big
+fi
+rm -f conftest*
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+fi
+rm -f conftest*
+	if test "$wk_cv_c_endian" = unknown; then
+	    if test "$cross_compiling" = yes; then
+  wk_cv_c_endian=little
+	    
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3065 "configure"
+#include "confdefs.h"
+main () {
+	      /* Are we little or big endian?  From Harbison&Steele.  */
+	      union
+	      {
+		long l;
+		char c[sizeof (long)];
+	      } u;
+	      u.l = 1;
+	      exit (u.c[sizeof (long) - 1] == 1);
+	      }
+EOF
+if { (eval echo configure:3078: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+then
+  wk_cv_c_endian=little
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -fr conftest*
+  wk_cv_c_endian=big
+fi
+rm -fr conftest*
+fi
+
+	fi
+      
+fi
+
+    echo "$ac_t""$wk_cv_c_endian" 1>&6
+    if test "$wk_cv_c_endian" = little; then
+      cat >> confdefs.h <<\EOF
+#define LITTLE_ENDIAN_HOST 1
+EOF
+
+    else
+      cat >> confdefs.h <<\EOF
+#define BIG_ENDIAN_HOST 1
+EOF
+
+    fi
+  
+
+
+ echo $ac_n "checking for byte typedef""... $ac_c" 1>&6
+echo "configure:3110: checking for byte typedef" >&5
+    if eval "test \"`echo '$''{'wk_cv_typedef_byte'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3115 "configure"
+#include "confdefs.h"
+#include <stdlib.h>
+    #include <sys/types.h>
+int main() {
+
+    #undef byte
+    int a = sizeof(byte);
+    
+; return 0; }
+EOF
+if { (eval echo configure:3126: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  wk_cv_typedef_byte=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  wk_cv_typedef_byte=no 
+fi
+rm -f conftest*
+fi
+
+    echo "$ac_t""$wk_cv_typedef_byte" 1>&6
+    if test "$wk_cv_typedef_byte" = yes; then
+	cat >> confdefs.h <<\EOF
+#define HAVE_BYTE_TYPEDEF 1
+EOF
+
+    fi
+  
+ echo $ac_n "checking for ushort typedef""... $ac_c" 1>&6
+echo "configure:3147: checking for ushort typedef" >&5
+    if eval "test \"`echo '$''{'wk_cv_typedef_ushort'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3152 "configure"
+#include "confdefs.h"
+#include <stdlib.h>
+    #include <sys/types.h>
+int main() {
+
+    #undef ushort
+    int a = sizeof(ushort);
+    
+; return 0; }
+EOF
+if { (eval echo configure:3163: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  wk_cv_typedef_ushort=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  wk_cv_typedef_ushort=no 
+fi
+rm -f conftest*
+fi
+
+    echo "$ac_t""$wk_cv_typedef_ushort" 1>&6
+    if test "$wk_cv_typedef_ushort" = yes; then
+	cat >> confdefs.h <<\EOF
+#define HAVE_USHORT_TYPEDEF 1
+EOF
+
+    fi
+  
+ echo $ac_n "checking for ulong typedef""... $ac_c" 1>&6
+echo "configure:3184: checking for ulong typedef" >&5
+    if eval "test \"`echo '$''{'wk_cv_typedef_ulong'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3189 "configure"
+#include "confdefs.h"
+#include <stdlib.h>
+    #include <sys/types.h>
+int main() {
+
+    #undef ulong
+    int a = sizeof(ulong);
+    
+; return 0; }
+EOF
+if { (eval echo configure:3200: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  wk_cv_typedef_ulong=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  wk_cv_typedef_ulong=no 
+fi
+rm -f conftest*
+fi
+
+    echo "$ac_t""$wk_cv_typedef_ulong" 1>&6
+    if test "$wk_cv_typedef_ulong" = yes; then
+	cat >> confdefs.h <<\EOF
+#define HAVE_ULONG_TYPEDEF 1
+EOF
+
+    fi
+  
+ echo $ac_n "checking for u16 typedef""... $ac_c" 1>&6
+echo "configure:3221: checking for u16 typedef" >&5
+    if eval "test \"`echo '$''{'wk_cv_typedef_u16'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3226 "configure"
+#include "confdefs.h"
+#include <stdlib.h>
+    #include <sys/types.h>
+int main() {
+
+    #undef u16
+    int a = sizeof(u16);
+    
+; return 0; }
+EOF
+if { (eval echo configure:3237: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  wk_cv_typedef_u16=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  wk_cv_typedef_u16=no 
+fi
+rm -f conftest*
+fi
+
+    echo "$ac_t""$wk_cv_typedef_u16" 1>&6
+    if test "$wk_cv_typedef_u16" = yes; then
+	cat >> confdefs.h <<\EOF
+#define HAVE_U16_TYPEDEF 1
+EOF
+
+    fi
+  
+ echo $ac_n "checking for u32 typedef""... $ac_c" 1>&6
+echo "configure:3258: checking for u32 typedef" >&5
+    if eval "test \"`echo '$''{'wk_cv_typedef_u32'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3263 "configure"
+#include "confdefs.h"
+#include <stdlib.h>
+    #include <sys/types.h>
+int main() {
+
+    #undef u32
+    int a = sizeof(u32);
+    
+; return 0; }
+EOF
+if { (eval echo configure:3274: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  wk_cv_typedef_u32=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  wk_cv_typedef_u32=no 
+fi
+rm -f conftest*
+fi
+
+    echo "$ac_t""$wk_cv_typedef_u32" 1>&6
+    if test "$wk_cv_typedef_u32" = yes; then
+	cat >> confdefs.h <<\EOF
+#define HAVE_U32_TYPEDEF 1
+EOF
+
+    fi
+  
+
+echo $ac_n "checking size of unsigned short""... $ac_c" 1>&6
+echo "configure:3296: checking size of unsigned short" >&5
+if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_short'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  if test "$cross_compiling" = yes; then
+  ac_cv_sizeof_unsigned_short=2
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3304 "configure"
+#include "confdefs.h"
+#include <stdio.h>
+main()
+{
+  FILE *f=fopen("conftestval", "w");
+  if (!f) exit(1);
+  fprintf(f, "%d\n", sizeof(unsigned short));
+  exit(0);
+}
+EOF
+if { (eval echo configure:3315: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+then
+  ac_cv_sizeof_unsigned_short=`cat conftestval`
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -fr conftest*
+  ac_cv_sizeof_unsigned_short=0
+fi
+rm -fr conftest*
+fi
+
+fi
+echo "$ac_t""$ac_cv_sizeof_unsigned_short" 1>&6
+cat >> confdefs.h <<EOF
+#define SIZEOF_UNSIGNED_SHORT $ac_cv_sizeof_unsigned_short
+EOF
+
+
+echo $ac_n "checking size of unsigned int""... $ac_c" 1>&6
+echo "configure:3335: checking size of unsigned int" >&5
+if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_int'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  if test "$cross_compiling" = yes; then
+  ac_cv_sizeof_unsigned_int=4
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3343 "configure"
+#include "confdefs.h"
+#include <stdio.h>
+main()
+{
+  FILE *f=fopen("conftestval", "w");
+  if (!f) exit(1);
+  fprintf(f, "%d\n", sizeof(unsigned int));
+  exit(0);
+}
+EOF
+if { (eval echo configure:3354: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+then
+  ac_cv_sizeof_unsigned_int=`cat conftestval`
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -fr conftest*
+  ac_cv_sizeof_unsigned_int=0
+fi
+rm -fr conftest*
+fi
+
+fi
+echo "$ac_t""$ac_cv_sizeof_unsigned_int" 1>&6
+cat >> confdefs.h <<EOF
+#define SIZEOF_UNSIGNED_INT $ac_cv_sizeof_unsigned_int
+EOF
+
+
+echo $ac_n "checking size of unsigned long""... $ac_c" 1>&6
+echo "configure:3374: checking size of unsigned long" >&5
+if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_long'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
 else
   if test "$cross_compiling" = yes; then
   ac_cv_sizeof_unsigned_long=4
 else
   cat > conftest.$ac_ext <<EOF
-#line 1742 "configure"
+#line 3382 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 main()
@@ -1749,7 +3389,7 @@
   exit(0);
 }
 EOF
-if { (eval echo configure:1753: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:3393: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_unsigned_long=`cat conftestval`
 else
@@ -1778,12 +3418,12 @@
 
 
 echo $ac_n "checking for vprintf""... $ac_c" 1>&6
-echo "configure:1782: checking for vprintf" >&5
+echo "configure:3422: checking for vprintf" >&5
 if eval "test \"`echo '$''{'ac_cv_func_vprintf'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1787 "configure"
+#line 3427 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char vprintf(); below.  */
@@ -1806,7 +3446,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:1810: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3450: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_vprintf=yes"
 else
@@ -1830,12 +3470,12 @@
 
 if test "$ac_cv_func_vprintf" != yes; then
 echo $ac_n "checking for _doprnt""... $ac_c" 1>&6
-echo "configure:1834: checking for _doprnt" >&5
+echo "configure:3474: checking for _doprnt" >&5
 if eval "test \"`echo '$''{'ac_cv_func__doprnt'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1839 "configure"
+#line 3479 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char _doprnt(); below.  */
@@ -1858,7 +3498,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:1862: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3502: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func__doprnt=yes"
 else
@@ -1882,15 +3522,15 @@
 
 fi
 
-for ac_func in strerror stpcpy strlwr tcgetattr rand strtoul
+for ac_func in strerror stpcpy strlwr tcgetattr rand strtoul mlock mmap
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:1889: checking for $ac_func" >&5
+echo "configure:3529: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1894 "configure"
+#line 3534 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -1913,7 +3553,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:1917: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3557: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -1942,7 +3582,7 @@
 
 
 echo $ac_n "checking for random device""... $ac_c" 1>&6
-echo "configure:1946: checking for random device" >&5
+echo "configure:3586: checking for random device" >&5
 if eval "test \"`echo '$''{'ac_cv_have_dev_random'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1960,7 +3600,7 @@
 
 
 echo $ac_n "checking for mpi assembler functions""... $ac_c" 1>&6
-echo "configure:1964: checking for mpi assembler functions" >&5
+echo "configure:3604: checking for mpi assembler functions" >&5
 mpi_config_done="no"
 if eval "test \"`echo '$''{'ac_cv_mpi_config_done'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1974,8 +3614,15 @@
 ac_cv_mpi_config_done=""
 if test -f $srcdir/mpi/config.links ; then
     . $srcdir/mpi/config.links
+     if test "x$wk_link_files_src" = "x"; then
+	wk_link_files_src="$mpi_ln_src"
+	wk_link_files_dst="$mpi_ln_dst"
+    else
+	wk_link_files_src="$wk_link_files_src $mpi_ln_src"
+	wk_link_files_dst="$wk_link_files_dst $mpi_ln_dst"
+    fi
+  
     ac_cv_mpi_extra_asm_modules="$mpi_extra_modules"
-    
     ac_cv_mpi_config_done="yes"
     echo "$ac_t""done" 1>&6
 else
@@ -1985,9 +3632,11 @@
 fi
 MPI_EXTRA_ASM_OBJS=""
 if test "$ac_cv_mpi_extra_asm_modules" != ""; then
-echo $ac_n "mpi extra asm functions:"" $ac_c" 1>&6 
+ echo $ac_n "mpi extra asm functions:"" $ac_c" 1>&6
+  
 for i in $ac_cv_mpi_extra_asm_modules; do
-    echo $ac_n "$i"" $ac_c" 1>&6 
+     echo $ac_n "$i"" $ac_c" 1>&6
+  
     MPI_EXTRA_ASM_OBJS="$MPI_EXTRA_ASM_OBJS $i.o"
 done
 echo "$ac_t""" 1>&6
@@ -1999,17 +3648,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2003: checking for $ac_hdr" >&5
+echo "configure:3652: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2008 "configure"
+#line 3657 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2013: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3662: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2041,7 +3690,7 @@
 CIPHER_EXTRA_OBJS=""
 CIPHER_EXTRA_DIST=""
 echo $ac_n "checking for extra cipher modules""... $ac_c" 1>&6
-echo "configure:2045: checking for extra cipher modules" >&5
+echo "configure:3694: checking for extra cipher modules" >&5
 if eval "test \"`echo '$''{'ac_cv_have_rsa_cipher'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2061,6 +3710,10 @@
 
 
 
+
+ 
+  
+
 trap '' 1 2 15
 cat > confcache <<\EOF
 # This file is a shell script that caches the results of configure
@@ -2162,12 +3815,15 @@
 ac_given_srcdir=$srcdir
 ac_given_INSTALL="$INSTALL"
 
-trap 'rm -fr `echo " Makefile	\
-	    util/Makefile    \
-	    mpi/Makefile \
-	    cipher/Makefile \
-	    g10/Makefile     \
-	    tools/Makefile   \
+trap 'rm -fr `echo "
+Makefile
+intl/Makefile
+po/Makefile.in
+util/Makefile
+mpi/Makefile
+cipher/Makefile
+g10/Makefile
+tools/Makefile
  config.h" | sed "s/:[^ ]*//g"` conftest*; exit 1' 1 2 15
 EOF
 cat >> $CONFIG_STATUS <<EOF
@@ -2200,6 +3856,7 @@
 s%@mandir@%$mandir%g
 s%@VERSION@%$VERSION%g
 s%@PACKAGE@%$PACKAGE%g
+s%@G10_LOCALEDIR@%$G10_LOCALEDIR%g
 s%@host@%$host%g
 s%@host_alias@%$host_alias%g
 s%@host_cpu@%$host_cpu%g
@@ -2221,6 +3878,22 @@
 s%@INSTALL_DATA@%$INSTALL_DATA%g
 s%@CC@%$CC%g
 s%@CPP@%$CPP%g
+s%@ALLOCA@%$ALLOCA%g
+s%@MSGFMT@%$MSGFMT%g
+s%@GMSGFMT@%$GMSGFMT%g
+s%@XGETTEXT@%$XGETTEXT%g
+s%@GENCAT@%$GENCAT%g
+s%@CATALOGS@%$CATALOGS%g
+s%@CATOBJEXT@%$CATOBJEXT%g
+s%@DATADIRNAME@%$DATADIRNAME%g
+s%@GMOFILES@%$GMOFILES%g
+s%@INSTOBJEXT@%$INSTOBJEXT%g
+s%@INTLDEPS@%$INTLDEPS%g
+s%@INTLLIBS@%$INTLLIBS%g
+s%@INTLOBJS@%$INTLOBJS%g
+s%@INTLSUB@%$INTLSUB%g
+s%@POFILES@%$POFILES%g
+s%@POSUB@%$POSUB%g
 s%@MPI_EXTRA_ASM_OBJS@%$MPI_EXTRA_ASM_OBJS%g
 s%@CIPHER_EXTRA_OBJS@%$CIPHER_EXTRA_OBJS%g
 s%@CIPHER_EXTRA_DIST@%$CIPHER_EXTRA_DIST%g
@@ -2265,12 +3938,14 @@
 
 cat >> $CONFIG_STATUS <<EOF
 
-CONFIG_FILES=\${CONFIG_FILES-"Makefile	\
-	    util/Makefile    \
-	    mpi/Makefile \
-	    cipher/Makefile \
-	    g10/Makefile     \
-	    tools/Makefile   \
+CONFIG_FILES=\${CONFIG_FILES-"Makefile
+intl/Makefile
+po/Makefile.in
+util/Makefile
+mpi/Makefile
+cipher/Makefile
+g10/Makefile
+tools/Makefile
 "}
 EOF
 cat >> $CONFIG_STATUS <<\EOF
@@ -2440,8 +4115,8 @@
 EOF
 
 cat >> $CONFIG_STATUS <<EOF
-ac_sources="${mpi_ln_src}"
-ac_dests="${mpi_ln_dst} "
+ac_sources="$wk_link_files_src"
+ac_dests="$wk_link_files_dst "
 EOF
 
 cat >> $CONFIG_STATUS <<\EOF
@@ -2487,7 +4162,7 @@
 
 EOF
 cat >> $CONFIG_STATUS <<\EOF
-echo timestamp > stamp-h  
+echo timestamp >stamp-h; sed -e "/POTFILES =/r po/POTFILES" po/Makefile.in > po/Makefile
 exit 0
 EOF
 chmod +x $CONFIG_STATUS
diff -urN g10-0.2.0/configure.in g10-0.2.1/configure.in
--- g10-0.2.0/configure.in	Thu Jan 22 18:41:16 1998
+++ g10-0.2.1/configure.in	Wed Jan 28 14:33:16 1998
@@ -8,12 +8,27 @@
 AC_CONFIG_HEADER(config.h)
 
 
+if test "x$exec_prefix" = xNONE ; then
+    if test "x$prefix" = xNONE ; then
+	g10_prefix="$ac_default_prefix"
+    else
+	g10_prefix="$prefix"
+    fi
+else
+    g10_prefix="$exec_prefix"
+fi
+
+
 VERSION=`cat $srcdir/VERSION`
 PACKAGE=g10
+ALL_LINGUAS="de"
+G10_LOCALEDIR="$g10_prefix/share/locale"
 AC_SUBST(VERSION)
 AC_SUBST(PACKAGE)
+AC_SUBST(G10_LOCALEDIR)
 AC_DEFINE_UNQUOTED(VERSION, "$VERSION")
 AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE")
+AC_DEFINE_UNQUOTED(G10_LOCALEDIR, "$G10_LOCALEDIR")
 
 AC_ARG_ENABLE(m-debug,
 [  --enable-m-debug    Enable debugging of memory allocation])
@@ -22,44 +37,10 @@
 fi
 CFLAGS="-g -Wall"
 
-dnl some additional macros
-
-dnl WK_MSG_PRINT(STRING)
-define(WK_MSG_PRINT,
-[echo $ac_n "$1"" $ac_c" 1>&AC_FD_MSG ])
-
-dnl WK_CHECK_TYPEDEF(TYPE, HAVE_NAME)
-AC_DEFUN(WK_CHECK_TYPEDEF,
-[AC_MSG_CHECKING(for $1 typedef)
-AC_CACHE_VAL(wk_cv_typedef_$1,
-[AC_TRY_COMPILE([#include <stdlib.h>
-#include <sys/types.h>], [
-#undef $1
-int a = sizeof($1);
-], wk_cv_typedef_$1=yes, wk_cv_typedef_$1=no )])
-AC_MSG_RESULT($wk_cv_typedef_$1)
-if test "$wk_cv_typedef_$1" = yes; then
-    AC_DEFINE($2)
-fi
-])
-
 
 
-
-dnl
 AC_CANONICAL_SYSTEM
-AC_MSG_CHECKING(cached information)
-hostcheck="$target"
-AC_CACHE_VAL(ac_cv_mpi_hostcheck, [ ac_cv_mpi_hostcheck="$hostcheck" ])
-if test "$ac_cv_mpi_hostcheck" != "$hostcheck"; then
-    AC_MSG_RESULT(changed)
-    AC_MSG_WARN(config.cache exists!)
-    AC_MSG_ERROR(you must do 'make distclean' first to compile for
-different target or different parameters.)
-else
-    AC_MSG_RESULT(ok)
-fi
-
+WK_CHECK_CACHE
 
 dnl Checks for programs.
 
@@ -91,49 +72,16 @@
 AC_HEADER_STDC
 AC_CHECK_HEADERS(unistd.h)
 
+ud_GNU_GETTEXT
+WK_LINK_FILES($nls_cv_header_libgt, $nls_cv_header_intl )
+
 
 dnl Checks for typedefs, structures, and compiler characteristics.
 AC_C_CONST
 AC_C_INLINE
 AC_TYPE_SIZE_T
 
-
-dnl autoconf doesn't support a default value for AC_C_BIGENDIAN
-dnl so here is the modified version
-if test "$cross_compiling" = yes; then
-    AC_MSG_WARN(cross compiling; assuming little endianess)
-fi
-AC_CACHE_CHECK(for little endianess, ac_cv_c_littleendian,
-[ac_cv_c_littleendian=unknown
-# See if sys/param.h defines the BYTE_ORDER macro.
-AC_TRY_COMPILE([#include <sys/types.h>
-#include <sys/param.h>], [
-#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
- bogus endian macros
-#endif], [# It does; now see whether it defined to BIG_ENDIAN or not.
-AC_TRY_COMPILE([#include <sys/types.h>
-#include <sys/param.h>], [
-#if BYTE_ORDER != BIG_ENDIAN
- not big endian
-#endif], ac_cv_c_littleendian=no, ac_cv_c_littleendian=yes)])
-if test "$ac_cv_c_littleendian" = unknown; then
-AC_TRY_RUN([main () {
-  /* Are we little or big endian?  From Harbison&Steele.  */
-  union
-  {
-    long l;
-    char c[sizeof (long)];
-  } u;
-  u.l = 1;
-  exit (u.c[sizeof (long) - 1] == 1);
-}], ac_cv_c_littleendian=yes, ac_cv_c_littleendian=no, ac_cv_c_littleendian=yes)
-fi])
-
-if test "$ac_cv_c_littleendian" = yes; then
-  AC_DEFINE(LITTLE_ENDIAN_HOST)
-else
-  AC_DEFINE(BIG_ENDIAN_HOST)
-fi
+WK_CHECK_ENDIAN
 
 
 WK_CHECK_TYPEDEF(byte, HAVE_BYTE_TYPEDEF)
@@ -156,7 +104,7 @@
 
 dnl Checks for library functions.
 AC_FUNC_VPRINTF
-AC_CHECK_FUNCS(strerror stpcpy strlwr tcgetattr rand strtoul)
+AC_CHECK_FUNCS(strerror stpcpy strlwr tcgetattr rand strtoul mlock mmap)
 
 
 
@@ -181,8 +129,8 @@
 ac_cv_mpi_config_done=""
 if test -f $srcdir/mpi/config.links ; then
     . $srcdir/mpi/config.links
+    WK_LINK_FILES($mpi_ln_src, $mpi_ln_dst)
     ac_cv_mpi_extra_asm_modules="$mpi_extra_modules"
-    AC_LINK_FILES( ${mpi_ln_src}, ${mpi_ln_dst} )
     ac_cv_mpi_config_done="yes"
     AC_MSG_RESULT(done)
 else
@@ -223,11 +171,17 @@
 AC_SUBST(CIPHER_EXTRA_OBJS)
 AC_SUBST(CIPHER_EXTRA_DIST)
 
-AC_OUTPUT([ Makefile	\
-	    util/Makefile    \
-	    mpi/Makefile \
-	    cipher/Makefile \
-	    g10/Makefile     \
-	    tools/Makefile   \
-], [echo timestamp > stamp-h ] )
+
+WK_DO_LINK_FILES
+
+AC_OUTPUT([
+Makefile
+intl/Makefile
+po/Makefile.in
+util/Makefile
+mpi/Makefile
+cipher/Makefile
+g10/Makefile
+tools/Makefile
+],[echo timestamp >stamp-h; sed -e "/POTFILES =/r po/POTFILES" po/Makefile.in > po/Makefile])
 
diff -urN g10-0.2.0/g10/Makefile.am g10-0.2.1/g10/Makefile.am
--- g10-0.2.0/g10/Makefile.am	Wed Jan 14 17:07:47 1998
+++ g10-0.2.1/g10/Makefile.am	Tue Jan 27 15:56:44 1998
@@ -41,11 +41,13 @@
 	      seskey.c		\
 	      sign.c		\
 	      import.c		\
+	      export.c		\
 	      comment.c 	\
 	      sig-check.c
 
 
-LDADD = -L ../cipher -L ../mpi -L ../util -lcipher -lmpi -lutil
+LDADD = -L ../cipher -L ../mpi -L ../util \
+	-lcipher -lmpi -lutil
 
 
 $(PROGRAMS): ../cipher/libcipher.a ../mpi/libmpi.a ../util/libutil.a
diff -urN g10-0.2.0/g10/Makefile.in g10-0.2.1/g10/Makefile.in
--- g10-0.2.0/g10/Makefile.in	Sun Jan 25 20:22:13 1998
+++ g10-0.2.1/g10/Makefile.in	Wed Jan 28 16:36:57 1998
@@ -79,10 +79,12 @@
 	      seskey.c		\
 	      sign.c		\
 	      import.c		\
+	      export.c		\
 	      comment.c 	\
 	      sig-check.c
 
-LDADD = -L ../cipher -L ../mpi -L ../util -lcipher -lmpi -lutil
+LDADD = -L ../cipher -L ../mpi -L ../util \
+	-lcipher -lmpi -lutil
 mkinstalldirs = $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ../config.h
 PROGRAMS = $(bin_PROGRAMS)
@@ -104,7 +106,7 @@
 free-packet.o getkey.o pkclist.o skclist.o ringedit.o kbnode.o keygen.o \
 mainproc.o armor.o mdfilter.o textfilter.o cipher.o elg.o rsa.o \
 openfile.o keyid.o trustdb.o parse-packet.o passphrase.o plaintext.o \
-pubkey-enc.o seckey-cert.o seskey.o sign.o import.o comment.o \
+pubkey-enc.o seckey-cert.o seskey.o sign.o import.o export.o comment.o \
 sig-check.o
 EXTRA_g10_SOURCES =
 g10_LDADD = $(LDADD)
@@ -257,6 +259,14 @@
  ../include/../cipher/sha1.h ../include/../cipher/rsa.h \
  ../include/../cipher/blowfish.h ../include/../cipher/gost.h \
  ../include/../cipher/elgamal.h filter.h
+export.o: export.c options.h packet.h ../include/types.h \
+ ../include/iobuf.h ../include/mpi.h ../include/memory.h \
+ ../include/cipher.h ../include/../cipher/md.h \
+ ../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+ ../include/../cipher/md5.h ../include/../cipher/rsa.h \
+ ../include/../cipher/blowfish.h ../include/../cipher/gost.h \
+ ../include/../cipher/elgamal.h filter.h ../include/errors.h keydb.h \
+ ../include/util.h
 free-packet.o: free-packet.c packet.h ../include/types.h \
  ../include/iobuf.h ../include/mpi.h ../include/memory.h \
  ../include/cipher.h ../include/../cipher/md.h \
@@ -272,7 +282,7 @@
  ../include/../cipher/rsa.h ../include/../cipher/blowfish.h \
  ../include/../cipher/gost.h ../include/../cipher/elgamal.h filter.h \
  ../include/util.h ../include/errors.h main.h keydb.h options.h \
- trustdb.h ../include/ttyio.h
+ trustdb.h ../include/ttyio.h ../include/i18n.h
 getkey.o: getkey.c ../include/util.h ../include/types.h \
  ../include/errors.h ../include/mpi.h ../include/iobuf.h \
  ../include/memory.h packet.h ../include/cipher.h \
@@ -303,7 +313,7 @@
  ../include/../cipher/sha1.h ../include/../cipher/md5.h \
  ../include/../cipher/rsa.h ../include/../cipher/blowfish.h \
  ../include/../cipher/gost.h ../include/../cipher/elgamal.h keydb.h \
- packet.h filter.h ../include/ttyio.h options.h
+ packet.h filter.h ../include/ttyio.h options.h ../include/i18n.h
 keyid.o: keyid.c ../include/util.h ../include/types.h \
  ../include/errors.h ../include/mpi.h ../include/iobuf.h \
  ../include/memory.h main.h ../include/cipher.h \
@@ -356,7 +366,7 @@
  ../include/../cipher/md5.h ../include/../cipher/rsa.h \
  ../include/../cipher/blowfish.h ../include/../cipher/gost.h \
  ../include/../cipher/elgamal.h filter.h ../include/errors.h keydb.h \
- ../include/util.h trustdb.h ../include/ttyio.h
+ ../include/util.h trustdb.h ../include/ttyio.h ../include/i18n.h
 plaintext.o: plaintext.c ../include/util.h ../include/types.h \
  ../include/errors.h ../include/mpi.h ../include/iobuf.h \
  ../include/memory.h options.h packet.h ../include/cipher.h \
diff -urN g10-0.2.0/g10/OPTIONS g10-0.2.1/g10/OPTIONS
--- g10-0.2.0/g10/OPTIONS	Wed Jan  7 13:03:35 1998
+++ g10-0.2.1/g10/OPTIONS	Mon Jan 26 13:23:55 1998
@@ -42,6 +42,12 @@
 # (Can be combined with a "sign")
 # encrypt data
 
+export <names>
+# Either export all keys from all keyrings (default keyrings and
+# those registered via option "keyring"), or if at least one name is
+# given, those of the givename. The new keyring is written to stdout
+# or to the file given with option "output"
+
 fingerprint
 # show the fingerprints,
 
diff -urN g10-0.2.0/g10/armor.c g10-0.2.1/g10/armor.c
--- g10-0.2.0/g10/armor.c	Fri Jan 16 12:52:52 1998
+++ g10-0.2.1/g10/armor.c	Tue Jan 27 13:29:52 1998
@@ -49,25 +49,30 @@
 static byte asctobin[256]; /* runtime initialized */
 static int is_initialized;
 
+
 typedef enum {
-    fhdrINIT=0,
-    fhdrLF,
-    fhdrWAIT,
-    fhdrWAITINFO,
-    fhdrWAITCLEARSIG,
-    fhdrDASH,
-    fhdrHEAD,
-    fhdrDASH2,
-    fhdrINFO
+    fhdrHASArmor,
+    fhdrNOArmor,
+    fhdrINIT,
+    fhdrINITCont,
+    fhdrINITSkip,
+    fhdrCHECKBegin,
+    fhdrWAITHeader,
+    fhdrWAITClearsig,
+    fhdrSKIPHeader,
+    fhdrCLEARSIG,
+    fhdrREADClearsig,
+    fhdrEMPTYClearsig,
+    fhdrCHECKClearsig,
+    fhdrCHECKClearsig2,
+    fhdrREADClearsigNext,
+    fhdrENDClearsig,
+    fhdrTEXT,
+    fhdrERROR,
+    fhdrERRORShow,
+    fhdrEOF
 } fhdr_state_t;
 
-struct fhdr_struct {
-    fhdr_state_t state;
-    int count;
-    int hdr_line; /* number of the header line */
-    char buf[256];
-};
-
 
 /* if we encounter this armor string with this index, go
  * into a mode, which fakes packets and wait for the next armor */
@@ -87,6 +92,10 @@
 };
 
 
+static fhdr_state_t find_header( fhdr_state_t state,
+			  byte *buf, size_t *r_buflen, IOBUF a, size_t n);
+
+
 static void
 initialize(void)
 {
@@ -124,18 +133,14 @@
  * Returns: True if it seems to be armored
  */
 static int
-is_armored( byte *buf, size_t len )
+is_armored( byte *buf )
 {
     int ctb, pkttype;
 
-    if( len < 28 )
-	return 0; /* not even enough space for the "---BEGIN"... */
-
     ctb = *buf;
     if( !(ctb & 0x80) )
 	return 1; /* invalid packet: assume it is armored */
     pkttype =  ctb & 0x40 ? (ctb & 0x3f) : ((ctb>>2)&0xf);
-    /*lenbytes = (ctb & 0x40) || ((ctb&3)==3)? 0 : (1<<(ctb & 3));*/
     switch( pkttype ) {
       case PKT_PUBLIC_CERT:
       case PKT_SECRET_CERT:
@@ -152,120 +157,246 @@
 }
 
 
-
-
-static int
-find_header( struct fhdr_struct *fhdr, int c )
+/****************
+ * parse an ascii armor.
+ * Returns: the state,
+ *	    the remaining bytes in BUF are returned in RBUFLEN.
+ */
+static fhdr_state_t
+find_header( fhdr_state_t state, byte *buf, size_t *r_buflen, IOBUF a, size_t n)
 {
-    int i;
+    int c, i;
     const char *s;
+    char *p;
+    size_t buflen;
+    int cont;
+    int clearsig=0;
+    int hdr_line=0;
+
+    buflen = *r_buflen;
+    assert(buflen >= 100 );
+    buflen--;
+
+    do {
+	switch( state ) {
+	  case fhdrHASArmor:
+	    /* read 28 bytes, which is the bare minimum for a BEGIN...
+	     * and check wether this has a Armor. */
+	    c = 0;
+	    for(n=0; n < 28 && (c=iobuf_get(a)) != -1 && c != '\n'; )
+		buf[n++] = c;
+	    if( n < 28 || c == -1 )
+		state = fhdrNOArmor; /* too short */
+	    else if( !is_armored( buf ) )
+		state = fhdrNOArmor;
+	    else
+		state = fhdrINITCont;
+	    break;
 
-    if( c == '\n' ) {
-	switch( fhdr->state ) {
-	  case fhdrINFO:
-	    if( !fhdr->count )
-		return 1;   /* blank line: data starts with the next line */
-	    fhdr->buf[fhdr->count] = 0;
-	    log_debug("armor line: '%s'\n", fhdr->buf );
-	    /* fall through */
-	  case fhdrWAITINFO:
-	    fhdr->state = fhdrINFO;
-	    fhdr->count = 0;
-	    break;
-	  case fhdrWAITCLEARSIG:
-	    if( fhdr->count++ == 1 ) /* skip the empty line */
-		return 1; /* clear signed text follows */
-	    else if( fhdr->count > 1 )
-		fhdr->state = fhdrWAIT; /* was not valid */
+	  case fhdrINIT: /* read some stuff into buffer */
+	    n = 0;
+	  case fhdrINITCont: /* read more stuff into buffer */
+	    c = 0;
+	    for(; n < buflen && (c=iobuf_get(a)) != -1 && c != '\n'; )
+		buf[n++] = c;
+	    state = c == '\n' ? fhdrCHECKBegin :
+		     c == -1  ? fhdrEOF : fhdrINITSkip;
 	    break;
-	  default:
-	    fhdr->state = fhdrLF;
+
+	  case fhdrINITSkip:
+	    while( (c=iobuf_get(a)) != -1 && c != '\n' )
+		;
+	    state =  c == -1? fhdrEOF : fhdrINIT;
 	    break;
-	}
-    }
-    else {
-	switch( fhdr->state ) {
-	  case fhdrINIT:
-	  case fhdrLF:
-	    if( c == '-' ) {
-		fhdr->state = fhdrDASH;
-		fhdr->count = 1;
-	    }
-	    else
-		fhdr->state = fhdrWAIT;
+
+	  case fhdrSKIPHeader:
+	    while( (c=iobuf_get(a)) != -1 && c != '\n' )
+		;
+	    state =  c == -1? fhdrEOF : fhdrWAITHeader;
 	    break;
-	  case fhdrWAIT:
-	  case fhdrWAITINFO:
-	  case fhdrWAITCLEARSIG:
-	    break;
-	  case fhdrDASH:
-	    if( c == '-' ) {
-		if( ++fhdr->count == 5 ) {
-		    fhdr->state = fhdrHEAD;
-		    fhdr->count = 0;
+
+	  case fhdrWAITHeader: /* wait for Header lines */
+	    c = 0;
+	    for(n=0; n < buflen && (c=iobuf_get(a)) != -1 && c != '\n'; )
+		buf[n++] = c;
+	    buf[n] = 0;
+	    if( n < buflen || c == '\n' ) {
+		if( n && buf[0] != '\r') { /* maybe a header */
+		    if( strchr( buf, ':') ) { /* yes */
+			log_debug("armor header: ");
+			print_string( stderr, buf, n );
+			putc('\n', stderr);
+			state = fhdrWAITHeader;
+		    }
+		    else
+			state = fhdrTEXT;
+		}
+		else if( !n || (buf[0] == '\r' && !buf[1]) ) { /* empty line */
+		    if( clearsig )
+			state = fhdrWAITClearsig;
+		    else {
+			/* this is not really correct: if we do not have
+			 * a clearsig and not armor lines we are not allowed
+			 * to have an empty line */
+			n = 0;
+			state = fhdrTEXT;
+		    }
+		}
+		else {
+		    log_debug("invalid armor header: ");
+		    print_string( stderr, buf, n );
+		    putc('\n', stderr);
+		    state = fhdrERROR;
+		}
+	    }
+	    else if( c != -1 ) {
+		if( strchr( buf, ':') ) { /* buffer to short, but this is okay*/
+		    log_debug("armor header: ");
+		    print_string( stderr, buf, n );
+		    fputs("[...]\n", stderr);  /* indicate it is truncated */
+		    state = fhdrSKIPHeader;  /* skip rest of line */
 		}
+		else /* line too long */
+		    state = fhdrERROR;
 	    }
 	    else
-		fhdr->state = fhdrWAIT;
+		state = fhdrEOF;
 	    break;
-	  case fhdrHEAD:
-	    if( c != '-' ) {
-		if( fhdr->count < DIM(fhdr->buf)-1 )
-		    fhdr->buf[fhdr->count++] = c;
-	    }
-	    else {
-		fhdr->buf[fhdr->count] = 0;
-		for(i=0; (s=head_strings[i]); i++ )
-		    if( !strcmp(s,fhdr->buf) )
-			break;
-		if( s ) { /* found string; wait for trailing dashes */
-		    fhdr->hdr_line = i;
-		    fhdr->state = fhdrDASH2;
-		    fhdr->count = 1;
-		}
+
+	  case fhdrWAITClearsig: /* skip all empty lines (for clearsig) */
+	    c = 0;
+	    for(n=0; n < buflen && (c=iobuf_get(a)) != -1 && c != '\n'; )
+		buf[n++] = c;
+	    if( n < buflen || c == '\n' ) {
+		buf[n] = 0;
+		if( !n || (buf[0]=='\r' && !buf[1]) ) /* empty line */
+		    ;
 		else
-		    fhdr->state = fhdrWAIT;
+		    state = fhdrTEXT;
 	    }
+	    else
+		state = fhdrEOF;
 	    break;
 
-	  case fhdrDASH2:
-	    if( c == '-' ) {
-		if( ++fhdr->count == 5 ) {
-		    fhdr->state = fhdrWAITINFO;
-		    log_debug("armor head: '%s'\n",
-					head_strings[fhdr->hdr_line]);
-		    fhdr->state = fhdr->hdr_line == BEGIN_SIGNED_MSG_IDX
-				   ? fhdrWAITCLEARSIG : fhdrWAITINFO;
-		    if( fhdr->state == fhdrWAITCLEARSIG )
-			fhdr->count = 0;
-		}
+	  case fhdrENDClearsig:
+	  case fhdrCHECKBegin:
+	    state = state == fhdrCHECKBegin ? fhdrINITSkip : fhdrERRORShow;
+	    if( n < 15 )
+		break;	/* too short */
+	    if( memcmp( buf, "-----", 5 ) )
+		break;
+	    buf[n] = 0;
+	    p = strstr(buf+5, "-----");
+	    if( !p )
+		break;
+	    *p = 0;
+	    p += 5;
+	    if( *p == '\r' )
+		p++;
+	    if( *p )
+		break; /* garbage after dashes */
+	    p = buf+5;
+	    for(i=0; (s=head_strings[i]); i++ )
+		if( !strcmp(s, p) )
+		    break;
+	    if( !s )
+		break; /* unknown begin line */
+	    /* found the begin line */
+	    hdr_line = i;
+	    state = fhdrWAITHeader;
+	    if( hdr_line == BEGIN_SIGNED_MSG_IDX )
+		clearsig = 1;
+	    log_debug("armor: %s\n", head_strings[hdr_line]);
+	    break;
+
+	  case fhdrCLEARSIG:
+	  case fhdrEMPTYClearsig:
+	  case fhdrREADClearsig:
+	    /* we are at the start of a line: read a clearsig into the buffer
+	     * we have to look for a the header line or dashd escaped text*/
+	    n = 0;
+	    c = 0;
+	    for(; n < buflen && (c=iobuf_get(a)) != -1 && c != '\n'; )
+		buf[n++] = c;
+	    buf[n] = 0;
+	    if( c == -1 )
+		state = fhdrEOF;
+	    else if( !n || ( buf[0]=='\r' && !buf[1] ) ) {
+		state = fhdrEMPTYClearsig;
+		/* FIXME: handle it */
 	    }
+	    else if( c == '\n' )
+		state = fhdrCHECKClearsig2;
 	    else
-		fhdr->state = fhdrWAIT;
+		state = fhdrCHECKClearsig;
 	    break;
 
-	  case fhdrINFO:
-	    if( fhdr->count < DIM(fhdr->buf)-1 )
-		fhdr->buf[fhdr->count++] = c;
+	  case fhdrCHECKClearsig:
+	  case fhdrCHECKClearsig2:
+	    /* check the clearsig line */
+	    if( n > 15 && !memcmp(buf, "-----", 5 ) )
+		state = fhdrENDClearsig;
+	    else if( buf[0] == '-' && buf[1] == ' ' ) {
+		/* dash escaped line */
+		if( buf[2] == '-' || ( n > 6 && !memcmp(buf+2, "From ", 5))) {
+		    for(i=2; i < n; i++ )
+			buf[i-2] = buf[i];
+		    n -= 2;
+		    buf[n] = 0; /* not really needed */
+		    state = state == fhdrCHECKClearsig2 ?
+				     fhdrREADClearsig : fhdrREADClearsigNext;
+		    /* FIXME: add the lf to the buffer */
+		}
+		else {
+		    log_debug("invalid dash escaped line: ");
+		    print_string( stderr, buf, n );
+		    putc('\n', stderr);
+		    state = fhdrERROR;
+		}
+	    }
+	    else {
+		state = state == fhdrCHECKClearsig2 ?
+				  fhdrREADClearsig : fhdrREADClearsigNext;
+		/* FIXME: add the lf to the buffer */
+	    }
 	    break;
 
-	  default: abort();
-	}
-    }
-    return 0;
-}
+	  case fhdrREADClearsigNext:
+	    /* Read to the end of the line, do not care about checking
+	     * for dashed escaped text of headers */
+	    break;
 
-/****************
- * check wether the trailer is okay.
- * Returns: 0 := still in trailer
- *	    -1 := Okay
- *	    1 := Error in trailer
- */
-static int
-check_trailer( struct fhdr_struct *fhdr, int c )
-{
-    return -1;
-    /* FIXME: implement this ! */
+	  case fhdrERRORShow:
+	    log_debug("invalid clear text header: ");
+	    print_string( stderr, buf, n );
+	    putc('\n', stderr);
+	    state = fhdrERROR;
+	    break;
+
+	  default: BUG();
+	}
+	switch( state ) {
+	  case fhdrINIT:
+	  case fhdrINITCont:
+	  case fhdrINITSkip:
+	  case fhdrCHECKBegin:
+	  case fhdrWAITHeader:
+	  case fhdrWAITClearsig:
+	  case fhdrSKIPHeader:
+	  case fhdrEMPTYClearsig:
+	  case fhdrCHECKClearsig:
+	  case fhdrCHECKClearsig2:
+	  case fhdrERRORShow:
+	    cont = 1;
+	    break;
+	  default: cont = 0;
+	}
+    } while( cont );
+
+    if( clearsig && state == fhdrTEXT )
+	state = fhdrCLEARSIG;
+    *r_buflen = n;
+    return state;
 }
 
 
@@ -274,59 +405,45 @@
 check_input( armor_filter_context_t *afx, IOBUF a )
 {
     int rc = 0;
-    int c;
-    size_t n = 0, nn=0;
-    struct fhdr_struct fhdr;
-
-    assert( DIM(afx->helpbuf) >= 50 );
-    memset( &fhdr, 0, sizeof(fhdr) );
-
-    /* read a couple of bytes */
-    for( n=0; n < DIM(afx->helpbuf); n++ ) {
-	if( (c=iobuf_get(a)) == -1 )
-	    break;
-	afx->helpbuf[n] = c & 0xff;
-    }
+    size_t n;
+    fhdr_state_t state = afx->parse_state;
 
-    if( !n )
-	rc = -1;
-    else if( is_armored( afx->helpbuf, n ) ) {
-	for(nn=0; nn < n; nn++ )
-	    if( find_header( &fhdr, afx->helpbuf[nn] ) )
-		break;
-	if( nn == n ) { /* continue read */
-	    while( (c=iobuf_get(a)) != -1 )
-		if( find_header( &fhdr, c ) )
-		    break;
-	    if( c == -1 )
-		rc = -1; /* eof */
-	}
-	if( !rc && fhdr.hdr_line == BEGIN_SIGNED_MSG_IDX ) {
-	    /* start fake package mode (for clear signatures) */
-	    nn++;
-	    afx->helplen = n;
-	    afx->helpidx = nn;
-	    afx->templen = 0;
-	    afx->tempidx = 0;
-	    afx->fake = m_alloc_clear( sizeof(struct fhdr_struct) );
-	}
-	else if( !rc ) {
-	    /* next byte to read or helpbuf[nn+1]
-	     * is the first rad64 byte */
-	    nn++;
-	    afx->inp_checked = 1;
-	    afx->crc = CRCINIT;
-	    afx->idx = 0;
-	    afx->radbuf[0] = 0;
-	    afx->helplen = n;
-	    afx->helpidx = nn;
-	}
-    }
-    else {
+    if( state != fhdrENDClearsig )
+	state = fhdrHASArmor;
+
+    n = DIM(afx->helpbuf);
+    state = find_header( state, afx->helpbuf, &n, a, afx->helplen );
+    switch( state ) {
+      case fhdrNOArmor:
 	afx->inp_checked = 1;
 	afx->inp_bypass = 1;
+	afx->helplen = n;
+	break;
+
+      case fhdrERROR:
+      case fhdrEOF:
+	rc = -1;
+	break;
+
+      case fhdrCLEARSIG: /* start fake package mode (for clear signatures) */
+	afx->helplen = n;
+	afx->helpidx = 0;
+	afx->faked = 1;
+	break;
+
+      case fhdrTEXT:
+	afx->helplen = n;
+	afx->helpidx = 0;
+	afx->inp_checked = 1;
+	afx->crc = CRCINIT;
+	afx->idx = 0;
+	afx->radbuf[0] = 0;
+	break;
+
+      default: BUG();
     }
 
+    afx->parse_state = state;
     return rc;
 }
 
@@ -338,71 +455,61 @@
 	     size_t *retn, byte *buf, size_t size  )
 {
     int rc = 0;
-    int c;
-    size_t n = 0;
-    struct fhdr_struct *fhdr = afx->fake;
-    byte *helpbuf = afx->helpbuf;
-    int helpidx = afx->helpidx;
-    int helplen = afx->helplen;
-    byte *tempbuf = afx->tempbuf;
-    int tempidx = afx->tempidx;
-    int templen = afx->templen;
-
-    /* FIXME: have to read one ahead or do some other mimic to
-     * get rid of the lf before the "begin signed message"
-     */
+    size_t len = 0;
+    size_t n, nn;
+    fhdr_state_t state = afx->parse_state;
+
     size = 100; /* FIXME: only used for testing (remove it)  */
-    n = 2; /* reserve 2 bytes for the length header */
-    while( n < size-2 ) { /* and 2 for the term header */
-	if( templen && (fhdr->state == fhdrWAIT || fhdr->state == fhdrLF) ) {
-	    if( tempidx < templen ) {
-		buf[n++] = tempbuf[tempidx++];
-		continue;
-	    }
-	    tempidx = templen = 0;
+
+    len = 2;	/* reserve 2 bytes for the length header */
+    size -= 2;	/* and 2 for the term header */
+    while( !rc && len < size ) {
+	if( afx->helpidx < afx->helplen ) { /* flush the last buffer */
+	    n = afx->helplen;
+	    for(nn=afx->helpidx; len < size && nn < n ; nn++ )
+		buf[len++] = afx->helpbuf[nn];
+	    afx->helpidx = nn;
+	    continue;
+	}
+	if( state == fhdrEOF ) {
+	    rc = -1;
+	    continue;
 	}
+	/* read a new one */
+	n = DIM(afx->helpbuf);
+	afx->helpidx = 0;
+	state = find_header( state, afx->helpbuf, &n, a, 0 );
+	switch( state) {
+	  case fhdrERROR:
+	  case fhdrEOF:
+	    rc = -1;
+	    break;
 
-	if( helpidx < helplen )
-	    c = helpbuf[helpidx++];
-	else if( (c=iobuf_get(a)) == -1 )
+	  case fhdrCLEARSIG:
+	  case fhdrREADClearsig:
+	  case fhdrREADClearsigNext:
+	    afx->helplen = n;
 	    break;
-	if( find_header( fhdr, c ) ) {
-	    m_free(afx->fake);
-	    afx->fake = NULL;
-	    afx->inp_checked = 1;
-	    afx->crc = CRCINIT;
-	    afx->idx = 0;
-	    afx->radbuf[0] = 0;
-	    /* we don't need to care about the tempbuf */
+
+	  case fhdrENDClearsig:
+	    afx->helplen = n;
+	    afx->faked = 0;
+	    rc = -1;
 	    break;
-	}
-	if( fhdr->state == fhdrWAIT || fhdr->state == fhdrLF ) {
-	    if( templen ) {
-		tempidx = 0;
-		continue;
-	    }
-	    buf[n++] = c;
-	}
-	else if( fhdr->state == fhdrWAITINFO
-		|| fhdr->state == fhdrINFO )
-	    ;
-	else { /* store it in another temp. buf */
-	    assert( templen < DIM(afx->tempbuf) );
-	    tempbuf[templen++] = c;
+
+	  default: BUG();
 	}
     }
-    buf[0] = (n-2) >> 8;
-    buf[1] = (n-2);
-    if( !afx->fake ) { /* write last (ending) length header */
-	buf[n++] = 0;
-	buf[n++] = 0;
+    buf[0] = (len-2) >> 8;
+    buf[1] = (len-2);
+    if( state == fhdrENDClearsig ) { /* write last (ending) length header */
+	buf[len++] = 0;
+	buf[len++] = 0;
+	rc = 0;
     }
 
-    afx->helpidx = helpidx;
-    afx->helplen = helplen;
-    afx->tempidx = tempidx;
-    afx->templen = templen;
-    *retn = n;
+    afx->parse_state = state;
+    *retn = len;
     return rc;
 }
 
@@ -493,11 +600,8 @@
 		log_error("CRC error; %06lx - %06lx\n",
 				    (ulong)afx->crc, (ulong)mycrc);
 	    else {
-		struct fhdr_struct fhdr;
-
-		memset( &fhdr, 0, sizeof(fhdr) );
 		for(rc=0;!rc;) {
-		    rc = check_trailer( &fhdr, c );
+		    rc = 0 /*check_trailer( &fhdr, c )*/;
 		    if( !rc ) {
 			if( afx->helpidx < afx->helplen )
 			    c = afx->helpbuf[afx->helpidx++];
@@ -561,13 +665,13 @@
 	    return -1;
 	}
 
-	if( afx->fake )
+	if( afx->faked )
 	    rc = fake_packet( afx, a, &n, buf, size );
 	else if( !afx->inp_checked ) {
 	    rc = check_input( afx, a );
 	    if( afx->inp_bypass )
 		;
-	    else if( afx->fake ) {
+	    else if( afx->faked ) {
 		/* the buffer is at least 20 bytes long, so it
 		 * is easy to construct a packet */
 		buf[0] = 0xaf; /* old packet format, type 11, var length */
diff -urN g10-0.2.0/g10/elg.c g10-0.2.1/g10/elg.c
--- g10-0.2.0/g10/elg.c	Fri Jan  9 13:34:45 1998
+++ g10-0.2.1/g10/elg.c	Wed Jan 28 10:46:41 1998
@@ -66,18 +66,20 @@
 
 
 void
-g10_elg_sign( PKT_secret_cert *skc, PKT_signature *sig, MD_HANDLE md )
+g10_elg_sign( PKT_secret_cert *skc, PKT_signature *sig,
+	      MD_HANDLE md, int digest_algo )
 {
     ELG_secret_key skey;
     MPI frame;
     byte *dp;
 
     assert( sig->pubkey_algo == PUBKEY_ALGO_ELGAMAL );
+    if( !digest_algo )
+	digest_algo = md_get_algo(md);
 
-    md_final( md );
-    dp = md_read( md, 0 );
+    dp = md_read( md, digest_algo );
     keyid_from_skc( skc, sig->keyid );
-    sig->d.elg.digest_algo = md_get_algo(md);
+    sig->d.elg.digest_algo = digest_algo;
     sig->d.elg.digest_start[0] = dp[0];
     sig->d.elg.digest_start[1] = dp[1];
     sig->d.elg.a = mpi_alloc( mpi_get_nlimbs(skc->d.elg.p) );
diff -urN g10-0.2.0/g10/export.c g10-0.2.1/g10/export.c
--- g10-0.2.0/g10/export.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/g10/export.c	Mon Jan 26 13:20:22 1998
@@ -0,0 +1,47 @@
+/* export.c
+ *	Copyright (c) 1998 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <assert.h>
+
+#include "options.h"
+#include "packet.h"
+#include "errors.h"
+#include "keydb.h"
+#include "memory.h"
+#include "util.h"
+
+
+/****************
+ * Make a new keyring from all internal keyrings (if no user is given)
+ * or for all selected users.
+ */
+int
+export_pubkeys( STRLIST users )
+{
+    log_fatal("Not yet implemented");
+    return 0;
+}
+
+
diff -urN g10-0.2.0/g10/filter.h g10-0.2.1/g10/filter.h
--- g10-0.2.0/g10/filter.h	Fri Jan  9 10:40:59 1998
+++ g10-0.2.1/g10/filter.h	Tue Jan 27 11:18:11 1998
@@ -35,9 +35,8 @@
     u32 crc;
     byte helpbuf[100];
     int  helpidx, helplen;
-    byte tempbuf[100];
-    int  tempidx, templen;
-    void *fake;
+    int faked;
+    int parse_state;
     int inp_checked;   /* set if inp has been checked */
     int inp_bypass;    /* set if the input is not armored */
     int inp_eof;
diff -urN g10-0.2.0/g10/g10.c g10-0.2.1/g10/g10.c
--- g10-0.2.0/g10/g10.c	Sun Jan 25 19:41:28 1998
+++ g10-0.2.1/g10/g10.c	Wed Jan 28 15:23:31 1998
@@ -37,12 +37,14 @@
 #include "filter.h"
 #include "trustdb.h"
 #include "ttyio.h"
+#include "i18n.h"
+
 
 enum cmd_values { aNull = 0,
     aSym, aStore, aEncr, aPrimegen, aKeygen, aSign, aSignEncr,
     aPrintMDs, aSignKey, aClearsig, aListPackets, aEditSig,
     aKMode, aKModeC, aChangePass, aImport, aListTrustDB,
-    aListTrustPath,
+    aListTrustPath, aExport,
 aTest };
 
 
@@ -67,24 +69,31 @@
 		break;
       case 2:
       case 12:	p =
-    "Syntax: g10 [options] [files]\n"
-    "sign, check, encrypt or decrypt\n"
-    "default operation depends on the input data\n"; break;
+    _("Syntax: g10 [options] [files]\n"
+      "sign, check, encrypt or decrypt\n"
+      "default operation depends on the input data\n"); break;
 
       case 26:
-	p = "Please report bugs to <g10-bugs@isil.d.shuttle.de>.\n";
+	p = _("Please report bugs to <g10-bugs@isil.d.shuttle.de>.\n");
 	break;
 
-      case 30: p = ""
-  #ifndef HAVE_ZLIB_H
+  #if !defined(HAVE_ZLIB_H) && defined(HAVE_RSA_CIPHER)
+      case 30: p = _(
     "   NOTE: This version is compiled without ZLIB support;\n"
     "         you are not able to process compresssed data!\n"
-  #endif
-  #ifdef HAVE_RSA_CIPHER
     "WARNING: This version has RSA support! Your are not allowed to\n"
-    "         use it inside the Unites States before Sep 30, 2000!\n"
+    "         use it inside the Unites States before Sep 30, 2000!\n" );
+  #elif !defined(HAVE_ZLIB_H)
+      case 30: p = _(
+    "   NOTE: This version is compiled without ZLIB support;\n"
+    "         you are not able to process compresssed data!\n");
+  #elif defined(HAVE_RSA_CIPHER)
+      case 30: p = _(
+    "WARNING: This version has RSA support! Your are not allowed to\n"
+    "         use it inside the Unites States before Sep 30, 2000!\n" );
+  #else
+      case 30: p = "";
   #endif
-	;
 	break;
       default:	p = default_strusage(level);
     }
@@ -92,12 +101,22 @@
 }
 
 static void
+i18n_init(void)
+{
+  #ifdef HAVE_LIBINTL
+    setlocale( LC_MESSAGES, "" );
+    bindtextdomain( PACKAGE, G10_LOCALEDIR );
+    textdomain( PACKAGE );
+  #endif
+}
+
+static void
 wrong_args( const char *text)
 {
-    fputs("Usage: g10 [options] ",stderr);
+    fputs(_("Usage: g10 [options] "),stderr);
     fputs(text,stderr);
     putc('\n',stderr);
-    exit(2);
+    g10_exit(2);
 }
 
 static void
@@ -130,69 +149,70 @@
     else if( cmd == aKMode && new_cmd == aSym )
 	cmd = aKModeC;
     else {
-	log_error("conflicting commands\n");
-	exit(2);
+	log_error(_("conflicting commands\n"));
+	g10_exit(2);
     }
 
     *ret_cmd = cmd;
 }
 
 
-int
+void
 main( int argc, char **argv )
 {
     static ARGPARSE_OPTS opts[] = {
-    { 'a', "armor",     0, "create ascii armored output"},
-    { 'v', "verbose",   0, "verbose" },
-    { 'z', NULL,        1, "set compress level (0 disables)" },
-    { 'n', "dry-run",   0, "don't make any changes" },
-    { 'c', "symmetric", 0, "do only a symmetric encryption" },
-    { 'o', "output",    2, "use as output file" },
-    { 500, "batch",     0, "batch mode: never ask" },
-    { 501, "yes",       0, "assume yes on most questions"},
-    { 502, "no",        0, "assume no on most questions"},
-    { 503, "gen-key",   0, "generate a new key pair" },
-    { 504, "add-key",   0, "add key to the public keyring" },
-    { 505, "delete-key",0, "remove key from public keyring" },
-    { 506, "sign-key"  ,0, "make a signature on a key in the keyring" },
-    { 507, "store",     0, "store only" },
-    { 508, "check-key" ,0, "check signatures on a key in the keyring" },
-    { 509, "keyring"   ,2, "add this keyring to the list of keyrings" },
-    { 's', "sign",      0, "make a signature"},
-    { 't', "textmode",  0, "use canonical text mode"},
-    { 'b', "detach-sign", 0, "make a detached signature"},
-    { 'e', "encrypt",   0, "encrypt data" },
-    { 'd', "decrypt",   0, "decrypt data (default)" },
-    { 'u', "local-user",2, "use this user-id to sign or decrypt" },
-    { 'r', "remote-user", 2, "use this user-id for encryption" },
-    { 'k', NULL      , 0, "list keys" },
-    { 510, "debug"     ,4|16, "set debugging flags" },
-    { 511, "debug-all" ,0, "enable full debugging"},
-    { 512, "cache-all" ,0, "hold everything in memory"},
+    { 'a', "armor",     0, N_("create ascii armored output")},
+    { 'v', "verbose",   0, N_("verbose") },
+    { 'z', NULL,        1, N_("set compress level (0 disables)") },
+    { 'n', "dry-run",   0, N_("don't make any changes") },
+    { 'c', "symmetric", 0, N_("do only a symmetric encryption")},
+    { 'o', "output",    2, N_("use as output file")},
+    { 500, "batch",     0, N_("batch mode: never ask")},
+    { 501, "yes",       0, N_("assume yes on most questions")},
+    { 502, "no",        0, N_("assume no on most questions")},
+    { 503, "gen-key",   0, N_("generate a new key pair")},
+    { 504, "add-key",   0, N_("add key to the public keyring")},
+    { 505, "delete-key",0, N_("remove key from public keyring")},
+    { 506, "sign-key"  ,0, N_("make a signature on a key in the keyring")},
+    { 507, "store",     0, N_("store only")},
+    { 508, "check-key" ,0, N_("check signatures on a key in the keyring")},
+    { 509, "keyring"   ,2, N_("add this keyring to the list of keyrings")},
+    { 's', "sign",      0, N_("make a signature")},
+    { 't', "textmode",  0, N_("use canonical text mode")},
+    { 'b', "detach-sign", 0, N_("make a detached signature")},
+    { 'e', "encrypt",   0, N_("encrypt data")},
+    { 'd', "decrypt",   0, N_("decrypt data (default)")},
+    { 'u', "local-user",2, N_("use this user-id to sign or decrypt")},
+    { 'r', "remote-user", 2, N_("use this user-id for encryption")},
+    { 'k', NULL      , 0, N_("list keys")},
+    { 510, "debug"     ,4|16, N_("set debugging flags")},
+    { 511, "debug-all" ,0, N_("enable full debugging")},
+ /* { 512 unused */
     { 513, "gen-prime" , 0, "\r" },
     { 514, "test"      , 0, "\r" },
-    { 515, "fingerprint", 0, "show the fingerprints"},
-    { 516, "print-mds" , 0, "print all message digests"},
-    { 517, "secret-keyring" ,2, "add this secret keyring to the list" },
-    { 518, "options"   , 2, "read options from file" },
+    { 515, "fingerprint", 0, N_("show the fingerprints")},
+    { 516, "print-mds" , 0, N_("print all message digests")},
+    { 517, "secret-keyring" ,2, N_("add this secret keyring to the list")},
+    { 518, "options"   , 2, N_("read options from file")},
     { 519, "no-armor",   0, "\r"},
     { 520, "no-default-keyring", 0, "\r" },
-    { 521, "list-packets",0,"list only the sequence of packets"},
+    { 521, "list-packets",0,N_("list only the sequence of packets")},
     { 522, "no-greeting", 0, "\r" },
     { 523, "passphrase-fd",1, "\r" },
-    { 524, "edit-sig"  ,0, "edit a key signature" },
-    { 525, "change-passphrase", 0, "change the passphrase of your secret keyring"},
+    { 524, "edit-sig"  ,0, N_("edit a key signature")},
+    { 525, "change-passphrase", 0, N_("change the passphrase of your secret keyring")},
     { 526, "no-verbose", 0, "\r"},
-    { 527, "cipher-algo", 2 , "select default cipher algorithm" },
-    { 528, "pubkey-algo", 2 , "select default puplic key algorithm" },
-    { 529, "digest-algo", 2 , "select default message digest algorithm" },
-    { 530, "import",      0 , "put public keys into the trustdb" },
+    { 527, "cipher-algo", 2 , N_("select default cipher algorithm")},
+    { 528, "pubkey-algo", 2 , N_("select default puplic key algorithm")},
+    { 529, "digest-algo", 2 , N_("select default message digest algorithm")},
+    { 530, "import",      0 , N_("put public keys into the trustdb")},
     { 531, "list-trustdb",0 , "\r"},
     { 532, "quick-random", 0, "\r"},
     { 533, "list-trust-path",0, "\r"},
-    { 534, "no-comment", 0,   "do not write comment packets"},
-    { 535, "completes_needed", 1, "(default is 1)"},
-    { 536, "marginals_needed", 1, "(default is 3)"},
+    { 534, "no-comment", 0,   N_("do not write comment packets")},
+    { 535, "completes-needed", 1, N_("(default is 1)")},
+    { 536, "marginals-needed", 1, N_("(default is 3)")},
+    { 537, "export", 0, N_("export all or the given keys") },
 
     {0} };
     ARGPARSE_ARGS pargs;
@@ -217,6 +237,9 @@
     enum cmd_values cmd = 0;
 
 
+    secmem_init( 16384 );
+
+    i18n_init();
     opt.compress = -1; /* defaults to standard compress level */
     opt.def_cipher_algo = CIPHER_ALGO_BLOWFISH;
     opt.def_pubkey_algo = PUBKEY_ALGO_ELGAMAL;
@@ -256,15 +279,15 @@
 	if( !configfp ) {
 	    if( default_config ) {
 		if( parse_verbose > 1 )
-		log_info("note: no default option file '%s'\n", configname );
+		log_info(_("note: no default option file '%s'\n"), configname );
 	    }
 	    else
-		log_fatal("option file '%s': %s\n",
+		log_fatal(_("option file '%s': %s\n"),
 				    configname, strerror(errno) );
 	    m_free(configname); configname = NULL;
 	}
 	if( parse_verbose > 1 )
-	    log_info("reading options from '%s'\n", configname );
+	    log_info(_("reading options from '%s'\n"), configname );
 	default_config = 0;
     }
 
@@ -306,7 +329,7 @@
 	  case 509: add_keyring(pargs.r.ret_str); nrings++; break;
 	  case 510: opt.debug |= pargs.r.ret_ulong; break;
 	  case 511: opt.debug = ~0; break;
-	  case 512: opt.cache_all = 1; break;
+	/*  case 512: */
 	  case 513: set_cmd( &cmd, aPrimegen); break;
 	  case 514: set_cmd( &cmd, aTest); break;
 	  case 515: opt.fingerprint = 1; break;
@@ -344,6 +367,7 @@
 	  case 534: opt.no_comment=1; break;
 	  case 535: opt.completes_needed = pargs.r.ret_int; break;
 	  case 536: opt.marginals_needed = pargs.r.ret_int; break;
+	  case 537: set_cmd( &cmd, aExport); break;
 	  default : errors++; pargs.err = configfp? 1:2; break;
 	}
     }
@@ -355,27 +379,27 @@
     }
     m_free( configname ); configname = NULL;
     if( !opt.def_cipher_algo || check_cipher_algo(opt.def_cipher_algo) ) {
-	log_error("selected cipher algorithm is invalid\n");
+	log_error(_("selected cipher algorithm is invalid\n"));
 	errors++;
     }
     if( !opt.def_pubkey_algo || check_pubkey_algo(opt.def_pubkey_algo) ) {
-	log_error("selected pubkey algorithm is invalid\n");
+	log_error(_("selected pubkey algorithm is invalid\n"));
 	errors++;
     }
     if( !opt.def_digest_algo || check_digest_algo(opt.def_digest_algo) ) {
-	log_error("selected digest algorithm is invalid\n");
+	log_error(_("selected digest algorithm is invalid\n"));
 	errors++;
     }
     if( opt.completes_needed < 1 ) {
-	log_error("completes_needed must be greater than 0\n");
+	log_error(_("completes-needed must be greater than 0\n"));
 	errors++;
     }
     if( opt.marginals_needed < 2 ) {
-	log_error("marginals_needed must be greater than 1\n");
+	log_error(_("marginals-needed must be greater than 1\n"));
 	errors++;
     }
     if( errors )
-	exit(2);
+	g10_exit(2);
 
 
     set_debug();
@@ -435,7 +459,7 @@
       default: rc = init_trustdb(1); break;
     }
     if( rc )
-	log_error("failed to initialize the TrustDB: %s\n", g10_errstr(rc));
+	log_error(_("failed to initialize the TrustDB: %s\n"), g10_errstr(rc));
 
 
     switch( cmd ) {
@@ -527,7 +551,7 @@
 
 	    while( (s=get_keyring(seq++)) ) {
 		if( !(a = iobuf_open(s)) ) {
-		    log_error("can't open '%s'\n", s);
+		    log_error(_("can't open '%s'\n"), s);
 		    continue;
 		}
 		if( seq > 1 )
@@ -544,7 +568,7 @@
 	}
 	else if( argc == 1) { /* list the given keyring */
 	    if( !(a = iobuf_open(fname)) )
-		log_fatal("can't open '%s'\n", fname_print);
+		log_fatal(_("can't open '%s'\n"), fname_print);
 	    proc_packets( a );
 	    iobuf_close(a);
 	}
@@ -603,6 +627,15 @@
 	}
 	break;
 
+      case aExport:
+	sl = NULL;
+	for( ; argc; argc--, argv++ )
+	    add_to_strlist( &sl, *argv );
+	export_pubkeys( sl );
+	free_strlist(sl);
+	break;
+
+
       case aListTrustDB:
 	if( !argc )
 	    list_trustdb(NULL);
@@ -614,7 +647,7 @@
 
       case aListTrustPath:
 	if( argc != 2 )
-	    wrong_args("--list-trust-path  <maxdepth> <username>");
+	    wrong_args("--list-trust-path [-- -]<maxdepth> <username>");
 	list_trust_path( atoi(*argv), argv[1] );
 	break;
 
@@ -624,7 +657,7 @@
 	if( argc > 1 )
 	    usage(1);
 	if( !(a = iobuf_open(fname)) )
-	    log_fatal("can't open '%s'\n", fname_print);
+	    log_fatal(_("can't open '%s'\n"), fname_print);
 	if( !opt.no_armor ) {
 	    /* push the armor filter, so it can peek at the input data */
 	    memset( &afx, 0, sizeof afx);
@@ -642,7 +675,17 @@
     /* cleanup */
     FREE_STRLIST(remusr);
     FREE_STRLIST(locusr);
-    return log_get_errorcount(0)? 2:0;
+    g10_exit(0);
+}
+
+
+void
+g10_exit( int rc )
+{
+    if( opt.verbose )
+	secmem_dump_stats();
+    secmem_term();
+    exit( rc? rc : log_get_errorcount(0)? 2:0 );
 }
 
 
diff -urN g10-0.2.0/g10/getkey.c g10-0.2.1/g10/getkey.c
--- g10-0.2.0/g10/getkey.c	Tue Jan 13 16:08:58 1998
+++ g10-0.2.1/g10/getkey.c	Mon Jan 26 14:40:03 1998
@@ -23,6 +23,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <assert.h>
+#include <ctype.h>
 #include "util.h"
 #include "packet.h"
 #include "memory.h"
@@ -215,15 +216,6 @@
     STRLIST sl;
 
 
-    if( opt.cache_all && !pkc_cache ) {
-	log_info("reading all entries ...\n");
-	for(sl = keyrings; sl; sl = sl->next )
-	    if( !scan_keyring( NULL, NULL, NULL, sl->d ) )
-		goto leave;
-	log_info("cached %d entries\n", pkc_cache_entries);
-    }
-
-
     /* lets see wether we checked the keyid already */
     for( kl = unknown_keyids; kl; kl = kl->next )
 	if( kl->keyid[0] == keyid[0] && kl->keyid[1] == keyid[1] )
@@ -273,6 +265,19 @@
  * first pubkey certificate which has the given name in a user_id.
  * if pkc has the pubkey algo set, the function will only return
  * a pubkey with that algo.
+ *
+ * - If the username starts with 8,9,16 or 17 hex-digits (the first one
+ *   must be in the range 0..9), this is considered a keyid; depending
+ *   on the length a short or complete one.
+ * - If the username starts with 32,33,40 or 41 hex-digits (the first one
+ *   must be in the range 0..9), this is considered a fingerprint.
+ *   (Not yet implemented)
+ * - If the username starts with a left angle, we assume it is a complete
+ *   email address and look only at this part.
+ * - If the userid start with an '=' an exact compare is done; this may
+ *   also follow the keyid in which case both parts are matched.
+ *   (Not yet implemented)
+ *
  */
 int
 get_pubkey_byname( PKT_public_cert *pkc, const char *name )
@@ -280,6 +285,58 @@
     int internal = 0;
     int rc = 0;
     STRLIST sl;
+    const char *s;
+    u32 keyid[2] = {0}; /* init to avoid compiler warning */
+    int use_keyid=0;
+
+    /* check what kind of name it is */
+    for(s = name; *s && isspace(*s); s++ )
+	;
+    if( isdigit( *s ) ) { /* a keyid */
+	int i;
+	char buf[9];
+
+	for(i=0; isxdigit(s[i]); i++ )
+	    ;
+	if( s[i] && !isspace(s[i]) ) /* not terminated by EOS or blank*/
+	    rc = G10ERR_INV_USER_ID;
+	else if( i == 8 || (i == 9 && *s == '0') ) { /* short keyid */
+	    if( i==9 )
+		s++;
+	    keyid[1] = strtoul( s, NULL, 16 );
+	    use_keyid++;
+	}
+	else if( i == 16 || (i == 17 && *s == '0') ) { /* complete keyid */
+	    if( i==17 )
+		s++;
+	    mem2str(buf, s, 9 );
+	    keyid[0] = strtoul( buf, NULL, 16 );
+	    keyid[1] = strtoul( s+8, NULL, 16 );
+	    return get_pubkey( pkc, keyid );
+	}
+	else
+	    rc = G10ERR_INV_USER_ID;
+    }
+    else if( *s == '<' ) { /* an email address */
+	/* for now handled like a substring */
+	/* a keyserver might use this for quicker access */
+    }
+    else if( *s == '=' ) { /* exact search */
+	rc = G10ERR_INV_USER_ID; /* nox yet implemented */
+    }
+    else if( *s == '#' ) { /* use local id */
+	rc = G10ERR_INV_USER_ID; /* nox yet implemented */
+    }
+    else if( *s == '*' ) { /* substring search */
+	name++;
+    }
+    else if( !*s )  /* empty string */
+	rc = G10ERR_INV_USER_ID;
+
+    if( rc )
+	goto leave;
+
+
 
     if( !pkc ) {
 	pkc = m_alloc_clear( sizeof *pkc );
@@ -288,9 +345,14 @@
 
     /* 2. Try to get it from the keyrings */
     for(sl = keyrings; sl; sl = sl->next )
-	if( !scan_keyring( pkc, NULL, name, sl->d ) )
-	    goto leave;
-
+	if( use_keyid ) {
+	    if( !scan_keyring( pkc, keyid, name, sl->d ) )
+		goto leave;
+	}
+	else {
+	    if( !scan_keyring( pkc, NULL, name, sl->d ) )
+		goto leave;
+	}
     /* 3. Try to get it from a key server */
 
     /* 4. not found: store it for future reference */
@@ -363,6 +425,9 @@
 
 /****************
  * scan the keyring and look for either the keyid or the name.
+ * If both, keyid and name are given, look for keyid but use only
+ * the low word of it (name is only used as a flag to indicate this mode
+ * of operation).
  */
 static int
 scan_keyring( PKT_public_cert *pkc, u32 *keyid,
@@ -375,11 +440,11 @@
     int save_mode;
     u32 akeyid[2];
     PKT_public_cert *last_pk = NULL;
+    int shortkeyid;
 
-    assert( !keyid || !name );
-
-    if( opt.cache_all && (name || keyid) )
-	return G10ERR_NO_PUBKEY;
+    shortkeyid = keyid && name;
+    if( shortkeyid )
+	name = NULL; /* not used anymore */
 
     if( !(a = iobuf_open( filename ) ) ) {
 	log_debug("scan_keyring: can't open '%s'\n", filename );
@@ -388,6 +453,8 @@
 
     if( !DBG_CACHE )
 	;
+    else if( shortkeyid )
+	log_debug("scan_keyring %s for %08lx\n",  filename, keyid[1] );
     else if( name )
 	log_debug("scan_keyring %s for '%s'\n",  filename, name );
     else if( keyid )
@@ -410,7 +477,8 @@
 	      case PUBKEY_ALGO_ELGAMAL:
 	      case PUBKEY_ALGO_RSA:
 		keyid_from_pkc( pkt.pkt.public_cert, akeyid );
-		if( akeyid[0] == keyid[0] && akeyid[1] == keyid[1] ) {
+		if( (shortkeyid || akeyid[0] == keyid[0])
+		    && akeyid[1] == keyid[1] ) {
 		    copy_public_cert( pkc, pkt.pkt.public_cert );
 		    found++;
 		}
diff -urN g10-0.2.0/g10/keygen.c g10-0.2.1/g10/keygen.c
--- g10-0.2.0/g10/keygen.c	Fri Jan 16 12:48:42 1998
+++ g10-0.2.1/g10/keygen.c	Tue Jan 27 15:45:36 1998
@@ -32,6 +32,7 @@
 #include "ttyio.h"
 #include "options.h"
 #include "keydb.h"
+#include "i18n.h"
 
 #if 0
   #define TEST_ALGO  1
@@ -105,7 +106,7 @@
     PKT_public_cert *pkc;
 
     if( opt.verbose )
-	log_info("writing self signature\n");
+	log_info(_("writing self signature\n"));
 
     /* get the uid packet from the tree */
     for( kbctx=NULL; (node=walk_kbtree( root, &kbctx)) ; ) {
@@ -201,19 +202,16 @@
 
 #ifdef ENABLE_RSA_KEYGEN
 static int
-gen_rsa(unsigned nbits, IOBUF pub_io, IOBUF sec_io, DEK *dek,
-	PKT_public_cert **ret_pkc, PKT_secret_cert **ret_skc )
+gen_rsa(unsigned nbits, KBNODE pub_root, KBNODE sec_root, DEK *dek,
+	PKT_secret_cert **ret_skc )
 {
     int rc;
-    PACKET pkt1, pkt2;
+    PACKET *pkt;
     PKT_secret_cert *skc;
     PKT_public_cert *pkc;
     RSA_public_key pk;
     RSA_secret_key sk;
 
-    init_packet(&pkt1);
-    init_packet(&pkt2);
-
     rsa_generate( &pk, &sk, nbits );
 
     skc = m_alloc_clear( sizeof *skc );
@@ -234,11 +232,11 @@
     skc->d.rsa.csum += checksum_mpi( skc->d.rsa.rsa_p );
     skc->d.rsa.csum += checksum_mpi( skc->d.rsa.rsa_q );
     skc->d.rsa.csum += checksum_mpi( skc->d.rsa.rsa_u );
-    if( !dek ) {
-	skc->d.rsa.is_protected = 0;
-	skc->d.rsa.protect_algo = 0;
-    }
-    else {
+
+    /* return an unprotected version of the skc */
+    *ret_skc = copy_secret_cert( NULL, skc );
+
+    if( dek ) {
 	skc->d.rsa.is_protected = 1;
 	skc->d.rsa.protect_algo = CIPHER_ALGO_BLOWFISH;
 	randomize_buffer( skc->d.rsa.protect.blowfish.iv, 8, 1);
@@ -246,31 +244,22 @@
 	rc = protect_secret_key( skc, dek );
 	if( rc ) {
 	    log_error("protect_secret_key failed: %s\n", g10_errstr(rc) );
-	    goto leave;
+	    free_public_cert(pkc);
+	    free_secret_cert(skc);
+	    return rc;
 	}
     }
 
-    pkt1.pkttype = PKT_PUBLIC_CERT;
-    pkt1.pkt.public_cert = pkc;
-    pkt2.pkttype = PKT_SECRET_CERT;
-    pkt2.pkt.secret_cert = skc;
+    pkt = m_alloc_clear(sizeof *pkt);
+    pkt->pkttype = PKT_PUBLIC_CERT;
+    pkt->pkt.public_cert = pkc;
+    add_kbnode(pub_root, new_kbnode( pkt ));
 
-    if( (rc = build_packet( pub_io, &pkt1 )) ) {
-	log_error("build public_cert packet failed: %s\n", g10_errstr(rc) );
-	goto leave;
-    }
-    if( (rc = build_packet( sec_io, &pkt2 )) ) {
-	log_error("build secret_cert packet failed: %s\n", g10_errstr(rc) );
-	goto leave;
-    }
-    *ret_pkc = pkt1.pkt.public_cert;
-    pkt1.pkt.public_cert = NULL;
-    *ret_skc = pkt1.pkt.secret_cert;
-    pkt1.pkt.secret_cert = NULL;
+    pkt = m_alloc_clear(sizeof *pkt);
+    pkt->pkttype = PKT_SECRET_CERT;
+    pkt->pkt.secret_cert = skc;
+    add_kbnode(sec_root, new_kbnode( pkt ));
 
-  leave:
-    free_packet(&pkt1);
-    free_packet(&pkt2);
     return rc;
 }
 #endif /*ENABLE_RSA_KEYGEN*/
@@ -305,28 +294,27 @@
     const char *algo_name;
     char *aname, *acomment, *amail;
 
-  #ifndef TEST_ALGO
+#ifndef TEST_ALGO
     if( opt.batch || opt.answer_yes || opt.answer_no )
-	log_fatal("Key generation can only be used in interactive mode\n");
+	log_fatal(_("Key generation can only be used in interactive mode\n"));
 
-    tty_printf("Please select the algorithm to use:\n"
-	       "   (1) ElGamal is the suggested one.\n"
-	       "   (2) DSA can only be used for signatures.\n"
-	   #ifdef ENABLE_RSA_KEYGEN
-	       "   (3) RSA cannot be used in the U.S.\n"
-	   #endif
-	       );
+    tty_printf(_("Please select the algorithm to use:\n"
+		 "   (1) ElGamal is the suggested one.\n"
+		 "   (2) DSA can only be used for signatures.\n"));
+  #ifdef ENABLE_RSA_KEYGEN
+    tty_printf(_("   (3) RSA cannot be used in the U.S.\n"));
   #endif
+#endif
 
     for(;;) {
       #ifdef TEST_ALGO
 	algo = TEST_ALGO;
       #else
-	answer = tty_get("Your selection? (1,2"
-					   #ifdef ENABLE_RSA_KEYGEN
-					     ",3"
-					   #endif
-					     ") ");
+	#ifdef ENABLE_RSA_KEYGEN
+	  answer = tty_get(_("Your selection? (1,2,3) "));
+       #else
+	  answer = tty_get(_("Your selection? (1,2) "));
+       #endif
 	tty_kill_prompt();
 	algo = *answer? atoi(answer): 1;
 	m_free(answer);
@@ -339,7 +327,7 @@
 	else if( algo == 2 ) {
 	    algo = PUBKEY_ALGO_DSA;
 	    algo_name = "DSA";
-	    tty_printf("Sorry; DSA is not yet supported.\n");
+	    tty_printf(_("Sorry; DSA is not yet supported.\n"));
 	}
       #ifdef ENABLE_RSA_KEYGEN
 	else if( algo == 3 ) {
@@ -352,36 +340,33 @@
 
 
 
-    tty_printf("About to generate a new %s keypair.\n"
-	  #ifndef TEST_NBITS
-	       "              minimum keysize is  768 bits\n"
-	       "              default keysize is 1024 bits\n"
-	       "    highest suggested keysize is 2048 bits\n"
-	  #endif
-							     , algo_name );
+    tty_printf(_("About to generate a new %s keypair.\n"
+		 "              minimum keysize is  768 bits\n"
+		 "              default keysize is 1024 bits\n"
+		 "    highest suggested keysize is 2048 bits\n"), algo_name );
     for(;;) {
       #ifdef TEST_NBITS
 	nbits = TEST_NBITS;
       #else
-	answer = tty_get("What keysize do you want? (1024) ");
+	answer = tty_get(_("What keysize do you want? (1024) "));
 	tty_kill_prompt();
 	nbits = *answer? atoi(answer): 1024;
 	m_free(answer);
       #endif
 	if( algo == PUBKEY_ALGO_DSA && (nbits < 512 || nbits > 1024) )
-	    tty_printf("DSA does only allow keysizes from 512 to 1024\n");
+	    tty_printf(_("DSA does only allow keysizes from 512 to 1024\n"));
 	else if( nbits < 768 )
-	    tty_printf("keysize too small; 768 is smallest value allowed.\n");
+	    tty_printf(_("keysize too small; 768 is smallest value allowed.\n"));
 	else if( nbits > 2048 ) {
-	    tty_printf("Keysizes larger than 2048 are not suggested, because "
-		       "computations take REALLY long!\n");
-	    answer = tty_get("Are you sure, that you want this keysize? ");
+	    tty_printf(_("Keysizes larger than 2048 are not suggested, because "
+			 "computations take REALLY long!\n"));
+	    answer = tty_get(_("Are you sure, that you want this keysize? "));
 	    tty_kill_prompt();
 	    if( answer_is_yes(answer) ) {
 		m_free(answer);
-		tty_printf("Okay, but keep in mind that your monitor "
-			   "and keyboard radiation is also very vulnerable "
-			   "to attacks!\n");
+		tty_printf(_("Okay, but keep in mind that your monitor "
+			     "and keyboard radiation is also very vulnerable "
+			     "to attacks!\n"));
 		break;
 	    }
 	    m_free(answer);
@@ -389,24 +374,24 @@
 	else
 	    break;
     }
-    tty_printf("Requested keysize is %u bits\n", nbits );
+    tty_printf(_("Requested keysize is %u bits\n"), nbits );
     if( algo == PUBKEY_ALGO_DSA && (nbits % 64) ) {
 	nbits = ((nbits + 63) / 64) * 64;
-	tty_printf("rounded up to %u bits\n", nbits );
+	tty_printf(_("rounded up to %u bits\n"), nbits );
     }
     else if( (nbits % 32) ) {
 	nbits = ((nbits + 31) / 32) * 32;
-	tty_printf("rounded up to %u bits\n", nbits );
+	tty_printf(_("rounded up to %u bits\n"), nbits );
     }
 
   #ifdef TEST_UID
     uid = m_alloc(strlen(TEST_UID)+1);
     strcpy(uid, TEST_UID);
   #else
-    tty_printf( "\n"
+    tty_printf( _("\n"
 "You need a User-ID to identify your key; the software constructs the user id\n"
 "from Real Name, Comment and Email Address in this form:\n"
-"    \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n\n" );
+"    \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n\n") );
     uid = NULL;
     aname=acomment=amail=NULL;
     for(;;) {
@@ -415,15 +400,15 @@
 	if( !aname ) {
 	    for(;;) {
 		m_free(aname);
-		aname = tty_get("Real name: ");
+		aname = tty_get(_("Real name: "));
 		trim_spaces(aname);
 		tty_kill_prompt();
 		if( strpbrk( aname, "<([])>" ) )
-		    tty_printf("Invalid character in name\n");
+		    tty_printf(_("Invalid character in name\n"));
 		else if( isdigit(*aname) )
-		    tty_printf("Name may not start with a digit\n");
+		    tty_printf(_("Name may not start with a digit\n"));
 		else if( strlen(aname) < 5 )
-		    tty_printf("Name must be at least 5 characters long\n");
+		    tty_printf(_("Name must be at least 5 characters long\n"));
 		else
 		    break;
 	    }
@@ -431,7 +416,7 @@
 	if( !amail ) {
 	    for(;;) {
 		m_free(amail);
-		amail = tty_get("Email address: ");
+		amail = tty_get(_("Email address: "));
 		trim_spaces(amail);
 		strlwr(amail);
 		tty_kill_prompt();
@@ -443,7 +428,7 @@
 			 || amail[strlen(amail)-1] == '@'
 			 || amail[strlen(amail)-1] == '.'
 			 || strstr(amail, "..") )
-		    tty_printf("Not a valid email address\n");
+		    tty_printf(_("Not a valid email address\n"));
 		else
 		    break;
 	    }
@@ -451,13 +436,13 @@
 	if( !acomment ) {
 	    for(;;) {
 		m_free(acomment);
-		acomment = tty_get("Comment: ");
+		acomment = tty_get(_("Comment: "));
 		trim_spaces(acomment);
 		tty_kill_prompt();
 		if( !*acomment )
 		    break;   /* no comment is okay */
 		else if( strpbrk( acomment, "()" ) )
-		    tty_printf("Invalid character in comment\n");
+		    tty_printf(_("Invalid character in comment\n"));
 		else
 		    break;
 	    }
@@ -473,15 +458,13 @@
 
 	/* append a warning if we do not have dev/random
 	 * or it is switched into  quick testmode */
-      #ifdef HAVE_DEV_RANDOM
 	if( quick_random_gen(-1) )
-      #endif
 	    strcpy(p, " (INSECURE!)" );
 
 
-	tty_printf("You selected this USER-ID:\n    \"%s\"\n\n", uid);
+	tty_printf(_("You selected this USER-ID:\n    \"%s\"\n\n"), uid);
 	for(;;) {
-	    answer = tty_get("Edit (N)ame, (C)omment, (E)mail or (O)kay? ");
+	    answer = tty_get(_("Edit (N)ame, (C)omment, (E)mail or (O)kay? "));
 	    tty_kill_prompt();
 	    if( strlen(answer) > 1 )
 		;
@@ -513,7 +496,7 @@
   #endif
 
 
-    tty_printf( "You need a Passphrase to protect your secret key.\n\n" );
+    tty_printf(_("You need a Passphrase to protect your secret key.\n\n") );
 
     dek = m_alloc_secure( sizeof *dek );
     for(;;) {
@@ -521,14 +504,14 @@
 	rc = make_dek_from_passphrase( dek , 2 );
 	if( rc == -1 ) {
 	    m_free(dek); dek = NULL;
-	    tty_printf(
+	    tty_printf(_(
 	    "You don't what a passphrase - this is probably a *bad* idea!\n"
 	    "I will do it anyway.  You can change your passphrase at anytime,\n"
-	    "using this program with the option \"--change-passphrase\"\n\n" );
+	    "using this program with the option \"--change-passphrase\"\n\n"));
 	    break;
 	}
 	else if( rc == G10ERR_PASSPHRASE ) {
-	    tty_printf("passphrase not correctly repeated; try again.\n");
+	    tty_printf(_("passphrase not correctly repeated; try again.\n"));
 	}
 	else if( rc ) {
 	    m_free(dek); dek = NULL;
@@ -545,8 +528,8 @@
     pub_fname = make_filename("~/.g10", "pubring.g10", NULL );
     sec_fname = make_filename("~/.g10", "secring.g10", NULL );
     if( opt.verbose ) {
-	tty_printf("writing public certificate to '%s'\n", pub_fname );
-	tty_printf("writing secret certificate to '%s'\n", sec_fname );
+	tty_printf(_("writing public certificate to '%s'\n"), pub_fname );
+	tty_printf(_("writing secret certificate to '%s'\n"), sec_fname );
     }
 
     /* we create the packets as a tree of kbnodes. Because the structure
@@ -557,17 +540,17 @@
     pub_root = make_comment_node("#created by G10 pre-release " VERSION );
     sec_root = make_comment_node("#created by G10 pre-release " VERSION );
 
-    tty_printf(
+    tty_printf(_(
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
 "network and the disks) during the prime generation; this gives the random\n"
-"number generator a better chance to gain enough entropy.\n" );
+"number generator a better chance to gain enough entropy.\n") );
 
     if( algo == PUBKEY_ALGO_ELGAMAL )
 	rc = gen_elg(nbits, pub_root, sec_root, dek, &skc );
   #ifdef ENABLE_RSA_KEYGEN
     else if( algo == PUBKEY_ALGO_RSA )
-	rc = gen_rsa(nbits, pub_io, sec_io, dek, &skc );
+	rc = gen_rsa(nbits, pub_root, sec_root, dek, &skc );
   #endif
     else if( algo == PUBKEY_ALGO_DSA )
 	rc = gen_dsa(nbits, pub_root, sec_root, dek, &skc );
@@ -625,7 +608,7 @@
 	else if( (rc=insert_keyblock( &sec_kbpos, sec_root )) )
 	    log_error("can't write secret key: %s\n", g10_errstr(rc) );
 	else {
-	    tty_printf("public and secret key created and signed.\n" );
+	    tty_printf(_("public and secret key created and signed.\n") );
 	}
 
 	if( !rc1 )
@@ -636,7 +619,7 @@
 
 
     if( rc )
-	tty_printf("Key generation failed: %s\n", g10_errstr(rc) );
+	tty_printf(_("Key generation failed: %s\n"), g10_errstr(rc) );
     release_kbnode( pub_root );
     release_kbnode( sec_root );
     if( skc ) /* the unprotected  secret certificate */
diff -urN g10-0.2.0/g10/main.h g10-0.2.1/g10/main.h
--- g10-0.2.0/g10/main.h	Fri Jan 16 17:47:39 1998
+++ g10-0.2.1/g10/main.h	Wed Jan 28 10:41:16 1998
@@ -32,6 +32,13 @@
 } encrypt_filter_context_t;
 
 
+/*-- g10.c --*/
+#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 5 )
+  void g10_exit(int rc) __attribute__ ((noreturn));
+#else
+  void g10_exit(int rc);
+#endif
+
 /*-- encode.c --*/
 int encode_symmetric( const char *filename );
 int encode_store( const char *filename );
@@ -71,14 +78,18 @@
 
 /*-- elg.c --*/
 void g10_elg_encrypt( PKT_public_cert *pkc, PKT_pubkey_enc *enc, DEK *dek );
-void g10_elg_sign( PKT_secret_cert *skc, PKT_signature *sig, MD_HANDLE md );
+void g10_elg_sign( PKT_secret_cert *skc, PKT_signature *sig,
+					 MD_HANDLE md, int digest_algo );
 
 /*-- rsa.c --*/
 void g10_rsa_encrypt( PKT_public_cert *pkc, PKT_pubkey_enc *enc, DEK *dek );
-void g10_rsa_sign( PKT_secret_cert *skc, PKT_signature *sig, MD_HANDLE md );
+void g10_rsa_sign( PKT_secret_cert *skc, PKT_signature *sig,
+					 MD_HANDLE md, int digest_algo );
 
 /*-- import.c --*/
 int import_pubkeys( const char *filename );
+/*-- export.c --*/
+int export_pubkeys( STRLIST users );
 
 
 #endif /*G10_MAIN_H*/
diff -urN g10-0.2.0/g10/mainproc.c g10-0.2.1/g10/mainproc.c
--- g10-0.2.0/g10/mainproc.c	Fri Jan 16 12:48:43 1998
+++ g10-0.2.1/g10/mainproc.c	Wed Jan 28 10:16:36 1998
@@ -613,7 +613,7 @@
 		    print_keyid( stderr, sig->keyid );
 		    putc('\n', stderr);
 		    if( opt.batch )
-			exit(1);
+			g10_exit(1);
 		}
 		else
 		    log_error("Can't check signature made by %08lX: %s\n",
diff -urN g10-0.2.0/g10/options.h g10-0.2.1/g10/options.h
--- g10-0.2.0/g10/options.h	Sun Jan 25 19:30:17 1998
+++ g10-0.2.1/g10/options.h	Mon Jan 26 14:01:44 1998
@@ -31,7 +31,7 @@
     int answer_yes; /* answer yes on most questions */
     int answer_no;  /* answer no on most questions */
     int check_sigs; /* check key signatures */
-    int cache_all;
+    int reserved1;
     int fingerprint; /* list fingerprints */
     int list_sigs;   /* list signatures */
     int no_armor;
diff -urN g10-0.2.0/g10/pkclist.c g10-0.2.1/g10/pkclist.c
--- g10-0.2.0/g10/pkclist.c	Sat Jan 24 17:28:21 1998
+++ g10-0.2.1/g10/pkclist.c	Mon Jan 26 22:44:05 1998
@@ -33,6 +33,7 @@
 #include "util.h"
 #include "trustdb.h"
 #include "ttyio.h"
+#include "i18n.h"
 
 /****************
  * Returns true if a ownertrust has changed.
@@ -61,14 +62,14 @@
 	return 0;
     }
 
-    tty_printf("No ownertrust defined for %lu:\n"
-	       "%4u%c/%08lX %s \"", lid,
+    tty_printf(_("No ownertrust defined for %lu:\n"
+	       "%4u%c/%08lX %s \""), lid,
 	      nbits_from_pkc( pkc ), pubkey_letter( pkc->pubkey_algo ),
 	      (ulong)keyid[1], datestr_from_pkc( pkc ) );
     p = get_user_id( keyid, &n );
     tty_print_string( p, n ),
     m_free(p);
-    tty_printf("\"\n\n"
+    tty_printf(_("\"\n\n"
 "Please decide in how far do you trust this user to\n"
 "correctly sign other users keys (looking at his passport,\n"
 "checking the fingerprints from different sources ...)?\n\n"
@@ -76,19 +77,19 @@
 " 2 = I do NOT trust\n"
 " 3 = I trust marginally\n"
 " 4 = I trust fully\n"
-" s = please show me more informations\n\n" );
+" s = please show me more informations\n\n") );
 
     for(;;) {
-	p = tty_get("Your decision? ");
+	p = tty_get(_("Your decision? "));
 	trim_spaces(p);
 	tty_kill_prompt();
 	if( *p && p[1] )
 	    ;
 	else if( *p == '?' ) {
-	    tty_printf(
+	    tty_printf(_(
 "It's up to you to assign a value here; this value will never be exported\n"
 "to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n"
-"to do with the (implicitly created) web-of-certificates.\n");
+"to do with the (implicitly created) web-of-certificates.\n"));
 	}
 	else if( !p[1] && (*p >= '1' && *p <= '4') ) {
 	    unsigned trust;
@@ -104,7 +105,7 @@
 	    break;
 	}
 	else if( *p == 's' || *p == 'S' ) {
-	    tty_printf("You will see a list of signators etc. here\n");
+	    tty_printf(_("You will see a list of signators etc. here\n"));
 	}
 	m_free(p); p = NULL;
     }
@@ -128,8 +129,8 @@
     int any=0;
 
     tty_printf(
-"Could not find a valid trust path to the key.  Lets see, wether we\n"
-"can assign some missing owner trust values.\n\n");
+_("Could not find a valid trust path to the key.  Lets see, wether we\n"
+  "can assign some missing owner trust values.\n\n"));
 
     rc = query_trust_record( pkc );
     if( rc ) {
diff -urN g10-0.2.0/g10/rsa.c g10-0.2.1/g10/rsa.c
--- g10-0.2.0/g10/rsa.c	Fri Jan  9 13:34:08 1998
+++ g10-0.2.1/g10/rsa.c	Wed Jan 28 10:43:27 1998
@@ -64,19 +64,20 @@
 
 
 void
-g10_rsa_sign( PKT_secret_cert *skc, PKT_signature *sig, MD_HANDLE md )
+g10_rsa_sign( PKT_secret_cert *skc, PKT_signature *sig,
+				    MD_HANDLE md, int digest_algo )
 {
  #ifdef HAVE_RSA_CIPHER
     RSA_secret_key skey;
     byte *dp;
 
     assert( sig->pubkey_algo == PUBKEY_ALGO_RSA );
+    if( !digest_algo )
+	digest_algo = md_get_algo(md);
 
-    md_final( md );
-    dp = md_read( md, 0 );
-
+    dp = md_read( md, digest_algo );
     keyid_from_skc( skc, sig->keyid );
-    sig->d.rsa.digest_algo = md_get_algo( md );
+    sig->d.rsa.digest_algo = digest_algo;
     sig->d.rsa.digest_start[0] = dp[0];
     sig->d.rsa.digest_start[1] = dp[1];
     sig->d.rsa.rsa_integer =
diff -urN g10-0.2.0/g10/sign.c g10-0.2.1/g10/sign.c
--- g10-0.2.0/g10/sign.c	Fri Jan 16 17:47:59 1998
+++ g10-0.2.1/g10/sign.c	Wed Jan 28 10:42:22 1998
@@ -48,9 +48,9 @@
     if( (rc=check_secret_key( skc )) )
 	;
     else if( sig->pubkey_algo == PUBKEY_ALGO_ELGAMAL )
-	g10_elg_sign( skc, sig, md );
+	g10_elg_sign( skc, sig, md, 0 );
     else if( sig->pubkey_algo == PUBKEY_ALGO_RSA )
-	g10_rsa_sign( skc, sig, md );
+	g10_rsa_sign( skc, sig, md, 0 );
     else
 	BUG();
 
@@ -246,7 +246,6 @@
 	PKT_secret_cert *skc;
 	PKT_signature *sig;
 	MD_HANDLE md;
-	byte *dp;
 
 	skc = skc_rover->skc;
 
@@ -265,58 +264,11 @@
 	    md_putc( md,  a	   & 0xff );
 	}
 	md_final( md );
-	dp = md_read( md, DIGEST_ALGO_RMD160 );
 
-	if( sig->pubkey_algo == PUBKEY_ALGO_ELGAMAL ) {
-	    ELG_secret_key skey;
-	    MPI frame;
-
-	    keyid_from_skc( skc, sig->keyid );
-	    sig->d.elg.digest_algo = DIGEST_ALGO_RMD160;
-	    sig->d.elg.digest_start[0] = dp[0];
-	    sig->d.elg.digest_start[1] = dp[1];
-	    sig->d.elg.a = mpi_alloc( mpi_get_nlimbs(skc->d.elg.p) );
-	    sig->d.elg.b = mpi_alloc( mpi_get_nlimbs(skc->d.elg.p) );
-	    frame = encode_rmd160_value( dp, 20, mpi_get_nbits(skc->d.elg.p) );
-	    skey.p = skc->d.elg.p;
-	    skey.g = skc->d.elg.g;
-	    skey.y = skc->d.elg.y;
-	    skey.x = skc->d.elg.x;
-	    elg_sign( sig->d.elg.a, sig->d.elg.b, frame, &skey);
-	    memset( &skey, 0, sizeof skey );
-	    mpi_free(frame);
-	    if( opt.verbose ) {
-		char *ustr = get_user_id_string( sig->keyid );
-		log_info("ELG signature from: %s\n", ustr );
-		m_free(ustr);
-	    }
-	}
-      #ifdef HAVE_RSA_CIPHER
-	else if( sig->pubkey_algo == PUBKEY_ALGO_RSA ) {
-	    RSA_secret_key skey;
-
-	    keyid_from_skc( skc, sig->keyid );
-	    sig->d.rsa.digest_algo = DIGEST_ALGO_RMD160;
-	    sig->d.rsa.digest_start[0] = dp[0];
-	    sig->d.rsa.digest_start[1] = dp[1];
-	    sig->d.rsa.rsa_integer = encode_rmd160_value( dp, 20,
-					    mpi_get_nbits(skc->d.rsa.rsa_n) );
-	    skey.e = skc->d.rsa.rsa_e;
-	    skey.n = skc->d.rsa.rsa_n;
-	    skey.p = skc->d.rsa.rsa_p;
-	    skey.q = skc->d.rsa.rsa_q;
-	    skey.d = skc->d.rsa.rsa_d;
-	    skey.u = skc->d.rsa.rsa_u;
-	    rsa_secret( sig->d.rsa.rsa_integer, sig->d.rsa.rsa_integer, &skey);
-	    memset( &skey, 0, sizeof skey );
-	    if( opt.verbose ) {
-		char *ustr = get_user_id_string( sig->keyid );
-		log_info("RSA signature from: %s\n", ustr );
-		m_free(ustr);
-	    }
-	    /* fixme: should we check wether the signature is okay? */
-	}
-      #endif/*HAVE_RSA_CIPHER*/
+	if( sig->pubkey_algo == PUBKEY_ALGO_ELGAMAL )
+	    g10_elg_sign( skc, sig, md, DIGEST_ALGO_RMD160 );
+	else if( sig->pubkey_algo == PUBKEY_ALGO_RSA )
+	    g10_rsa_sign( skc, sig, md, DIGEST_ALGO_RMD160 );
 	else
 	    BUG();
 
diff -urN g10-0.2.0/include/distfiles g10-0.2.1/include/distfiles
--- g10-0.2.0/include/distfiles	Tue Dec 23 17:39:57 1997
+++ g10-0.2.1/include/distfiles	Mon Jan 26 17:49:20 1998
@@ -6,3 +6,5 @@
 ttyio.h
 types.h
 util.h
+i18n.h
+
diff -urN g10-0.2.0/include/errors.h g10-0.2.1/include/errors.h
--- g10-0.2.0/include/errors.h	Fri Jan 16 17:36:34 1998
+++ g10-0.2.1/include/errors.h	Mon Jan 26 13:40:54 1998
@@ -54,5 +54,6 @@
 #define G10ERR_INV_KEYRING    32
 #define G10ERR_TRUSTDB	      33 /* a problem with the trustdb */
 #define G10ERR_BAD_CERT       34 /* bad certicate */
+#define G10ERR_INV_USER_ID    35
 
 #endif /*G10_ERRORS_H*/
diff -urN g10-0.2.0/include/i18n.h g10-0.2.1/include/i18n.h
--- g10-0.2.0/include/i18n.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/include/i18n.h	Mon Jan 26 17:49:04 1998
@@ -0,0 +1,37 @@
+/* i18n.h
+ *	Copyright (c) 1998 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#ifndef G10_I18N_H
+#define G10_I18N_H
+
+#ifdef HAVE_LIBINTL
+  #include <libintl.h>
+  #define _(a) gettext (a)
+  #ifdef gettext_noop
+    #define N_(a) gettext_noop (a)
+  #else
+    #define N_(a) (a)
+  #endif
+#else
+  #define _(a) (a)
+  #define N_(a) (a)
+#endif
+
+#endif /*G10_I18N_H*/
diff -urN g10-0.2.0/include/memory.h g10-0.2.1/include/memory.h
--- g10-0.2.0/include/memory.h	Thu Dec 11 14:05:18 1997
+++ g10-0.2.1/include/memory.h	Wed Jan 28 15:20:53 1998
@@ -61,9 +61,20 @@
 size_t m_size( const void *a );
 int m_is_secure( const void *p );
 
+/*-- secmem.c --*/
+void secmem_init( size_t npool );
+void secmem_term( void );
+void *secmem_malloc( size_t size );
+void secmem_free( void *a );
+void secmem_dump_stats(void);
+
+
+
 #define DBG_MEMORY    memory_debug_mode
 #define DBG_MEMSTAT   memory_stat_debug_mode
 int memory_debug_mode;
 int memory_stat_debug_mode;
+
+
 
 #endif /*G10_MEMORY_H*/
diff -urN g10-0.2.0/include/util.h g10-0.2.1/include/util.h
--- g10-0.2.0/include/util.h	Thu Jan 22 13:40:05 1998
+++ g10-0.2.1/include/util.h	Mon Jan 26 13:47:45 1998
@@ -111,6 +111,7 @@
 #define FREE_STRLIST(a) do { free_strlist((a)); (a) = NULL ; } while(0)
 void add_to_strlist( STRLIST *list, const char *string );
 char *memistr( char *buf, size_t buflen, const char *sub );
+char *mem2str( char *, const void *, size_t);
 char *trim_spaces( char *string );
 int string_count_chr( const char *string, int c );
 
diff -urN g10-0.2.0/intl/ChangeLog g10-0.2.1/intl/ChangeLog
--- g10-0.2.0/intl/ChangeLog	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/ChangeLog	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,693 @@
+Sat Dec  2 22:51:38 1995  Marcus Daniels  <marcus@sysc.pdx.edu>
+
+	* cat-compat.c (textdomain):
+	Reverse order in which files are tried you load.  First
+	try local file, when this failed absolute path.
+
+Wed Nov 29 02:03:53 1995  Nelson H. F. Beebe  <beebe@math.utah.edu>
+
+	* cat-compat.c (bindtextdomain): Add missing { }.
+
+Sun Nov 26 18:21:41 1995  Ulrich Drepper  <drepper@myware>
+
+	* libintl.inst: Add missing __P definition.  Reported by Nelson Beebe.
+
+	* Makefile.in:
+	Add dummy `all' and `dvi' goals.  Reported by Tom Tromey.
+
+Sat Nov 25 16:12:01 1995  Franc,ois Pinard  <pinard@iro.umontreal.ca>
+
+	* hash-string.h: Capitalize arguments of macros.
+
+Sat Nov 25 12:01:36 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (DISTFILES): Prevent files names longer than 13
+	characters.  libintl.h.glibc->libintl.glibc,
+	libintl.h.install->libintl.inst.  Reported by Joshua R. Poulson.
+
+Sat Nov 25 11:31:12 1995  Eric Backus  <ericb@lsid.hp.com>
+
+	* dcgettext.c: Fix bug in preprocessor conditionals.
+
+Sat Nov 25 02:35:27 1995  Nelson H. F. Beebe  <beebe@math.utah.edu>
+
+	* libgettext.h: Solaris cc does not understand
+	 #if !SYMBOL1 && !SYMBOL2.  Sad	but true.
+
+Thu Nov 23 16:22:14 1995  Ulrich Drepper  <drepper@myware>
+
+	* hash-string.h (hash_string):
+	Fix for machine with >32 bit `unsigned long's.
+
+	* dcgettext.c (DCGETTEXT):
+	Fix horrible bug in loop for alternative translation.
+
+Thu Nov 23 01:45:29 1995  Ulrich Drepper  <drepper@myware>
+
+	* po2tbl.sed.in, linux-msg.sed, xopen-msg.sed:
+	Some further simplifications in message number generation.
+
+Mon Nov 20 21:08:43 1995  Ulrich Drepper  <drepper@myware>
+
+	* libintl.h.glibc: Use __const instead of const in prototypes.
+
+	* Makefile.in (install-src):
+	Install libintl.h.install instead of libintl.h.  This
+	is a stripped-down version.  Suggested by Peter Miller.
+
+	* libintl.h.install, libintl.h.glibc: Initial revision.
+
+	* localealias.c (_nl_expand_alias, read_alias_file):
+	Protect prototypes in type casts by __P.
+
+Tue Nov 14 16:43:58 1995  Ulrich Drepper  <drepper@myware>
+
+	* hash-string.h: Correct prototype for hash_string.
+
+Sun Nov 12 12:42:30 1995  Ulrich Drepper  <drepper@myware>
+
+	* hash-string.h (hash_string): Add prototype.
+
+	* gettextP.h: Fix copyright.
+	(SWAP): Add prototype.
+
+Wed Nov  8 22:56:33 1995  Ulrich Drepper  <drepper@myware>
+
+	* localealias.c (read_alias_file): Forgot sizeof.
+	Avoid calling *printf function.  This introduces a big overhead.
+	Patch by Roland McGrath.
+
+Tue Nov  7 14:21:08 1995  Ulrich Drepper  <drepper@myware>
+
+	* finddomain.c, cat-compat.c: Wrong indentation in #if for stpcpy.
+
+	* finddomain.c (stpcpy):
+	Define substitution function local.  The macro was to flaky.
+
+	* cat-compat.c: Fix typo.
+
+	* xopen-msg.sed, linux-msg.sed:
+	While bringing message number to right place only accept digits.
+
+	* linux-msg.sed, xopen-msg.sed: Now that the counter does not have
+	leading 0s we don't need to remove them.  Reported by Marcus
+	Daniels.
+
+	* Makefile.in (../po/cat-id-tbl.o): Use $(top_srdir) in
+	dependency.  Reported by Marcus Daniels.
+
+	* cat-compat.c: (stpcpy) [!_LIBC && !HAVE_STPCPY]: Define replacement.
+	Generally cleanup using #if instead of #ifndef.
+
+	* Makefile.in: Correct typos in comment.  By Franc,ois Pinard.
+
+Mon Nov  6 00:27:02 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (install-src): Don't install libintl.h and libintl.a
+	if we use an available gettext implementation.
+
+Sun Nov  5 22:02:08 1995  Ulrich Drepper  <drepper@myware>
+
+	* libgettext.h: Fix typo: HAVE_CATGETTS -> HAVE_CATGETS.  Reported
+	by Franc,ois Pinard.
+
+	* libgettext.h: Use #if instead of #ifdef/#ifndef.
+
+	* finddomain.c:
+	Comments describing what has to be done should start with FIXME.
+
+Sun Nov  5 19:38:01 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (DISTFILES): Split.  Use DISTFILES with normal meaning.
+	DISTFILES.common names the files common to both dist goals.
+	DISTFILES.gettext are the files only distributed in GNU gettext.
+
+Sun Nov  5 17:32:54 1995  Ulrich Drepper  <drepper@myware>
+
+	* dcgettext.c (DCGETTEXT): Correct searching in derived locales.
+	This was necessary since a change in _nl_find_msg several weeks
+	ago.  I really don't know this is still not fixed.
+
+Sun Nov  5 12:43:12 1995  Ulrich Drepper  <drepper@myware>
+
+	* loadmsgcat.c (_nl_load_domain): Test for FILENAME == NULL.  This
+	might mark a special condition.
+
+	* finddomain.c (make_entry_rec): Don't make illegal entry as decided.
+
+	* Makefile.in (dist): Suppress error message when ln failed.
+	Get files from $(srcdir) explicitly.
+
+	* libgettext.h (gettext_const): Rename to gettext_noop.
+
+Fri Nov  3 07:36:50 1995  Ulrich Drepper  <drepper@myware>
+
+	* finddomain.c (make_entry_rec):
+	Protect against wrong locale names by testing mask.
+
+	* libgettext.h (gettext_const): Add macro definition.
+	Capitalize macro arguments.
+
+Thu Nov  2 23:15:51 1995  Ulrich Drepper  <drepper@myware>
+
+	* finddomain.c (_nl_find_domain):
+	Test for pointer != NULL before accessing value.
+	Reported by Tom Tromey.
+
+	* gettext.c (NULL):
+	Define as (void*)0 instad of 0.  Reported by Franc,ois Pinard.
+
+Mon Oct 30 21:28:52 1995  Ulrich Drepper  <drepper@myware>
+
+	* po2tbl.sed.in: Serious typo bug fixed by Jim Meyering.
+
+Sat Oct 28 23:20:47 1995  Ulrich Drepper  <drepper@myware>
+
+	* libgettext.h: Disable dcgettext optimization for Solaris 2.3.
+
+	* localealias.c (alias_compare):
+	Peter Miller reported that tolower in some systems is
+	even dumber than I thought.  Protect call by `isupper'.
+
+Fri Oct 27 22:22:51 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (libdir, includedir): New variables.
+	(install-src): Install libintl.a and libintl.h in correct dirs.
+
+Fri Oct 27 22:07:29 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (SOURCES): Fix typo: intrl.compat.c -> intl-compat.c.
+
+	* po2tbl.sed.in: Patch for buggy SEDs by Christian von Roques.
+
+	* localealias.c:
+	Fix typo and superflous test.  Reported by Christian von Roques.
+
+Fri Oct  6 11:52:05 1995  Ulrich Drepper  <drepper@myware>
+
+	* finddomain.c (_nl_find_domain):
+	Correct some remainder from the pre-CEN syntax.  Now
+	we don't have a constant number of successors anymore.
+
+Wed Sep 27 21:41:13 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (DISTFILES): Add libintl.h.glibc.
+
+	* Makefile.in (dist-libc): Add goal for packing sources for glibc.
+	(COMSRCS, COMHDRS): Splitted to separate sources shared with glibc.
+
+	* loadmsgcat.c: Forget to continue #if line.
+
+	* localealias.c:
+	[_LIBC]: Rename strcasecmp to __strcasecmp to keep ANSI C name
+	space clean.
+
+	* dcgettext.c, finddomain.c: Better comment to last change.
+
+	* loadmsgcat.c:
+	[_LIBC]: Rename fstat, open, close, read, mmap, and munmap to
+	__fstat, __open, __close, __read, __mmap, and __munmap resp
+	to keep ANSI C name space clean.
+
+	* finddomain.c:
+	[_LIBC]: Rename stpcpy to __stpcpy to keep ANSI C name space clean.
+
+	* dcgettext.c:
+	[_LIBC]: Rename getced and stpcpy to __getcwd and __stpcpy resp to
+	keep ANSI C name space clean.
+
+	* libgettext.h:
+	Include sys/types.h for those old SysV systems out there.
+	Reported by Francesco Potorti`.
+
+	* loadmsgcat.c (use_mmap): Define if compiled for glibc.
+
+	* bindtextdom.c: Include all those standard headers
+	unconditionally if _LIBC is defined.
+
+	* finddomain.c: Fix 2 times defiend -> defined.
+
+	* textdomain.c: Include libintl.h instead of libgettext.h when
+	compiling for glibc.  Include all those standard headers
+	unconditionally if _LIBC is defined.
+
+	* localealias.c, loadmsgcat.c: Prepare to be compiled in glibc.
+
+	* gettext.c:
+	Include libintl.h instead of libgettext.h when compiling for glibc.
+	Get NULL from stddef.h if we compile for glibc.
+
+	* finddomain.c: Include libintl.h instead of libgettext.h when
+	compiling for glibc.  Include all those standard headers
+	unconditionally if _LIBC is defined.
+
+	* dcgettext.c: Include all those standard headers unconditionally
+	if _LIBC is defined.
+
+	* dgettext.c: If compiled in glibc include libintl.h instead of
+	libgettext.h.
+	(locale.h): Don't rely on HAVE_LOCALE_H when compiling for glibc.
+
+	* dcgettext.c: If compiled in glibc include libintl.h instead of
+	libgettext.h.
+	(getcwd): Don't rely on HAVE_GETCWD when compiling for glibc.
+
+	* bindtextdom.c:
+	If compiled in glibc include libintl.h instead of libgettext.h.
+
+Mon Sep 25 22:23:06 1995  Ulrich Drepper  <drepper@myware>
+
+	* localealias.c (_nl_expand_alias): Don't call bsearch if NMAP <= 0.
+	Reported by Marcus Daniels.
+
+	* cat-compat.c (bindtextdomain):
+	String used in putenv must not be recycled.
+	Reported by Marcus Daniels.
+
+	* libgettext.h (__USE_GNU_GETTEXT):
+	Additional symbol to signal that we use GNU gettext
+	library.
+
+	* cat-compat.c (bindtextdomain):
+	Fix bug with the strange stpcpy replacement.
+	Reported by Nelson Beebe.
+
+Sat Sep 23 08:23:51 1995  Ulrich Drepper  <drepper@myware>
+
+	* cat-compat.c: Include <string.h> for stpcpy prototype.
+
+	* localealias.c (read_alias_file):
+	While expand strdup code temporary variable `cp' hided
+	higher level variable with same name.  Rename to `tp'.
+
+	* textdomain.c (textdomain):
+	Avoid warning by using temporary variable in strdup code.
+
+	* finddomain.c (_nl_find_domain): Remove unused variable `application'.
+
+Thu Sep 21 15:51:44 1995  Ulrich Drepper  <drepper@myware>
+
+	* localealias.c (alias_compare):
+	Use strcasecmp() only if available.  Else use
+	implementation in place.
+
+	* intl-compat.c:
+	Wrapper functions now call *__ functions instead of __*.
+
+	* libgettext.h: Declare prototypes for *__ functions instead for __*.
+
+	* cat-compat.c, loadmsgcat.c:
+	Don't use xmalloc, xstrdup, and stpcpy.  These functions are not part
+	of the standard libc and so prevent libintl.a from being used
+	standalone.
+
+	* bindtextdom.c:
+	Don't use xmalloc, xstrdup, and stpcpy.  These functions are not part
+	of the standard libc and so prevent libintl.a from being used
+	standalone.
+	Rename to bindtextdomain__ if not used in GNU C Library.
+
+	* dgettext.c:
+	Rename function to dgettext__ if not used in GNU C Library.
+
+	* gettext.c:
+	Don't use xmalloc, xstrdup, and stpcpy.  These functions are not part
+	of the standard libc and so prevent libintl.a from being used
+	standalone.
+	Functions now called gettext__ if not used in GNU C Library.
+
+	* dcgettext.c, localealias.c, textdomain.c, finddomain.c:
+	Don't use xmalloc, xstrdup, and stpcpy.  These functions are not part
+	of the standard libc and so prevent libintl.a from being used
+	standalone.
+
+Sun Sep 17 23:14:49 1995  Ulrich Drepper  <drepper@myware>
+
+	* finddomain.c: Correct some bugs in handling of CEN standard
+ 	locale definitions.
+
+Thu Sep  7 01:49:28 1995  Ulrich Drepper  <drepper@myware>
+
+	* finddomain.c: Implement CEN syntax.
+
+	* gettextP.h (loaded_domain): Extend number of successors to 31.
+
+Sat Aug 19 19:25:29 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (aliaspath): Remove path to X11 locale dir.
+
+	* Makefile.in: Make install-src depend on install.  This helps
+ 	gettext to install the sources and other packages can use the
+ 	install goal.
+
+Sat Aug 19 15:19:33 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (uninstall): Remove stuff installed by install-src.
+
+Tue Aug 15 13:13:53 1995  Ulrich Drepper  <drepper@myware>
+
+	* VERSION.in: Initial revision.
+
+	* Makefile.in (DISTFILES):
+	Add VERSION file.  This is not necessary for gettext, but
+	for other packages using this library.
+
+Tue Aug 15 06:16:44 1995  Ulrich Drepper  <drepper@myware>
+
+	* gettextP.h (_nl_find_domain):
+	New prototype after changing search strategy.
+
+	* finddomain.c (_nl_find_domain):
+	We now try only to find a specified catalog.  Fall back to other
+	catalogs listed in the locale list is now done in __dcgettext.
+
+	* dcgettext.c (__dcgettext):
+	Now we provide message fall back even to different languages.
+	I.e. if a message is not available in one language all the other
+ 	in the locale list a tried.  Formerly fall back was only possible
+ 	within one language.  Implemented by moving one loop from
+ 	_nl_find_domain to here.
+
+Mon Aug 14 23:45:50 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (gettextsrcdir):
+	Directory where source of GNU gettext library are made
+	available.
+	(INSTALL, INSTALL_DATA): Programs used for installing sources.
+	(gettext-src): New.  Rule to install GNU gettext sources for use in
+	gettextize shell script.
+
+Sun Aug 13 14:40:48 1995  Ulrich Drepper  <drepper@myware>
+
+	* loadmsgcat.c (_nl_load_domain):
+	Use mmap for loading only when munmap function is
+	also available.
+
+	* Makefile.in (install): Depend on `all' goal.
+
+Wed Aug  9 11:04:33 1995  Ulrich Drepper  <drepper@myware>
+
+	* localealias.c (read_alias_file):
+	Do not overwrite '\n' when terminating alias value string.
+
+	* localealias.c (read_alias_file):
+	Handle long lines.  Ignore the rest not fitting in
+	the buffer after the initial `fgets' call.
+
+Wed Aug  9 00:54:29 1995  Ulrich Drepper  <drepper@myware>
+
+	* gettextP.h (_nl_load_domain):
+	Add prototype, replacing prototype for _nl_load_msg_cat.
+
+	* finddomain.c (_nl_find_domain):
+	Remove unneeded variable filename and filename_len.
+	(expand_alias): Remove prototype because functions does not
+ 	exist anymore.
+
+	* localealias.c (read_alias_file):
+	Change type of fname_len parameter to int.
+	(xmalloc): Add prototype.
+
+	* loadmsgcat.c: Better prototypes for xmalloc.
+
+Tue Aug  8 22:30:39 1995  Ulrich Drepper  <drepper@myware>
+
+	* finddomain.c (_nl_find_domain):
+	Allow alias name to be constructed from the four components.
+
+	* Makefile.in (aliaspath): New variable.  Set to preliminary value.
+	(SOURCES): Add localealias.c.
+	(OBJECTS): Add localealias.o.
+
+	* gettextP.h: Add prototype for _nl_expand_alias.
+
+	* finddomain.c: Aliasing handled in intl/localealias.c.
+
+	* localealias.c: Aliasing for locale names.
+
+	* bindtextdom.c: Better prototypes for xmalloc and xstrdup.
+
+Mon Aug  7 23:47:42 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (DISTFILES): gettext.perl is now found in misc/.
+
+	* cat-compat.c (bindtextdomain):
+	Correct implementation.  dirname parameter was not used.
+	Reported by Marcus Daniels.
+
+	* gettextP.h (loaded_domain):
+	New fields `successor' and `decided' for oo, lazy
+	message handling implementation.
+
+	* dcgettext.c:
+	Adopt for oo, lazy message handliing.
+  	Now we can inherit translations from less specific locales.
+	(find_msg): New function.
+
+	* loadmsgcat.c, finddomain.c:
+	Complete rewrite.  Implement oo, lazy message handling :-).
+  	We now have an additional environment variable `LANGUAGE' with
+ 	a higher priority than LC_ALL for the LC_MESSAGE locale.
+  	Here we can set a colon separated list of specifications each
+ 	of the form `language[_territory[.codeset]][@modifier]'.
+
+Sat Aug  5 09:55:42 1995  Ulrich Drepper  <drepper@myware>
+
+	* finddomain.c (unistd.h):
+	Include to get _PC_PATH_MAX defined on system having it.
+
+Fri Aug  4 22:42:00 1995  Ulrich Drepper  <drepper@myware>
+
+	* finddomain.c (stpcpy): Include prototype.
+
+	* Makefile.in (dist): Remove `copying instead' message.
+
+Wed Aug  2 18:52:03 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (ID, TAGS): Do not use $^.
+
+Tue Aug  1 20:07:11 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (TAGS, ID): Use $^ as command argument.
+	(TAGS): Give etags -o option t write to current directory,
+ 	not $(srcdir).
+	(ID): Use $(srcdir) instead os $(top_srcdir)/src.
+	(distclean): Remove ID.
+
+Sun Jul 30 11:51:46 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (gnulocaledir):
+	New variable, always using share/ for data directory.
+	(DEFS): Add GNULOCALEDIR, used in finddomain.c.
+
+	* finddomain.c (_nl_default_dirname):
+	Set to GNULOCALEDIR, because it always has to point
+	to the directory where GNU gettext Library writes it to.
+
+	* intl-compat.c (textdomain, bindtextdomain):
+	Undefine macros before function definition.
+
+Sat Jul 22 01:10:02 1995  Ulrich Drepper  <drepper@myware>
+
+	* libgettext.h (_LIBINTL_H):
+	Protect definition in case where this file is included as
+	libgettext.h on Solaris machines.  Add comment about this.
+
+Wed Jul 19 02:36:42 1995  Ulrich Drepper  <drepper@myware>
+
+	* intl-compat.c (textdomain): Correct typo.
+
+Wed Jul 19 01:51:35 1995  Ulrich Drepper  <drepper@myware>
+
+	* dcgettext.c (dcgettext): Function now called __dcgettext.
+
+	* dgettext.c (dgettext): Now called __dgettext and calls
+ 	__dcgettext.
+
+	* gettext.c (gettext):
+	Function now called __gettext and calls __dgettext.
+
+	* textdomain.c (textdomain): Function now called __textdomain.
+
+	* bindtextdom.c (bindtextdomain): Function now called
+ 	__bindtextdomain.
+
+	* intl-compat.c: Initial revision.
+
+	* Makefile.in (SOURCES): Add intl-compat.c.
+	(OBJECTS): We always compile the GNU gettext library functions.
+  	OBJECTS contains all objects but cat-compat.o, ../po/cat-if-tbl.o,
+ 	and intl-compat.o.
+  	(GETTOBJS): Contains now only intl-compat.o.
+
+	* libgettext.h:
+	Re-include protection matches dualistic character of libgettext.h.
+	For all functions in GNU gettext library define __ counter part.
+
+	* finddomain.c (strchr): Define as index if not found in C library.
+	(_nl_find_domain): For relative paths paste / in between.
+
+Tue Jul 18 16:37:45 1995  Ulrich Drepper  <drepper@myware>
+
+	* loadmsgcat.c, finddomain.c: Add inclusion of sys/types.h.
+
+	* xopen-msg.sed: Fix bug with `msgstr ""' lines.
+	A little bit better comments.
+
+Tue Jul 18 01:18:27 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in:
+	po-mode.el, makelinks, combine-sh are now found in ../misc.
+
+	* po-mode.el, makelinks, combine-sh, elisp-comp:
+	Moved to ../misc/.
+
+	* libgettext.h, gettextP.h, gettext.h: Uniform test for __STDC__.
+
+Sun Jul 16 22:33:02 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (INSTALL, INSTALL_DATA): New variables.
+	(install-data, uninstall): Install/uninstall .elc file.
+
+	* po-mode.el (Installation comment):
+	Add .pox as possible extension of .po files.
+
+Sun Jul 16 13:23:27 1995  Ulrich Drepper  <drepper@myware>
+
+	* elisp-comp: Complete new version by Franc,ois: This does not
+ 	fail when not compiling in the source directory.
+
+Sun Jul 16 00:12:17 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (../po/cat-id-tbl.o):
+	Use $(MAKE) instead of make for recursive make.
+
+	* Makefile.in (.el.elc): Use $(SHELL) instead of /bin/sh.
+	(install-exec): Add missing dummy goal.
+	(install-data, uninstall): @ in multi-line shell command at
+ 	beginning, not in front of echo.  Reported by Eric Backus.
+
+Sat Jul 15 00:21:28 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (DISTFILES):
+	Rename libgettext.perl to gettext.perl to fit in 14 chars
+	file systems.
+
+	* gettext.perl:
+ 	Rename to gettext.perl to fit in 14 chars file systems.
+
+Thu Jul 13 23:17:20 1995  Ulrich Drepper  <drepper@myware>
+
+	* cat-compat.c: If !STDC_HEADERS try to include malloc.h.
+
+Thu Jul 13 20:55:02 1995  Ulrich Drepper  <drepper@myware>
+
+	* po2tbl.sed.in: Pretty printing.
+
+	* linux-msg.sed, xopen-msg.sed:
+	Correct bugs with handling substitute flags in branches.
+
+	* hash-string.h (hash_string):
+	Old K&R compilers don't under stand `unsigned char'.
+
+	* gettext.h (nls_uint32):
+	Some old K&R compilers (eg HP) don't understand `unsigned int'.
+
+	* cat-compat.c (msg_to_cat_id): De-ANSI-fy prototypes.
+
+Thu Jul 13 01:34:33 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (ELCFILES): New variable.
+	(DISTFILES): Add elisp-comp.
+	Add implicit rule for .el -> .elc compilation.
+	(install-data): install $ELCFILES
+	(clean): renamed po-to-tbl and po-to-msg to po2tbl and po2msg resp.
+
+	* elisp-comp: Initial revision
+
+Wed Jul 12 16:14:52 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in:
+	cat-id-tbl.c is now found in po/.  This enables us to use an identical
+	intl/ directory in all packages.
+
+	* dcgettext.c (dcgettext): hashing does not work for table size <= 2.
+
+	* textdomain.c: fix typo (#if def -> #if defined)
+
+Tue Jul 11 18:44:43 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in (stamp-cat-id): use top_srcdir to address source files
+	(DISTFILES,distclean): move tupdate.perl to src/
+
+	* po-to-tbl.sed.in:
+	add additional jump to clear change flag to recognize multiline strings
+
+Tue Jul 11 01:32:50 1995  Ulrich Drepper  <drepper@myware>
+
+	* textdomain.c: Protect inclusion of stdlib.h and string.h.
+
+	* loadmsgcat.c: Protect inclusion of stdlib.h.
+
+	* libgettext.h: Protect inclusion of locale.h.
+	Allow use in C++ programs.
+	Define NULL is not happened already.
+
+	* Makefile.in (DISTFILES): ship po-to-tbl.sed.in instead of
+	po-to-tbl.sed.
+	(distclean): remove po-to-tbl.sed and tupdate.perl.
+
+	* tupdate.perl.in: Substitute Perl path even in exec line.
+	Don't include entries without translation from old .po file.
+
+Tue Jul  4 00:41:51 1995  Ulrich Drepper  <drepper@myware>
+
+	* tupdate.perl.in: use "Updated: " in msgid "".
+
+	* cat-compat.c: Fix typo (LOCALDIR -> LOCALEDIR).
+ 	Define getenv if !__STDC__.
+
+	* bindtextdom.c: Protect stdlib.h and string.h inclusion.
+ 	Define free if !__STDC__.
+
+	* finddomain.c: Change DEF_MSG_DOM_DIR to LOCALEDIR.
+ 	Define free if !__STDC__.
+
+	* cat-compat.c: Change DEF_MSG_DOM_DIR to LOCALEDIR.
+
+Mon Jul  3 23:56:30 1995  Ulrich Drepper  <drepper@myware>
+
+	* Makefile.in: Use LOCALEDIR instead of DEF_MSG_DOM_DIR.
+	Remove unneeded $(srcdir) from Makefile.in dependency.
+
+	* makelinks: Add copyright and short description.
+
+	* po-mode.el: Last version for 0.7.
+
+	* tupdate.perl.in: Fix die message.
+
+	* dcgettext.c: Protect include of string.h.
+
+	* gettext.c: Protect include of stdlib.h and further tries to get NULL.
+
+	* finddomain.c: Some corrections in includes.
+
+	* Makefile.in (INCLUDES): Prune list correct path to Makefile.in.
+
+	* po-to-tbl.sed: Adopt for new .po file format.
+
+	* linux-msg.sed, xopen-msg.sed: Adopt for new .po file format.
+
+Sun Jul  2 23:55:03 1995  Ulrich Drepper  <drepper@myware>
+
+	* tupdate.perl.in: Complete rewrite for new .po file format.
+
+Sun Jul  2 02:06:50 1995  Ulrich Drepper  <drepper@myware>
+
+	* First official release.  This directory contains all the code
+	needed to internationalize own packages.  It provides functions
+	which allow to use the X/Open catgets function with an interface
+	like the Uniforum gettext function.  For system which does not
+	have neither of those a complete implementation is provided.
+
+
diff -urN g10-0.2.0/intl/Makefile.in g10-0.2.1/intl/Makefile.in
--- g10-0.2.0/intl/Makefile.in	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/Makefile.in	Wed Jan 28 16:33:52 1998
@@ -0,0 +1,166 @@
+# Makefile for directory with message catalog handling in GNU NLS Utilities.
+# Copyright (C) 1995 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+PACKAGE = @PACKAGE@
+VERSION = @VERSION@
+
+SHELL = /bin/sh
+
+srcdir = @srcdir@
+top_srcdir = @top_srcdir@
+VPATH = @srcdir@
+
+prefix = @prefix@
+exec_prefix = @exec_prefix@
+transform = @program_transform_name@
+libdir = $(prefix)/lib
+includedir = $(prefix)/include
+datadir = $(prefix)/@DATADIRNAME@
+localedir = $(datadir)/locale
+gnulocaledir = $(prefix)/share/locale
+gettextsrcdir = $(prefix)/share/gettext
+aliaspath = $(localedir):.
+subdir = intl
+
+INSTALL = @INSTALL@
+INSTALL_DATA = @INSTALL_DATA@
+
+AR = ar
+CC = @CC@
+RANLIB = @RANLIB@
+
+DEFS = -DLOCALEDIR=\"$(localedir)\" -DGNULOCALEDIR=\"$(gnulocaledir)\" \
+-DLOCALE_ALIAS_PATH=\"$(aliaspath)\" @DEFS@
+CFLAGS = @CFLAGS@
+
+COMPILE = $(CC) -c $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS) $(XCFLAGS)
+
+HEADERS = $(COMHDRS) libgettext.h
+COMHDRS = gettext.h gettextP.h hash-string.h
+SOURCES = $(COMSRCS) intl-compat.c cat-compat.c
+COMSRCS = bindtextdom.c dcgettext.c dgettext.c gettext.c \
+finddomain.c loadmsgcat.c localealias.c textdomain.c
+OBJECTS = @INTLOBJS@ bindtextdom.o dcgettext.o dgettext.o gettext.o \
+finddomain.o loadmsgcat.o localealias.o textdomain.o
+CATOBJS = cat-compat.o ../po/cat-id-tbl.o
+GETTOBJS = intl-compat.o
+DISTFILES.common = ChangeLog Makefile.in linux-msg.sed po2tbl.sed.in \
+xopen-msg.sed $(HEADERS) $(SOURCES)
+DISTFILES = $(DISTFILES.common) VERSION
+DISTFILES.gettext = $(DISTFILES.common) libintl.glibc libintl.inst
+
+.SUFFIXES:
+.SUFFIXES: .c .o
+.c.o:
+	$(COMPILE) $<
+
+INCLUDES = -I.. -I. -I$(top_srcdir)/intl -I$(top_srcdir)/lib
+
+all: libintl.a
+
+
+libintl.a: $(OBJECTS)
+	rm -f $@
+	$(AR) cru $@ $(OBJECTS)
+	$(RANLIB) $@
+
+../po/cat-id-tbl.o: ../po/cat-id-tbl.c $(top_srcdir)/po/$(PACKAGE).pot
+	cd ../po && $(MAKE) cat-id-tbl.o
+
+check install: all
+
+# This installation goal is only used in GNU gettext.  Packages which
+# only use the library should use install instead.
+#
+# We must not install the libintl.h/libintl.a files if we are on a system
+# which has the gettext() function in its C library or in a separate
+# library.  A special case is where configure found a previously installed
+# GNU gettext library.	If you want to use the one which comes with this
+# version of the package, you have to use `configure --with-gnu-gettext'.
+install-src: install
+	$(top_srcdir)/mkinstalldirs $(libdir) $(includedir) $(gettextsrcdir)
+	if test -f libintl.h; then \
+	  $(INSTALL_DATA) $(srcdir)/libintl.inst \
+	    $(includedir)/libintl.h; \
+	  $(INSTALL_DATA) libintl.a $(libdir)/libintl.a; \
+	fi
+	cd $(srcdir) && \
+	for file in $(DISTFILES.common); do \
+	  $(INSTALL_DATA) $$file $(gettextsrcdir)/intl-$$file; \
+	done
+	$(INSTALL_DATA) VERSION $(gettextsrcdir)/intl-VERSION
+
+uninstall:
+	for file in $(DISTFILES); do \
+	  rm -f $(gettextsrcdir)/intl-$$file; \
+	done
+
+info dvi:
+
+$(OBJECTS): ../config.h libgettext.h
+bindtextdom.o finddomain.o loadmsgcat.o: gettextP.h gettext.h
+dcgettext.o: gettextP.h gettext.h hash-string.h
+
+tags: TAGS
+
+TAGS: $(HEADERS) $(SOURCES)
+	here=`pwd`; cd $(srcdir) && etags -o $$here/TAGS $(HEADERS) $(SOURCES)
+
+id: ID
+
+ID: $(HEADERS) $(SOURCES)
+	here=`pwd`; cd $(srcdir) && mkid -f$$here/ID $(HEADERS) $(SOURCES)
+
+
+mostlyclean:
+	rm -f *.a *.o core core.*
+
+clean: mostlyclean
+
+distclean: clean
+	rm -f Makefile ID TAGS po2msg.sed po2tbl.sed libintl.h
+
+maintainer-clean: distclean
+	@echo "This command is intended for maintainers to use;"
+	@echo "it deletes files that may require special tools to rebuild."
+
+distdir = $(top_builddir)/$(PACKAGE)-$(VERSION)/$(subdir)
+distdir: Makefile.in $(DEP_DISTFILES)
+	@for file in `cd $(srcdir) && echo $(DISTFILES)`; do \
+	  test -f $(distdir)/$$file \
+	  || ln $(srcdir)/$$file $(distdir)/$$file 2> /dev/null \
+	  || cp -p $(srcdir)/$$file $(distdir)/$$file; \
+	done
+
+# This dist goal is only used in GNU gettext.  GNU gettext needs not contain
+# the file `VERSION' but contains some other files which should not be
+# distributed in other packages.
+dist-gettext: Makefile $(DISTFILES.gettext)
+	for file in $(DISTFILES.gettext); do \
+	  ln $(srcdir)/$$file $(distdir) 2> /dev/null \
+	    || cp -p $(srcdir)/$$file $(distdir); \
+	done
+
+dist-libc:
+	tar zcvf intl-glibc.tar.gz $(COMSRCS) $(COMHDRS) libintl.h.glibc
+
+Makefile: Makefile.in ../config.status
+	cd .. && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= ./config.status
+
+# Tell versions [3.59,3.63) of GNU make not to export all variables.
+# Otherwise a system limit (for SysV at least) may be exceeded.
+.NOEXPORT:
+  i\
+$set 1 # Automatically created by po2msg.sed
+  h
+  s/.*/0/
+  x
+}
+#
+# Mitch's old catalog format does not allow comments.
+#
+# We copy the original message as a comment into the .msg file.
+#
+/^msgid/ {
+  s/msgid[ 	]*"//
+#
+# This does not work now with the new format.
+# /"$/! {
+#   s/\\$//
+#   s/$/ ... (more lines following)"/
+# }
+  x
+# The following nice solution is by
+# Bruno <Haible@ma2s2.mathematik.uni-karlsruhe.de>
+  td
+# Increment a decimal number in pattern space.
+# First hide trailing `9' digits.
+  :d
+  s/9\(_*\)$/_\1/
+  td
+# Assure at least one digit is available.
+  s/^\(_*\)$/0\1/
+# Increment the last digit.
+  s/8\(_*\)$/9\1/
+  s/7\(_*\)$/8\1/
+  s/6\(_*\)$/7\1/
+  s/5\(_*\)$/6\1/
+  s/4\(_*\)$/5\1/
+  s/3\(_*\)$/4\1/
+  s/2\(_*\)$/3\1/
+  s/1\(_*\)$/2\1/
+  s/0\(_*\)$/1\1/
+# Convert the hidden `9' digits to `0's.
+  s/_/0/g
+  x
+  G
+  s/\(.*\)"\n\([0-9]*\)/$ #\2 Original Message:(\1)/p
+}
+#
+# The .msg file contains, other then the .po file, only the translations
+# but each given a unique ID.  Starting from 1 and incrementing by 1 for
+# each message we assign them to the messages.
+# It is important that the .po file used to generate the cat-id-tbl.c file
+# (with po-to-tbl) is the same as the one used here.  (At least the order
+# of declarations must not be changed.)
+#
+/^msgstr/ {
+  s/msgstr[ 	]*"\(.*\)"/# \1/
+# Clear substitution flag.
+  tb
+# Append the next line.
+  :b
+  N
+# Look whether second part is continuation line.
+  s/\(.*\n\)"\(.*\)"/\1\2/
+# Yes, then branch.
+  ta
+  P
+  D
+# Note that D includes a jump to the start!!
+# We found a continuation line.  But before printing insert '\'.
+  :a
+  s/\(.*\)\(\n.*\)/\1\\\2/
+  P
+# We cannot use D here.
+  s/.*\n\(.*\)/\1/
+  tb
+}
+d
diff -urN g10-0.2.0/intl/loadmsgcat.c g10-0.2.1/intl/loadmsgcat.c
--- g10-0.2.0/intl/loadmsgcat.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/loadmsgcat.c	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,191 @@
+/* loadmsgcat.c -- load needed message catalogs
+   Copyright (C) 1995 Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#include <fcntl.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+
+#if defined STDC_HEADERS || defined _LIBC
+# include <stdlib.h>
+#endif
+
+#if defined HAVE_UNISTD_H || defined _LIBC
+# include <unistd.h>
+#endif
+
+#if (defined HAVE_MMAP && defined HAVE_MUNMAP) || defined _LIBC
+# include <sys/mman.h>
+#endif
+
+#include "gettext.h"
+#include "gettextP.h"
+
+/* @@ end of prolog @@ */
+
+#ifdef _LIBC
+/* Rename the non ANSI C functions.  This is required by the standard
+   because some ANSI C functions will require linking with this object
+   file and the name space must not be polluted.  */
+# define fstat  __fstat
+# define open   __open
+# define close  __close
+# define read   __read
+# define mmap   __mmap
+# define munmap __munmap
+#endif
+
+/* We need a sign, whether a new catalog was loaded, which can be associated
+   with all translations.  This is important if the translations are
+   cached by one of GCC's features.  */
+int _nl_msg_cat_cntr;
+
+
+/* Load the message catalogs specified by FILENAME.  If it is no valid
+   message catalog do nothing.  */
+void
+_nl_load_domain (domain)
+     struct loaded_domain *domain;
+{
+  int fd;
+  struct stat st;
+  struct mo_file_header *data = (struct mo_file_header *) -1;
+#if (defined HAVE_MMAP && defined HAVE_MUNMAP && !defined DISALLOW_MMAP) \
+    || defined _LIBC
+  int use_mmap = 0;
+#endif
+
+  domain->decided = 1;
+  domain->data = NULL;
+
+  /* If the record does not represent a valid locale the FILENAME
+     might be NULL.  This can happen when according to the given
+     specification the locale file name is different for XPG and CEN
+     syntax.  */
+  if (domain->filename == NULL)
+    return;
+
+  /* Try to open the addressed file.  */
+  fd = open (domain->filename, O_RDONLY);
+  if (fd == -1)
+    return;
+
+  /* We must know about the size of the file.  */
+  if (fstat (fd, &st) != 0
+      && st.st_size < (off_t) sizeof (struct mo_file_header))
+    {
+      /* Something went wrong.  */
+      close (fd);
+      return;
+    }
+
+#if (defined HAVE_MMAP && defined HAVE_MUNMAP && !defined DISALLOW_MMAP) \
+    || defined _LIBC
+  /* Now we are ready to load the file.  If mmap() is available we try
+     this first.  If not available or it failed we try to load it.  */
+  data = (struct mo_file_header *) mmap (NULL, st.st_size, PROT_READ,
+					 MAP_PRIVATE, fd, 0);
+
+  if (data != (struct mo_file_header *) -1)
+    {
+      /* mmap() call was successful.  */
+      close (fd);
+      use_mmap = 1;
+    }
+#endif
+
+  /* If the data is not yet available (i.e. mmap'ed) we try to load
+     it manually.  */
+  if (data == (struct mo_file_header *) -1)
+    {
+      off_t to_read;
+      char *read_ptr;
+
+      data = (struct mo_file_header *) malloc (st.st_size);
+      if (data == NULL)
+	return;
+
+      to_read = st.st_size;
+      read_ptr = (char *) data;
+      do
+	{
+	  long int nb = (long int) read (fd, read_ptr, to_read);
+	  if (nb == -1)
+	    {
+	      close (fd);
+	      return;
+	    }
+
+	  read_ptr += nb;
+	  to_read -= nb;
+	}
+      while (to_read > 0);
+
+      close (fd);
+    }
+
+  /* Using the magic number we can test whether it really is a message
+     catalog file.  */
+  if (data->magic != _MAGIC && data->magic != _MAGIC_SWAPPED)
+    {
+      /* The magic number is wrong: not a message catalog file.  */
+#if (defined HAVE_MMAP && defined HAVE_MUNMAP && !defined DISALLOW_MMAP) \
+    || defined _LIBC
+      if (use_mmap)
+	munmap ((caddr_t) data, st.st_size);
+      else
+#endif
+	free (data);
+      return;
+    }
+
+  domain->data = (char *) data;
+  domain->must_swap = data->magic != _MAGIC;
+
+  /* Fill in the information about the available tables.  */
+  switch (W (domain->must_swap, data->revision))
+    {
+    case 0:
+      domain->nstrings = W (domain->must_swap, data->nstrings);
+      domain->orig_tab = (struct string_desc *)
+	((char *) data + W (domain->must_swap, data->orig_tab_offset));
+      domain->trans_tab = (struct string_desc *)
+	((char *) data + W (domain->must_swap, data->trans_tab_offset));
+      domain->hash_size = W (domain->must_swap, data->hash_tab_size);
+      domain->hash_tab = (nls_uint32 *)
+	((char *) data + W (domain->must_swap, data->hash_tab_offset));
+      break;
+    default:
+      /* This is an illegal revision.  */
+#if (defined HAVE_MMAP && defined HAVE_MUNMAP && !defined DISALLOW_MMAP) \
+    || defined _LIBC
+      if (use_mmap)
+	munmap ((caddr_t) data, st.st_size);
+      else
+#endif
+	free (data);
+      domain->data = NULL;
+      return;
+    }
+
+  /* Show that one domain is changed.  This might make some cached
+     translation invalid.  */
+  ++_nl_msg_cat_cntr;
+}
diff -urN g10-0.2.0/intl/localealias.c g10-0.2.1/intl/localealias.c
--- g10-0.2.0/intl/localealias.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/localealias.c	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,317 @@
+/* localealias.c -- handle aliases for locale names
+   Copyright (C) 1995 Free Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#include <ctype.h>
+#include <stdio.h>
+#include <sys/types.h>
+
+#ifdef __GNUC__
+# define alloca __builtin_alloca
+#else
+# if defined HAVE_ALLOCA_H || defined _LIBC
+#  include <alloca.h>
+# else
+#  ifdef _AIX
+ #pragma alloca
+#  else
+#   ifndef alloca
+char *alloca ();
+#   endif
+#  endif
+# endif
+#endif
+
+#if defined STDC_HEADERS || defined _LIBC
+# include <stdlib.h>
+#else
+char *getenv ();
+# ifdef HAVE_MALLOC_H
+#  include <malloc.h>
+# else
+void free ();
+# endif
+#endif
+
+#if defined HAVE_STRING_H || defined _LIBC
+# include <string.h>
+#else
+# include <strings.h>
+#endif
+#if !HAVE_STRCHR && !defined _LIBC
+# ifndef strchr
+#  define strchr index
+# endif
+#endif
+
+#include "gettext.h"
+#include "gettextP.h"
+
+/* @@ end of prolog @@ */
+
+#ifdef _LIBC
+/* Rename the non ANSI C functions.  This is required by the standard
+   because some ANSI C functions will require linking with this object
+   file and the name space must not be polluted.  */
+# define strcasecmp __strcasecmp
+#endif
+
+struct alias_map
+{
+  const char *alias;
+  const char *value;
+};
+
+
+static struct alias_map *map;
+static size_t nmap = 0;
+static size_t maxmap = 0;
+
+
+/* Prototypes for local functions.  */
+static size_t read_alias_file __P ((const char *fname, int fname_len));
+static void extend_alias_table __P ((void));
+static int alias_compare __P ((const struct alias_map *map1,
+			       const struct alias_map *map2));
+
+
+const char *
+_nl_expand_alias (name)
+    const char *name;
+{
+  static const char *locale_alias_path = LOCALE_ALIAS_PATH;
+  struct alias_map *retval;
+  size_t added;
+
+  do
+    {
+      struct alias_map item;
+
+      item.alias = name;
+
+      if (nmap > 0)
+	retval = (struct alias_map *) bsearch (&item, map, nmap,
+					       sizeof (struct alias_map),
+					       (int (*) __P ((const void *,
+							      const void *)))
+					         alias_compare);
+      else
+	retval = NULL;
+
+      /* We really found an alias.  Return the value.  */
+      if (retval != NULL)
+	return retval->value;
+
+      /* Perhaps we can find another alias file.  */
+      added = 0;
+      while (added == 0 && locale_alias_path[0] != '\0')
+	{
+	  const char *start;
+
+	  while (locale_alias_path[0] == ':')
+	    ++locale_alias_path;
+	  start = locale_alias_path;
+
+	  while (locale_alias_path[0] != '\0' && locale_alias_path[0] != ':')
+	    ++locale_alias_path;
+
+	  if (start < locale_alias_path)
+	    added = read_alias_file (start, locale_alias_path - start);
+	}
+    }
+  while (added != 0);
+
+  return NULL;
+}
+
+
+static size_t
+read_alias_file (fname, fname_len)
+     const char *fname;
+     int fname_len;
+{
+  FILE *fp;
+  char *full_fname;
+  size_t added;
+  static const char aliasfile[] = "/locale.alias";
+
+  full_fname = (char *) alloca (fname_len + sizeof aliasfile);
+  memcpy (full_fname, fname, fname_len);
+  memcpy (&full_fname[fname_len], aliasfile, sizeof aliasfile);
+
+  fp = fopen (full_fname, "r");
+  if (fp == NULL)
+    return 0;
+
+  added = 0;
+  while (!feof (fp))
+    {
+      /* It is a reasonable approach to use a fix buffer here because
+	 a) we are only interested in the first two fields
+	 b) these fields must be usable as file names and so must not
+	    be that long
+       */
+      char buf[BUFSIZ];
+      char *alias;
+      char *value;
+      char *cp;
+
+      if (fgets (buf, BUFSIZ, fp) == NULL)
+	/* EOF reached.  */
+	break;
+
+      cp = buf;
+      /* Ignore leading white space.  */
+      while (isspace (cp[0]))
+	++cp;
+
+      /* A leading '#' signals a comment line.  */
+      if (cp[0] != '\0' && cp[0] != '#')
+	{
+	  alias = cp++;
+	  while (cp[0] != '\0' && !isspace (cp[0]))
+	    ++cp;
+	  /* Terminate alias name.  */
+	  if (cp[0] != '\0')
+	    *cp++ = '\0';
+
+	  /* Now look for the beginning of the value.  */
+	  while (isspace (cp[0]))
+	    ++cp;
+
+	  if (cp[0] != '\0')
+	    {
+	      char *tp;
+	      size_t len;
+
+	      value = cp++;
+	      while (cp[0] != '\0' && !isspace (cp[0]))
+		++cp;
+	      /* Terminate value.  */
+	      if (cp[0] == '\n')
+		{
+		  /* This has to be done to make the following test
+		     for the end of line possible.  We are looking for
+		     the terminating '\n' which do not overwrite here.  */
+		  *cp++ = '\0';
+		  *cp = '\n';
+		}
+	      else if (cp[0] != '\0')
+		*cp++ = '\0';
+
+	      if (nmap >= maxmap)
+		extend_alias_table ();
+
+	      /* We cannot depend on strdup available in the libc.  Sigh!  */
+	      len = strlen (alias) + 1;
+	      tp = (char *) malloc (len);
+	      if (tp == NULL)
+		return added;
+	      memcpy (tp, alias, len);
+	      map[nmap].alias = tp;
+
+	      len = strlen (value) + 1;
+	      tp = (char *) malloc (len);
+	      if (tp == NULL)
+		return added;
+	      memcpy (tp, value, len);
+	      map[nmap].value = tp;
+
+	      ++nmap;
+	      ++added;
+	    }
+	}
+
+      /* Possibily not the whole line fitted into the buffer.  Ignore
+	 the rest of the line.  */
+      while (strchr (cp, '\n') == NULL)
+	{
+	  cp = buf;
+	  if (fgets (buf, BUFSIZ, fp) == NULL)
+	    /* Make sure the inner loop will be left.  The outer loop
+	       will exit at the `feof' test.  */
+	    *cp = '\n';
+	}
+    }
+
+  /* Should we test for ferror()?  I think we have to silently ignore
+     errors.  --drepper  */
+  fclose (fp);
+
+  if (added > 0)
+    qsort (map, nmap, sizeof (struct alias_map),
+	   (int (*) __P ((const void *, const void *))) alias_compare);
+
+  return added;
+}
+
+
+static void
+extend_alias_table ()
+{
+  size_t new_size;
+  struct alias_map *new_map;
+
+  new_size = maxmap == 0 ? 100 : 2 * maxmap;
+  new_map = (struct alias_map *) malloc (new_size
+					 * sizeof (struct alias_map));
+  if (new_map == NULL)
+    /* Simply don't extend: we don't have any more core.  */
+    return;
+
+  memcpy (new_map, map, nmap * sizeof (struct alias_map));
+
+  if (maxmap != 0)
+    free (map);
+
+  map = new_map;
+  maxmap = new_size;
+}
+
+
+static int
+alias_compare (map1, map2)
+     const struct alias_map *map1;
+     const struct alias_map *map2;
+{
+#if defined _LIBC || defined HAVE_STRCASECMP
+  return strcasecmp (map1->alias, map2->alias);
+#else
+  const unsigned char *p1 = (const unsigned char *) map1->alias;
+  const unsigned char *p2 = (const unsigned char *) map2->alias;
+  unsigned char c1, c2;
+
+  if (p1 == p2)
+    return 0;
+
+  do
+    {
+      /* I know this seems to be odd but the tolower() function in
+	 some systems libc cannot handle nonalpha characters.  */
+      c1 = isupper (*p1) ? tolower (*p1) : *p1;
+      c2 = isupper (*p2) ? tolower (*p2) : *p2;
+      if (c1 == '\0')
+	break;
+    }
+  while (c1 == c2);
+
+  return c1 - c2;
+#endif
+}
diff -urN g10-0.2.0/intl/po2tbl.sed.in g10-0.2.1/intl/po2tbl.sed.in
--- g10-0.2.0/intl/po2tbl.sed.in	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/po2tbl.sed.in	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,102 @@
+# po2tbl.sed - Convert Uniforum style .po file to lookup table for catgets
+# Copyright (C) 1995 Free Software Foundation, Inc.
+# Ulrich Drepper <drepper@gnu.ai.mit.edu>, 1995.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+#
+1 {
+  i\
+/* Automatically generated by po2tbl.sed from @PACKAGE NAME@.pot.  */\
+\
+#if HAVE_CONFIG_H\
+# include <config.h>\
+#endif\
+\
+#include "libgettext.h"\
+\
+const struct _msg_ent _msg_tbl[] = {
+  h
+  s/.*/0/
+  x
+}
+#
+# Write msgid entries in C array form.
+#
+/^msgid/ {
+  s/msgid[ 	]*\(".*"\)/  {\1/
+  tb
+# Append the next line
+  :b
+  N
+# Look whether second part is continuation line.
+  s/\(.*\)"\(\n\)"\(.*"\)/\1\2\3/
+# Yes, then branch.
+  ta
+# Because we assume that the input file correctly formed the line
+# just read cannot be again be a msgid line.  So it's safe to ignore
+# it.
+  s/\(.*\)\n.*/\1/
+  bc
+# We found a continuation line.  But before printing insert '\'.
+  :a
+  s/\(.*\)\(\n.*\)/\1\\\2/
+  P
+# We cannot use D here.
+  s/.*\n\(.*\)/\1/
+# Some buggy seds do not clear the `successful substitution since last ``t'''
+# flag on `N', so we do a `t' here to clear it.
+  tb
+# Not reached
+  :c
+  x
+# The following nice solution is by
+# Bruno <Haible@ma2s2.mathematik.uni-karlsruhe.de>
+  td
+# Increment a decimal number in pattern space.
+# First hide trailing `9' digits.
+  :d
+  s/9\(_*\)$/_\1/
+  td
+# Assure at least one digit is available.
+  s/^\(_*\)$/0\1/
+# Increment the last digit.
+  s/8\(_*\)$/9\1/
+  s/7\(_*\)$/8\1/
+  s/6\(_*\)$/7\1/
+  s/5\(_*\)$/6\1/
+  s/4\(_*\)$/5\1/
+  s/3\(_*\)$/4\1/
+  s/2\(_*\)$/3\1/
+  s/1\(_*\)$/2\1/
+  s/0\(_*\)$/1\1/
+# Convert the hidden `9' digits to `0's.
+  s/_/0/g
+  x
+  G
+  s/\(.*\)\n\([0-9]*\)/\1, \2},/
+  s/\(.*\)"$/\1/
+  p
+}
+#
+# Last line.
+#
+$ {
+  i\
+};\
+
+  g
+  s/0*\(.*\)/int _msg_tbl_length = \1;/p
+}
+d
diff -urN g10-0.2.0/intl/textdomain.c g10-0.2.1/intl/textdomain.c
--- g10-0.2.0/intl/textdomain.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/textdomain.c	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,97 @@
+/* textdomain.c -- implementation of the textdomain(3) function
+   Copyright (C) 1995 Software Foundation, Inc.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#if defined STDC_HEADERS || defined _LIBC
+# include <stdlib.h>
+#endif
+
+#if defined STDC_HEADERS || defined HAVE_STRING_H || defined _LIBC
+# include <string.h>
+#else
+# include <strings.h>
+#endif
+
+#ifdef _LIBC
+# include <libintl.h>
+#else
+# include "libgettext.h"
+#endif
+
+/* @@ end of prolog @@ */
+
+/* Name of the default text domain.  */
+extern const char _nl_default_default_domain[];
+
+/* Default text domain in which entries for gettext(3) are to be found.  */
+extern const char *_nl_current_default_domain;
+
+
+/* Names for the libintl functions are a problem.  They must not clash
+   with existing names and they should follow ANSI C.  But this source
+   code is also used in GNU C Library where the names have a __
+   prefix.  So we have to make a difference here.  */
+#ifdef _LIBC
+# define TEXTDOMAIN __textdomain
+#else
+# define TEXTDOMAIN textdomain__
+#endif
+
+/* Set the current default message catalog to DOMAINNAME.
+   If DOMAINNAME is null, return the current default.
+   If DOMAINNAME is "", reset to the default of "messages".  */
+char *
+TEXTDOMAIN (domainname)
+     const char *domainname;
+{
+  char *old;
+
+  /* A NULL pointer requests the current setting.  */
+  if (domainname == NULL)
+    return (char *) _nl_current_default_domain;
+
+  old = (char *) _nl_current_default_domain;
+
+  /* If domain name is the null string set to default domain "messages".  */
+  if (domainname[0] == '\0'
+      || strcmp (domainname, _nl_default_default_domain) == 0)
+    _nl_current_default_domain = _nl_default_default_domain;
+  else
+    {
+      /* If the following malloc fails `_nl_current_default_domain'
+	 will be NULL.  This value will be returned and so signals we
+	 are out of core.  */
+      size_t len = strlen (domainname) + 1;
+      char *cp = (char *) malloc (len);
+      if (cp != NULL)
+	memcpy (cp, domainname, len);
+      _nl_current_default_domain = cp;
+    }
+
+  if (old != _nl_default_default_domain)
+    free (old);
+
+  return (char *) _nl_current_default_domain;
+}
+
+#ifdef _LIBC
+/* Alias for function name in GNU C Library.  */
+weak_alias (__textdomain, textdomain);
+#endif
diff -urN g10-0.2.0/intl/xopen-msg.sed g10-0.2.1/intl/xopen-msg.sed
--- g10-0.2.0/intl/xopen-msg.sed	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/intl/xopen-msg.sed	Mon Jan 26 20:10:55 1998
@@ -0,0 +1,104 @@
+# po2msg.sed - Convert Uniforum style .po file to X/Open style .msg file
+# Copyright (C) 1995 Free Software Foundation, Inc.
+# Ulrich Drepper <drepper@gnu.ai.mit.edu>, 1995.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+#
+#
+# The first directive in the .msg should be the definition of the
+# message set number.  We use always set number 1.
+#
+1 {
+  i\
+$set 1 # Automatically created by po2msg.sed
+  h
+  s/.*/0/
+  x
+}
+#
+# We copy all comments into the .msg file.  Perhaps they can help.
+#
+/^#/ s/^#[ 	]*/$ /p
+#
+# We copy the original message as a comment into the .msg file.
+#
+/^msgid/ {
+# Does not work now
+#  /"$/! {
+#    s/\\$//
+#    s/$/ ... (more lines following)"/
+#  }
+  s/^msgid[ 	]*"\(.*\)"$/$ Original Message: \1/
+  p
+}
+#
+# The .msg file contains, other then the .po file, only the translations
+# but each given a unique ID.  Starting from 1 and incrementing by 1 for
+# each message we assign them to the messages.
+# It is important that the .po file used to generate the cat-id-tbl.c file
+# (with po-to-tbl) is the same as the one used here.  (At least the order
+# of declarations must not be changed.)
+#
+/^msgstr/ {
+  s/msgstr[ 	]*"\(.*\)"/\1/
+  x
+# The following nice solution is by
+# Bruno <Haible@ma2s2.mathematik.uni-karlsruhe.de>
+  td
+# Increment a decimal number in pattern space.
+# First hide trailing `9' digits.
+  :d
+  s/9\(_*\)$/_\1/
+  td
+# Assure at least one digit is available.
+  s/^\(_*\)$/0\1/
+# Increment the last digit.
+  s/8\(_*\)$/9\1/
+  s/7\(_*\)$/8\1/
+  s/6\(_*\)$/7\1/
+  s/5\(_*\)$/6\1/
+  s/4\(_*\)$/5\1/
+  s/3\(_*\)$/4\1/
+  s/2\(_*\)$/3\1/
+  s/1\(_*\)$/2\1/
+  s/0\(_*\)$/1\1/
+# Convert the hidden `9' digits to `0's.
+  s/_/0/g
+  x
+# Bring the line in the format `<number> <message>'
+  G
+  s/^[^\n]*$/& /
+  s/\(.*\)\n\([0-9]*\)/\2 \1/
+# Clear flag from last substitution.
+  tb
+# Append the next line.
+  :b
+  N
+# Look whether second part is a continuation line.
+  s/\(.*\n\)"\(.*\)"/\1\2/
+# Yes, then branch.
+  ta
+  P
+  D
+# Note that `D' includes a jump to the start!!
+# We found a continuation line.  But before printing insert '\'.
+  :a
+  s/\(.*\)\(\n.*\)/\1\\\2/
+  P
+# We cannot use the sed command `D' here
+  s/.*\n\(.*\)/\1/
+  tb
+}
+d
diff -urN g10-0.2.0/mpi/mpi-add.c g10-0.2.1/mpi/mpi-add.c
--- g10-0.2.0/mpi/mpi-add.c	Fri Jan 16 12:07:58 1998
+++ g10-0.2.1/mpi/mpi-add.c	Wed Jan 28 11:09:47 1998
@@ -216,11 +216,11 @@
 void
 mpi_sub(MPI w, MPI u, MPI v)
 {
-    if( 1 || w == v ) {
+    if( w == v ) {
 	MPI vv = mpi_copy(v);
 	vv->sign = !vv->sign;
 	mpi_add( w, u, vv );
-	m_free(vv);
+	mpi_free(vv);
     }
     else {
 	/* fixme: this is not thread-save (we temp. modify v) */
diff -urN g10-0.2.0/po/Makefile.in.in g10-0.2.1/po/Makefile.in.in
--- g10-0.2.0/po/Makefile.in.in	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/po/Makefile.in.in	Wed Jan 28 16:36:50 1998
@@ -0,0 +1,210 @@
+# Makefile for program source directory in GNU NLS utilities package.
+# Copyright (C) 1995 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+PACKAGE = @PACKAGE@
+VERSION = @VERSION@
+
+SHELL = /bin/sh
+@SET_MAKE@
+
+srcdir = @srcdir@
+top_srcdir = @top_srcdir@
+VPATH = @srcdir@
+
+prefix = @prefix@
+exec_prefix = @exec_prefix@
+datadir = $(prefix)/@DATADIRNAME@
+localedir = $(datadir)/locale
+gnulocaledir = $(prefix)/share/locale
+gettextsrcdir = $(prefix)/share/gettext
+subdir = po
+
+INSTALL = @INSTALL@
+INSTALL_DATA = @INSTALL_DATA@
+
+CC = @CC@
+GENCAT = @GENCAT@
+GMSGFMT = @GMSGFMT@
+MSGFMT = @MSGFMT@
+XGETTEXT = @XGETTEXT@
+TUPDATE = tupdate
+
+DEFS = @DEFS@
+CFLAGS = @CFLAGS@
+CPPFLAGS = @CPPFLAGS@
+
+INCLUDES = -I.. -I$(top_srcdir)/intl
+
+COMPILE = $(CC) -c $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS) $(XCFLAGS)
+
+SOURCES = cat-id-tbl.c
+POFILES = @POFILES@
+GMOFILES = @GMOFILES@
+DISTFILES = ChangeLog Makefile.in.in POTFILES.in $(PACKAGE).pot \
+	    $(POFILES) $(SOURCES)
+
+POTFILES = \
+
+CATALOGS = @CATALOGS@
+CATOBJEXT = @CATOBJEXT@
+INSTOBJEXT = @INSTOBJEXT@
+
+.SUFFIXES:
+.SUFFIXES: .c .o .po .pox .gmo .mo .msg .cat
+
+.c.o:
+	$(COMPILE) $<
+
+.po.pox:
+	$(MAKE) $(PACKAGE).pot
+	$(TUPDATE) $(srcdir)/$(PACKAGE).pot $< > $*.pox
+
+.po.mo:
+	$(MSGFMT) -o $@ $<
+
+.po.gmo:
+	file=$(srcdir)/`echo $* | sed 's,.*/,,'`.gmo \
+	  && rm -f $$file && $(GMSGFMT) -o $$file $<
+
+.po.cat:
+	sed -f ../intl/po2msg.sed < $< > $*.msg \
+	  && rm -f $@ && $(GENCAT) $@ $*.msg
+
+
+all: cat-id-tbl.c $(CATALOGS)
+
+$(PACKAGE).pot: $(POTFILES)
+	$(XGETTEXT) --default-domain=$(PACKAGE) --directory=$(top_srcdir) \
+	  --add-comments --keyword=_ --keyword=N_ \
+	  --files-from=$(srcdir)/POTFILES.in
+	if cmp -s $(PACKAGE).po $(srcdir)/$(PACKAGE).pot; then \
+	  rm -f $(PACKAGE).po; \
+	else \
+	  rm -f $(srcdir)/$(PACKAGE).pot \
+	    && mv $(PACKAGE).po $(srcdir)/$(PACKAGE).pot; \
+	fi
+
+cat-id-tbl.c: stamp-cat-id
+stamp-cat-id: $(PACKAGE).pot
+	rm -f cat-id-tbl.tmp.c
+	sed -f ../intl/po2tbl.sed $(srcdir)/$(PACKAGE).pot \
+		| sed -e "s/@PACKAGE NAME@/$(PACKAGE)/" > cat-id-tbl.tmp.c
+	if cmp -s cat-id-tbl.tmp.c $(srcdir)/cat-id-tbl.c; then \
+	  rm cat-id-tbl.tmp.c; \
+	else \
+	  echo cat-id-tbl.c changed; \
+	  rm -f $(srcdir)/cat-id-tbl.c; \
+	  mv cat-id-tbl.tmp.c $(srcdir)/cat-id-tbl.c; \
+	fi
+	cd $(srcdir) && rm -f stamp-cat-id && echo timestamp > stamp-cat-id
+
+
+install: install-exec install-data
+install-exec:
+install-data: all
+	$(top_srcdir)/scripts/mkinstalldirs $(datadir)
+	catalogs='$(CATALOGS)'; \
+	for cat in $$catalogs; do \
+	  if test "`echo $$cat | sed 's/.*\(\..*\)/\1/'`" = ".gmo"; then \
+	    destdir=$(gnulocaledir); \
+	  else \
+	    destdir=$(localedir); \
+	  fi; \
+	  lang=`echo $$cat | sed 's/$(CATOBJEXT)$$//'`; \
+	  dir=$$destdir/$$lang/LC_MESSAGES; \
+	  $(top_srcdir)/scripts/mkinstalldirs $$dir; \
+	  if test -r $$cat; then \
+	    $(INSTALL_DATA) $$cat $$dir/$(PACKAGE)$(INSTOBJEXT); \
+	  else \
+	    $(INSTALL_DATA) $(srcdir)/$$cat $$dir/$(PACKAGE)$(INSTOBJEXT); \
+	  fi; \
+	done
+
+# This installation goal is only used in GNU gettext.  Packages which
+# only use the library should use install instead.
+install-src: install
+	$(top_srcdir)/scripts/mkinstalldirs $(gettextsrcdir)
+	cd $(srcdir) && \
+	  $(INSTALL_DATA) Makefile.in.in $(gettextsrcdir)/po-Makefile.in.in
+
+uninstall:
+	catalogs='$(CATALOGS)'; \
+	for cat in $$catalogs; do \
+	  lang=`echo $$cat | sed 's/$(CATOBJEXT)$$//'`; \
+	  rm -f $(localedir)/$$lang/LC_MESSAGES/$(PACKAGE)$(INSTOBJEXT); \
+	  rm -f $(gnulocaledir)/$$lang/LC_MESSAGES/$(PACKAGE)$(INSTOBJEXT); \
+	done
+	rm -f $(gettextsrcdir)/po-Makefile.in.in
+
+check: all
+
+cat-id-tbl.o: ../intl/libgettext.h
+
+TAGS ID:
+
+mostlyclean:
+	rm -f core core.* *.pox $(PACKAGE).po *.old.po cat-id-tbl.tmp.c
+
+clean: mostlyclean
+
+distclean: clean
+	rm -f Makefile Makefile.in POTFILES *.mo *.msg *.cat
+
+maintainer-clean: distclean
+	@echo "This command is intended for maintainers to use;"
+	@echo "it deletes files that may require special tools to rebuild."
+
+distdir = $(top_builddir)/$(PACKAGE)-$(VERSION)/$(subdir)
+distdir: $(DEP_DISTFILES)
+	@for file in `cd $(srcdir) && echo $(DISTFILES)`; do \
+	  test -f $(distdir)/$$file \
+	  || ln $(srcdir)/$$file $(distdir)/$$file 2> /dev/null \
+	  || cp -p $(srcdir)/$$file $(distdir)/$$file; \
+	done
+
+update-po: Makefile
+	$(MAKE) $(PACKAGE).pot
+	cd $(srcdir); \
+	catalogs='$(CATALOGS)'; \
+	for cat in $$catalogs; do \
+	  lang=`echo $$cat | sed 's/$(CATOBJEXT)$$//'`; \
+	  mv $$lang.po $$lang.old.po; \
+	  if $(TUPDATE) $(PACKAGE).pot $$lang.old.po > $$lang.po; then \
+	    rm -f $$lang.old.po; \
+	  else \
+	    echo "tupdate for $$cat failed!"; \
+	    rm -f $$lang.po; \
+	    mv $$lang.old.po $$lang.po; \
+	  fi; \
+	done
+
+POTFILES: POTFILES.in
+	( if test 'x$(srcdir)' != 'x.'; then \
+	    posrcprefix='$(top_srcdir)/'; \
+	  else \
+	    posrcprefix="../"; \
+	  fi; \
+	  sed -e '/^#/d' -e '/^[        ]*$$/d' \
+	      -e "s@.*@ $$posrcprefix& \\\\@" \
+	      -e '$$s/\(.*\) \\/\1/' < $(srcdir)/POTFILES.in > POTFILES )
+
+Makefile: Makefile.in.in ../config.status POTFILES
+	cd .. && CONFIG_FILES=$(subdir)/$@.in CONFIG_HEADERS= ./config.status
+
+# Tell versions [3.59,3.63) of GNU make not to export all variables.
+# Otherwise a system limit (for SysV at least) may be exceeded.
+.NOEXPORT:
diff -urN g10-0.2.0/po/POTFILES.in g10-0.2.1/po/POTFILES.in
--- g10-0.2.0/po/POTFILES.in	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/po/POTFILES.in	Tue Jan 27 15:46:35 1998
@@ -0,0 +1,15 @@
+# List of source files containing translatable strings for G10.
+# Copyright (c) 1998 by Werner Koch (dd9jn)
+
+# utility
+
+# cipher
+cipher/random.c
+
+
+# main program
+
+g10/g10.c
+g10/pkclist.c
+g10/keygen.c
+
diff -urN g10-0.2.0/po/cat-id-tbl.c g10-0.2.1/po/cat-id-tbl.c
--- g10-0.2.0/po/cat-id-tbl.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/po/cat-id-tbl.c	Tue Jan 27 15:55:52 1998
@@ -0,0 +1,178 @@
+/* Automatically generated by po2tbl.sed from g10.pot.  */
+
+#if HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#include "libgettext.h"
+
+const struct _msg_ent _msg_tbl[] = {
+  {"", 1},
+  {"\
+\n\
+Not enough random bytes available.  Please do some other work to give", 2},
+  {"warning: using insecure random number generator!!\n", 3},
+  {"\
+The random number generator is only a kludge to let\n\
+it compile - it is in no way a strong RNG!\n\
+\n\
+DON'T USE ANY DATA GENERATED BY THIS PROGRAM!!\n\
+\n", 4},
+  {"\
+Syntax: g10 [options] [files]\n\
+sign, check, encrypt or decrypt\n\
+default operation depends on the input data\n", 5},
+  {"Please report bugs to <g10-bugs@isil.d.shuttle.de>.\n", 6},
+  {"\
+   NOTE: This version is compiled without ZLIB support;\n\
+         you are not able to process compresssed data!\n\
+WARNING: This version has RSA support! Your are not allowed to\n\
+         use it inside the Unites States before Sep 30, 2000!\n", 7},
+  {"\
+   NOTE: This version is compiled without ZLIB support;\n\
+         you are not able to process compresssed data!\n", 8},
+  {"\
+WARNING: This version has RSA support! Your are not allowed to\n\
+         use it inside the Unites States before Sep 30, 2000!\n", 9},
+  {"Usage: g10 [options] ", 10},
+  {"conflicting commands\n", 11},
+  {"create ascii armored output", 12},
+  {"verbose", 13},
+  {"set compress level (0 disables)", 14},
+  {"don't make any changes", 15},
+  {"do only a symmetric encryption", 16},
+  {"use as output file", 17},
+  {"batch mode: never ask", 18},
+  {"assume yes on most questions", 19},
+  {"assume no on most questions", 20},
+  {"generate a new key pair", 21},
+  {"add key to the public keyring", 22},
+  {"remove key from public keyring", 23},
+  {"make a signature on a key in the keyring", 24},
+  {"store only", 25},
+  {"check signatures on a key in the keyring", 26},
+  {"add this keyring to the list of keyrings", 27},
+  {"make a signature", 28},
+  {"use canonical text mode", 29},
+  {"make a detached signature", 30},
+  {"encrypt data", 31},
+  {"decrypt data (default)", 32},
+  {"use this user-id to sign or decrypt", 33},
+  {"use this user-id for encryption", 34},
+  {"list keys", 35},
+  {"set debugging flags", 36},
+  {"enable full debugging", 37},
+  {"show the fingerprints", 38},
+  {"print all message digests", 39},
+  {"add this secret keyring to the list", 40},
+  {"read options from file", 41},
+  {"list only the sequence of packets", 42},
+  {"edit a key signature", 43},
+  {"change the passphrase of your secret keyring", 44},
+  {"select default cipher algorithm", 45},
+  {"select default puplic key algorithm", 46},
+  {"select default message digest algorithm", 47},
+  {"put public keys into the trustdb", 48},
+  {"do not write comment packets", 49},
+  {"(default is 1)", 50},
+  {"(default is 3)", 51},
+  {"export all or the given keys", 52},
+  {"note: no default option file '%s'\n", 53},
+  {"option file '%s': %s\n", 54},
+  {"reading options from '%s'\n", 55},
+  {"selected cipher algorithm is invalid\n", 56},
+  {"selected pubkey algorithm is invalid\n", 57},
+  {"selected digest algorithm is invalid\n", 58},
+  {"completes-needed must be greater than 0\n", 59},
+  {"marginals-needed must be greater than 1\n", 60},
+  {"failed to initialize the TrustDB: %s\n", 61},
+  {"can't open '%s'\n", 62},
+  {"\
+No ownertrust defined for %lu:\n\
+%4u%c/%08lX %s \"", 63},
+  {"\
+\"\n\
+\n\
+Please decide in how far do you trust this user to\n\
+correctly sign other users keys (looking at his passport,\n\
+checking the fingerprints from different sources ...)?\n\
+\n\
+ 1 = Don't know\n\
+ 2 = I do NOT trust\n\
+ 3 = I trust marginally\n\
+ 4 = I trust fully\n\
+ s = please show me more informations\n\
+\n", 64},
+  {"Your decision? ", 65},
+  {"\
+It's up to you to assign a value here; this value will never be exported\n\
+to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n\
+to do with the (implicitly created) web-of-certificates.\n", 66},
+  {"You will see a list of signators etc. here\n", 67},
+  {"\
+Could not find a valid trust path to the key.  Lets see, wether we\n\
+can assign some missing owner trust values.\n\
+\n", 68},
+  {"writing self signature\n", 69},
+  {"Key generation can only be used in interactive mode\n", 70},
+  {"\
+Please select the algorithm to use:\n\
+   (1) ElGamal is the suggested one.\n\
+   (2) DSA can only be used for signatures.\n", 71},
+  {"   (3) RSA cannot be used in the U.S.\n", 72},
+  {"Your selection? (1,2,3) ", 73},
+  {"Your selection? (1,2) ", 74},
+  {"Sorry; DSA is not yet supported.\n", 75},
+  {"\
+About to generate a new %s keypair.\n\
+              minimum keysize is  768 bits\n\
+              default keysize is 1024 bits\n\
+    highest suggested keysize is 2048 bits\n", 76},
+  {"What keysize do you want? (1024) ", 77},
+  {"DSA does only allow keysizes from 512 to 1024\n", 78},
+  {"keysize too small; 768 is smallest value allowed.\n", 79},
+  {"Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n", 80},
+  {"Are you sure, that you want this keysize? ", 81},
+  {"Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n", 82},
+  {"Requested keysize is %u bits\n", 83},
+  {"rounded up to %u bits\n", 84},
+  {"\
+\n\
+You need a User-ID to identify your key; the software constructs the user id\n\
+from Real Name, Comment and Email Address in this form:\n\
+    \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n\
+\n", 85},
+  {"Real name: ", 86},
+  {"Invalid character in name\n", 87},
+  {"Name may not start with a digit\n", 88},
+  {"Name must be at least 5 characters long\n", 89},
+  {"Email address: ", 90},
+  {"Not a valid email address\n", 91},
+  {"Comment: ", 92},
+  {"Invalid character in comment\n", 93},
+  {"\
+You selected this USER-ID:\n\
+    \"%s\"\n\
+\n", 94},
+  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 95},
+  {"\
+You need a Passphrase to protect your secret key.\n\
+\n", 96},
+  {"\
+You don't what a passphrase - this is probably a *bad* idea!\n\
+I will do it anyway.  You can change your passphrase at anytime,\n\
+using this program with the option \"--change-passphrase\"\n\
+\n", 97},
+  {"passphrase not correctly repeated; try again.\n", 98},
+  {"writing public certificate to '%s'\n", 99},
+  {"writing secret certificate to '%s'\n", 100},
+  {"\
+We need to generate a lot of random bytes. It is a good idea to perform\n\
+some other action (work in another window, move the mouse, utilize the\n\
+network and the disks) during the prime generation; this gives the random\n\
+number generator a better chance to gain enough entropy.\n", 101},
+  {"public and secret key created and signed.\n", 102},
+  {"Key generation failed: %s\n", 103},
+};
+
+int _msg_tbl_length = 103;
diff -urN g10-0.2.0/po/de.po g10-0.2.1/po/de.po
--- g10-0.2.0/po/de.po	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/po/de.po	Wed Jan 28 15:40:04 1998
@@ -0,0 +1,500 @@
+msgid ""
+msgstr ""
+"Date: 1998-01-26 22:08:36+0100\n"
+"From: Werner Koch <wk@frodo>\n"
+"Content-Type: text/plain; charset=\n"
+"Xgettext-Options: --default-domain=g10 --directory=.. --add-comments --keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
+"Files: g10/g10.c g10/pkclist.c\n"
+
+#: cipher/random.c:146
+msgid ""
+"\n"
+"Not enough random bytes available.  Please do some other work to give"
+msgstr ""
+
+#: cipher/random.c:185
+msgid "warning: using insecure random number generator!!\n"
+msgstr ""
+
+#: cipher/random.c:186
+msgid ""
+"The random number generator is only a kludge to let\n"
+"it compile - it is in no way a strong RNG!\n"
+"\n"
+"DON'T USE ANY DATA GENERATED BY THIS PROGRAM!!\n"
+"\n"
+msgstr ""
+
+#: g10/g10.c:72
+msgid ""
+"Syntax: g10 [options] [files]\n"
+"sign, check, encrypt or decrypt\n"
+"default operation depends on the input data\n"
+msgstr ""
+
+#: g10/g10.c:77
+msgid "Please report bugs to <g10-bugs@isil.d.shuttle.de>.\n"
+msgstr "Berichte ber Wanzen bitte an <g10-bugs@isil.d.shuttle.de>.\n"
+
+#: g10/g10.c:82
+msgid ""
+"   NOTE: This version is compiled without ZLIB support;\n"
+"         you are not able to process compresssed data!\n"
+"WARNING: This version has RSA support! Your are not allowed to\n"
+"         use it inside the Unites States before Sep 30, 2000!\n"
+msgstr ""
+"Achtung: Komprimierte Daten knnen nicht bearbeiten werden,\n"
+"         da auf diesem System ZLIN nicht installiert ist!\n"
+"         (RSA Verfahren ist vorhanden.)\n"
+
+#: g10/g10.c:88
+msgid ""
+"   NOTE: This version is compiled without ZLIB support;\n"
+"         you are not able to process compresssed data!\n"
+msgstr ""
+"Achtung: Komprimierte Daten knnen nicht bearbeiten werden,\n"
+"         da auf diesem System ZLIB nicht installiert ist!\n"
+
+#: g10/g10.c:92
+msgid ""
+"WARNING: This version has RSA support! Your are not allowed to\n"
+"         use it inside the Unites States before Sep 30, 2000!\n"
+msgstr ""
+"         (RSA Verfahren ist vorhanden.)\n"
+
+#: g10/g10.c:116
+msgid "Usage: g10 [options] "
+msgstr "Aufruf: g10 [Opeionen] "
+
+#: g10/g10.c:152
+msgid "conflicting commands\n"
+msgstr ""
+
+#: g10/g10.c:164
+msgid "create ascii armored output"
+msgstr "Ausgabe mit ASCII Armor versehen"
+
+#: g10/g10.c:165
+msgid "verbose"
+msgstr "detailierte Informationen"
+
+#: g10/g10.c:166
+msgid "set compress level (0 disables)"
+msgstr "Kompressionspegel sethen (aussschalten mit 0)"
+
+#: g10/g10.c:167
+msgid "don't make any changes"
+msgstr "Keine wirklichen nderungen durchfhren"
+
+#: g10/g10.c:168
+msgid "do only a symmetric encryption"
+msgstr ""
+
+#: g10/g10.c:169
+msgid "use as output file"
+msgstr ""
+
+#: g10/g10.c:170
+msgid "batch mode: never ask"
+msgstr ""
+
+#: g10/g10.c:171
+msgid "assume yes on most questions"
+msgstr ""
+
+#: g10/g10.c:172
+msgid "assume no on most questions"
+msgstr ""
+
+#: g10/g10.c:173
+msgid "generate a new key pair"
+msgstr ""
+
+#: g10/g10.c:174
+msgid "add key to the public keyring"
+msgstr ""
+
+#: g10/g10.c:175
+msgid "remove key from public keyring"
+msgstr "Key entfernen"
+
+#: g10/g10.c:176
+msgid "make a signature on a key in the keyring"
+msgstr "key signieren"
+
+#: g10/g10.c:177
+msgid "store only"
+msgstr ""
+
+#: g10/g10.c:178
+msgid "check signatures on a key in the keyring"
+msgstr "  "
+
+#: g10/g10.c:179
+msgid "add this keyring to the list of keyrings"
+msgstr ""
+
+#: g10/g10.c:180
+msgid "make a signature"
+msgstr ""
+
+#: g10/g10.c:181
+msgid "use canonical text mode"
+msgstr ""
+
+#: g10/g10.c:182
+msgid "make a detached signature"
+msgstr ""
+
+#: g10/g10.c:183
+msgid "encrypt data"
+msgstr ""
+
+#: g10/g10.c:184
+msgid "decrypt data (default)"
+msgstr ""
+
+#: g10/g10.c:185
+msgid "use this user-id to sign or decrypt"
+msgstr ""
+
+#: g10/g10.c:186
+msgid "use this user-id for encryption"
+msgstr ""
+
+#: g10/g10.c:187
+msgid "list keys"
+msgstr ""
+
+#: g10/g10.c:188
+msgid "set debugging flags"
+msgstr ""
+
+#: g10/g10.c:189
+msgid "enable full debugging"
+msgstr ""
+
+#: g10/g10.c:193
+msgid "show the fingerprints"
+msgstr ""
+
+#: g10/g10.c:194
+msgid "print all message digests"
+msgstr ""
+
+#: g10/g10.c:195
+msgid "add this secret keyring to the list"
+msgstr ""
+
+#: g10/g10.c:196
+msgid "read options from file"
+msgstr ""
+
+#: g10/g10.c:199
+msgid "list only the sequence of packets"
+msgstr ""
+
+#: g10/g10.c:202
+msgid "edit a key signature"
+msgstr ""
+
+#: g10/g10.c:203
+msgid "change the passphrase of your secret keyring"
+msgstr ""
+
+#: g10/g10.c:205
+msgid "select default cipher algorithm"
+msgstr ""
+
+#: g10/g10.c:206
+msgid "select default puplic key algorithm"
+msgstr ""
+
+#: g10/g10.c:207
+msgid "select default message digest algorithm"
+msgstr ""
+
+#: g10/g10.c:208
+msgid "put public keys into the trustdb"
+msgstr ""
+
+#: g10/g10.c:212
+msgid "do not write comment packets"
+msgstr ""
+
+#: g10/g10.c:213
+msgid "(default is 1)"
+msgstr ""
+
+#: g10/g10.c:214
+msgid "(default is 3)"
+msgstr ""
+
+#: g10/g10.c:215
+msgid "export all or the given keys"
+msgstr ""
+
+#: g10/g10.c:282
+msgid "note: no default option file '%s'\n"
+msgstr ""
+
+#: g10/g10.c:285
+msgid "option file '%s': %s\n"
+msgstr ""
+
+#: g10/g10.c:290
+msgid "reading options from '%s'\n"
+msgstr ""
+
+#: g10/g10.c:382
+msgid "selected cipher algorithm is invalid\n"
+msgstr ""
+
+#: g10/g10.c:386
+msgid "selected pubkey algorithm is invalid\n"
+msgstr ""
+
+#: g10/g10.c:390
+msgid "selected digest algorithm is invalid\n"
+msgstr ""
+
+#: g10/g10.c:394
+msgid "completes-needed must be greater than 0\n"
+msgstr ""
+
+#: g10/g10.c:398
+msgid "marginals-needed must be greater than 1\n"
+msgstr ""
+
+#: g10/g10.c:462
+msgid "failed to initialize the TrustDB: %s\n"
+msgstr ""
+
+#: g10/g10.c:554 g10/g10.c:571 g10/g10.c:660
+msgid "can't open '%s'\n"
+msgstr ""
+
+#: g10/pkclist.c:65
+msgid ""
+"No ownertrust defined for %lu:\n"
+"%4u%c/%08lX %s \""
+msgstr ""
+
+#: g10/pkclist.c:72
+msgid ""
+"\"\n"
+"\n"
+"Please decide in how far do you trust this user to\n"
+"correctly sign other users keys (looking at his passport,\n"
+"checking the fingerprints from different sources ...)?\n"
+"\n"
+" 1 = Don't know\n"
+" 2 = I do NOT trust\n"
+" 3 = I trust marginally\n"
+" 4 = I trust fully\n"
+" s = please show me more informations\n"
+"\n"
+msgstr ""
+"\"\n"
+"\n"
+"Bitte entscheiden Sie, in wieweit Sie diesem User zutrauen,\n"
+"eines anderen Users Key korrekt zu signieren (Vergleich mit dem Pa,\n"
+"vergleichen der Fingerprints aus unterschiedlichen Quellen ...)?\n"
+"\n"
+" 1 = Wei nicht so recht\n"
+" 2 = Neeh, dem traue ich das nicht zu\n"
+" 3 = Ich vertraue ihm normalerweise\n"
+" 4 = Ich vertraue ihm immer\n"
+" s = Bitte weitere Information anzeigen\n"
+"\n"
+
+#: g10/pkclist.c:83
+msgid "Your decision? "
+msgstr "Ihre Auswahl? "
+
+#: g10/pkclist.c:90
+msgid ""
+"It's up to you to assign a value here; this value will never be exported\n"
+"to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n"
+"to do with the (implicitly created) web-of-certificates.\n"
+msgstr ""
+
+#: g10/pkclist.c:108
+msgid "You will see a list of signators etc. here\n"
+msgstr ""
+
+#: g10/pkclist.c:132
+msgid ""
+"Could not find a valid trust path to the key.  Lets see, wether we\n"
+"can assign some missing owner trust values.\n"
+"\n"
+msgstr ""
+"Ein gltiger Trust Path konnte fr diesen Key nicht gefunden werden.\n"
+"Mal sehen ob wir now weitere Ownertrust Werte zuordnen knnen.\n"
+"\n"
+
+#: g10/keygen.c:109
+msgid "writing self signature\n"
+msgstr ""
+
+#: g10/keygen.c:299
+msgid "Key generation can only be used in interactive mode\n"
+msgstr ""
+
+#: g10/keygen.c:301
+msgid ""
+"Please select the algorithm to use:\n"
+"   (1) ElGamal is the suggested one.\n"
+"   (2) DSA can only be used for signatures.\n"
+msgstr ""
+
+#: g10/keygen.c:305
+msgid "   (3) RSA cannot be used in the U.S.\n"
+msgstr ""
+
+#: g10/keygen.c:314
+msgid "Your selection? (1,2,3) "
+msgstr ""
+
+#: g10/keygen.c:316
+msgid "Your selection? (1,2) "
+msgstr ""
+
+#: g10/keygen.c:330
+msgid "Sorry; DSA is not yet supported.\n"
+msgstr ""
+
+#: g10/keygen.c:343
+msgid ""
+"About to generate a new %s keypair.\n"
+"              minimum keysize is  768 bits\n"
+"              default keysize is 1024 bits\n"
+"    highest suggested keysize is 2048 bits\n"
+msgstr ""
+
+#: g10/keygen.c:351
+msgid "What keysize do you want? (1024) "
+msgstr ""
+
+#: g10/keygen.c:357
+msgid "DSA does only allow keysizes from 512 to 1024\n"
+msgstr ""
+
+#: g10/keygen.c:359
+msgid "keysize too small; 768 is smallest value allowed.\n"
+msgstr ""
+
+#: g10/keygen.c:361
+msgid "Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n"
+msgstr ""
+
+#: g10/keygen.c:363
+msgid "Are you sure, that you want this keysize? "
+msgstr ""
+
+#: g10/keygen.c:367
+msgid "Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n"
+msgstr ""
+
+#: g10/keygen.c:377
+msgid "Requested keysize is %u bits\n"
+msgstr ""
+
+#: g10/keygen.c:380 g10/keygen.c:384
+msgid "rounded up to %u bits\n"
+msgstr ""
+
+#: g10/keygen.c:391
+msgid ""
+"\n"
+"You need a User-ID to identify your key; the software constructs the user id\n"
+"from Real Name, Comment and Email Address in this form:\n"
+"    \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n"
+"\n"
+msgstr ""
+
+#: g10/keygen.c:403
+msgid "Real name: "
+msgstr ""
+
+#: g10/keygen.c:407
+msgid "Invalid character in name\n"
+msgstr ""
+
+#: g10/keygen.c:409
+msgid "Name may not start with a digit\n"
+msgstr ""
+
+#: g10/keygen.c:411
+msgid "Name must be at least 5 characters long\n"
+msgstr ""
+
+#: g10/keygen.c:419
+msgid "Email address: "
+msgstr ""
+
+#: g10/keygen.c:431
+msgid "Not a valid email address\n"
+msgstr ""
+
+#: g10/keygen.c:439
+msgid "Comment: "
+msgstr ""
+
+#. no comment is okay
+#: g10/keygen.c:445
+msgid "Invalid character in comment\n"
+msgstr ""
+
+#: g10/keygen.c:465
+msgid ""
+"You selected this USER-ID:\n"
+"    \"%s\"\n"
+"\n"
+msgstr ""
+
+#: g10/keygen.c:467
+msgid "Edit (N)ame, (C)omment, (E)mail or (O)kay? "
+msgstr ""
+
+#: g10/keygen.c:499
+msgid ""
+"You need a Passphrase to protect your secret key.\n"
+"\n"
+msgstr ""
+
+#: g10/keygen.c:508
+msgid ""
+"You don't what a passphrase - this is probably a *bad* idea!\n"
+"I will do it anyway.  You can change your passphrase at anytime,\n"
+"using this program with the option \"--change-passphrase\"\n"
+"\n"
+msgstr ""
+
+#: g10/keygen.c:514
+msgid "passphrase not correctly repeated; try again.\n"
+msgstr ""
+
+#: g10/keygen.c:531
+msgid "writing public certificate to '%s'\n"
+msgstr ""
+
+#: g10/keygen.c:532
+msgid "writing secret certificate to '%s'\n"
+msgstr ""
+
+#: g10/keygen.c:544
+msgid ""
+"We need to generate a lot of random bytes. It is a good idea to perform\n"
+"some other action (work in another window, move the mouse, utilize the\n"
+"network and the disks) during the prime generation; this gives the random\n"
+"number generator a better chance to gain enough entropy.\n"
+msgstr ""
+
+#: g10/keygen.c:611
+msgid "public and secret key created and signed.\n"
+msgstr ""
+
+#: g10/keygen.c:622
+msgid "Key generation failed: %s\n"
+msgstr ""
diff -urN g10-0.2.0/po/g10.pot g10-0.2.1/po/g10.pot
--- g10-0.2.0/po/g10.pot	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/po/g10.pot	Wed Jan 28 15:23:44 1998
@@ -0,0 +1,479 @@
+msgid ""
+msgstr ""
+"Date: 1998-01-28 15:23:44+0100\n"
+"From: Werner Koch <wk@frodo>\n"
+"Content-Type: text/plain; charset=\n"
+"Xgettext-Options: --default-domain=g10 --directory=.. --add-comments --keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
+"Files: cipher/random.c g10/g10.c g10/pkclist.c g10/keygen.c\n"
+
+#: cipher/random.c:146
+msgid ""
+"\n"
+"Not enough random bytes available.  Please do some other work to give"
+msgstr ""
+
+#: cipher/random.c:185
+msgid "warning: using insecure random number generator!!\n"
+msgstr ""
+
+#: cipher/random.c:186
+msgid ""
+"The random number generator is only a kludge to let\n"
+"it compile - it is in no way a strong RNG!\n"
+"\n"
+"DON'T USE ANY DATA GENERATED BY THIS PROGRAM!!\n"
+"\n"
+msgstr ""
+
+#: g10/g10.c:72
+msgid ""
+"Syntax: g10 [options] [files]\n"
+"sign, check, encrypt or decrypt\n"
+"default operation depends on the input data\n"
+msgstr ""
+
+#: g10/g10.c:77
+msgid "Please report bugs to <g10-bugs@isil.d.shuttle.de>.\n"
+msgstr ""
+
+#: g10/g10.c:82
+msgid ""
+"   NOTE: This version is compiled without ZLIB support;\n"
+"         you are not able to process compresssed data!\n"
+"WARNING: This version has RSA support! Your are not allowed to\n"
+"         use it inside the Unites States before Sep 30, 2000!\n"
+msgstr ""
+
+#: g10/g10.c:88
+msgid ""
+"   NOTE: This version is compiled without ZLIB support;\n"
+"         you are not able to process compresssed data!\n"
+msgstr ""
+
+#: g10/g10.c:92
+msgid ""
+"WARNING: This version has RSA support! Your are not allowed to\n"
+"         use it inside the Unites States before Sep 30, 2000!\n"
+msgstr ""
+
+#: g10/g10.c:116
+msgid "Usage: g10 [options] "
+msgstr ""
+
+#: g10/g10.c:152
+msgid "conflicting commands\n"
+msgstr ""
+
+#: g10/g10.c:164
+msgid "create ascii armored output"
+msgstr ""
+
+#: g10/g10.c:165
+msgid "verbose"
+msgstr ""
+
+#: g10/g10.c:166
+msgid "set compress level (0 disables)"
+msgstr ""
+
+#: g10/g10.c:167
+msgid "don't make any changes"
+msgstr ""
+
+#: g10/g10.c:168
+msgid "do only a symmetric encryption"
+msgstr ""
+
+#: g10/g10.c:169
+msgid "use as output file"
+msgstr ""
+
+#: g10/g10.c:170
+msgid "batch mode: never ask"
+msgstr ""
+
+#: g10/g10.c:171
+msgid "assume yes on most questions"
+msgstr ""
+
+#: g10/g10.c:172
+msgid "assume no on most questions"
+msgstr ""
+
+#: g10/g10.c:173
+msgid "generate a new key pair"
+msgstr ""
+
+#: g10/g10.c:174
+msgid "add key to the public keyring"
+msgstr ""
+
+#: g10/g10.c:175
+msgid "remove key from public keyring"
+msgstr ""
+
+#: g10/g10.c:176
+msgid "make a signature on a key in the keyring"
+msgstr ""
+
+#: g10/g10.c:177
+msgid "store only"
+msgstr ""
+
+#: g10/g10.c:178
+msgid "check signatures on a key in the keyring"
+msgstr ""
+
+#: g10/g10.c:179
+msgid "add this keyring to the list of keyrings"
+msgstr ""
+
+#: g10/g10.c:180
+msgid "make a signature"
+msgstr ""
+
+#: g10/g10.c:181
+msgid "use canonical text mode"
+msgstr ""
+
+#: g10/g10.c:182
+msgid "make a detached signature"
+msgstr ""
+
+#: g10/g10.c:183
+msgid "encrypt data"
+msgstr ""
+
+#: g10/g10.c:184
+msgid "decrypt data (default)"
+msgstr ""
+
+#: g10/g10.c:185
+msgid "use this user-id to sign or decrypt"
+msgstr ""
+
+#: g10/g10.c:186
+msgid "use this user-id for encryption"
+msgstr ""
+
+#: g10/g10.c:187
+msgid "list keys"
+msgstr ""
+
+#: g10/g10.c:188
+msgid "set debugging flags"
+msgstr ""
+
+#: g10/g10.c:189
+msgid "enable full debugging"
+msgstr ""
+
+#: g10/g10.c:193
+msgid "show the fingerprints"
+msgstr ""
+
+#: g10/g10.c:194
+msgid "print all message digests"
+msgstr ""
+
+#: g10/g10.c:195
+msgid "add this secret keyring to the list"
+msgstr ""
+
+#: g10/g10.c:196
+msgid "read options from file"
+msgstr ""
+
+#: g10/g10.c:199
+msgid "list only the sequence of packets"
+msgstr ""
+
+#: g10/g10.c:202
+msgid "edit a key signature"
+msgstr ""
+
+#: g10/g10.c:203
+msgid "change the passphrase of your secret keyring"
+msgstr ""
+
+#: g10/g10.c:205
+msgid "select default cipher algorithm"
+msgstr ""
+
+#: g10/g10.c:206
+msgid "select default puplic key algorithm"
+msgstr ""
+
+#: g10/g10.c:207
+msgid "select default message digest algorithm"
+msgstr ""
+
+#: g10/g10.c:208
+msgid "put public keys into the trustdb"
+msgstr ""
+
+#: g10/g10.c:212
+msgid "do not write comment packets"
+msgstr ""
+
+#: g10/g10.c:213
+msgid "(default is 1)"
+msgstr ""
+
+#: g10/g10.c:214
+msgid "(default is 3)"
+msgstr ""
+
+#: g10/g10.c:215
+msgid "export all or the given keys"
+msgstr ""
+
+#: g10/g10.c:282
+msgid "note: no default option file '%s'\n"
+msgstr ""
+
+#: g10/g10.c:285
+msgid "option file '%s': %s\n"
+msgstr ""
+
+#: g10/g10.c:290
+msgid "reading options from '%s'\n"
+msgstr ""
+
+#: g10/g10.c:382
+msgid "selected cipher algorithm is invalid\n"
+msgstr ""
+
+#: g10/g10.c:386
+msgid "selected pubkey algorithm is invalid\n"
+msgstr ""
+
+#: g10/g10.c:390
+msgid "selected digest algorithm is invalid\n"
+msgstr ""
+
+#: g10/g10.c:394
+msgid "completes-needed must be greater than 0\n"
+msgstr ""
+
+#: g10/g10.c:398
+msgid "marginals-needed must be greater than 1\n"
+msgstr ""
+
+#: g10/g10.c:462
+msgid "failed to initialize the TrustDB: %s\n"
+msgstr ""
+
+#: g10/g10.c:554 g10/g10.c:571 g10/g10.c:660
+msgid "can't open '%s'\n"
+msgstr ""
+
+#: g10/pkclist.c:65
+msgid ""
+"No ownertrust defined for %lu:\n"
+"%4u%c/%08lX %s \""
+msgstr ""
+
+#: g10/pkclist.c:72
+msgid ""
+"\"\n"
+"\n"
+"Please decide in how far do you trust this user to\n"
+"correctly sign other users keys (looking at his passport,\n"
+"checking the fingerprints from different sources ...)?\n"
+"\n"
+" 1 = Don't know\n"
+" 2 = I do NOT trust\n"
+" 3 = I trust marginally\n"
+" 4 = I trust fully\n"
+" s = please show me more informations\n"
+"\n"
+msgstr ""
+
+#: g10/pkclist.c:83
+msgid "Your decision? "
+msgstr ""
+
+#: g10/pkclist.c:90
+msgid ""
+"It's up to you to assign a value here; this value will never be exported\n"
+"to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n"
+"to do with the (implicitly created) web-of-certificates.\n"
+msgstr ""
+
+#: g10/pkclist.c:108
+msgid "You will see a list of signators etc. here\n"
+msgstr ""
+
+#: g10/pkclist.c:132
+msgid ""
+"Could not find a valid trust path to the key.  Lets see, wether we\n"
+"can assign some missing owner trust values.\n"
+"\n"
+msgstr ""
+
+#: g10/keygen.c:109
+msgid "writing self signature\n"
+msgstr ""
+
+#: g10/keygen.c:299
+msgid "Key generation can only be used in interactive mode\n"
+msgstr ""
+
+#: g10/keygen.c:301
+msgid ""
+"Please select the algorithm to use:\n"
+"   (1) ElGamal is the suggested one.\n"
+"   (2) DSA can only be used for signatures.\n"
+msgstr ""
+
+#: g10/keygen.c:305
+msgid "   (3) RSA cannot be used in the U.S.\n"
+msgstr ""
+
+#: g10/keygen.c:314
+msgid "Your selection? (1,2,3) "
+msgstr ""
+
+#: g10/keygen.c:316
+msgid "Your selection? (1,2) "
+msgstr ""
+
+#: g10/keygen.c:330
+msgid "Sorry; DSA is not yet supported.\n"
+msgstr ""
+
+#: g10/keygen.c:343
+msgid ""
+"About to generate a new %s keypair.\n"
+"              minimum keysize is  768 bits\n"
+"              default keysize is 1024 bits\n"
+"    highest suggested keysize is 2048 bits\n"
+msgstr ""
+
+#: g10/keygen.c:351
+msgid "What keysize do you want? (1024) "
+msgstr ""
+
+#: g10/keygen.c:357
+msgid "DSA does only allow keysizes from 512 to 1024\n"
+msgstr ""
+
+#: g10/keygen.c:359
+msgid "keysize too small; 768 is smallest value allowed.\n"
+msgstr ""
+
+#: g10/keygen.c:361
+msgid "Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n"
+msgstr ""
+
+#: g10/keygen.c:363
+msgid "Are you sure, that you want this keysize? "
+msgstr ""
+
+#: g10/keygen.c:367
+msgid "Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n"
+msgstr ""
+
+#: g10/keygen.c:377
+msgid "Requested keysize is %u bits\n"
+msgstr ""
+
+#: g10/keygen.c:380 g10/keygen.c:384
+msgid "rounded up to %u bits\n"
+msgstr ""
+
+#: g10/keygen.c:391
+msgid ""
+"\n"
+"You need a User-ID to identify your key; the software constructs the user id\n"
+"from Real Name, Comment and Email Address in this form:\n"
+"    \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n"
+"\n"
+msgstr ""
+
+#: g10/keygen.c:403
+msgid "Real name: "
+msgstr ""
+
+#: g10/keygen.c:407
+msgid "Invalid character in name\n"
+msgstr ""
+
+#: g10/keygen.c:409
+msgid "Name may not start with a digit\n"
+msgstr ""
+
+#: g10/keygen.c:411
+msgid "Name must be at least 5 characters long\n"
+msgstr ""
+
+#: g10/keygen.c:419
+msgid "Email address: "
+msgstr ""
+
+#: g10/keygen.c:431
+msgid "Not a valid email address\n"
+msgstr ""
+
+#: g10/keygen.c:439
+msgid "Comment: "
+msgstr ""
+
+#. no comment is okay
+#: g10/keygen.c:445
+msgid "Invalid character in comment\n"
+msgstr ""
+
+#: g10/keygen.c:465
+msgid ""
+"You selected this USER-ID:\n"
+"    \"%s\"\n"
+"\n"
+msgstr ""
+
+#: g10/keygen.c:467
+msgid "Edit (N)ame, (C)omment, (E)mail or (O)kay? "
+msgstr ""
+
+#: g10/keygen.c:499
+msgid ""
+"You need a Passphrase to protect your secret key.\n"
+"\n"
+msgstr ""
+
+#: g10/keygen.c:508
+msgid ""
+"You don't what a passphrase - this is probably a *bad* idea!\n"
+"I will do it anyway.  You can change your passphrase at anytime,\n"
+"using this program with the option \"--change-passphrase\"\n"
+"\n"
+msgstr ""
+
+#: g10/keygen.c:514
+msgid "passphrase not correctly repeated; try again.\n"
+msgstr ""
+
+#: g10/keygen.c:531
+msgid "writing public certificate to '%s'\n"
+msgstr ""
+
+#: g10/keygen.c:532
+msgid "writing secret certificate to '%s'\n"
+msgstr ""
+
+#: g10/keygen.c:544
+msgid ""
+"We need to generate a lot of random bytes. It is a good idea to perform\n"
+"some other action (work in another window, move the mouse, utilize the\n"
+"network and the disks) during the prime generation; this gives the random\n"
+"number generator a better chance to gain enough entropy.\n"
+msgstr ""
+
+#: g10/keygen.c:611
+msgid "public and secret key created and signed.\n"
+msgstr ""
+
+#: g10/keygen.c:622
+msgid "Key generation failed: %s\n"
+msgstr ""
diff -urN g10-0.2.0/scripts/distfiles g10-0.2.1/scripts/distfiles
--- g10-0.2.0/scripts/distfiles	Tue Dec 23 18:00:11 1997
+++ g10-0.2.1/scripts/distfiles	Tue Jan 27 21:45:04 1998
@@ -2,3 +2,4 @@
 config.sub
 install-sh
 mkinstalldirs
+mkdiff
diff -urN g10-0.2.0/scripts/mkdiff g10-0.2.1/scripts/mkdiff
--- g10-0.2.0/scripts/mkdiff	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/scripts/mkdiff	Tue Jan 27 21:47:12 1998
@@ -0,0 +1,74 @@
+#!/bin/sh
+
+set -e
+
+curr_ver=$(ls g10-*.tar.gz | sort -r -t '.' -n +0.4 -1 +1 -2 +2 \
+           | head -1 | sed -e 's/g10-\(.*\).tar.gz/\1/' )
+prev_ver=$(ls g10-*.tar.gz | sort -r -t '.' -n +0.4 -1 +1 -2 +2 \
+           | head -2 | tail -1 | sed -e 's/g10-\(.*\).tar.gz/\1/' )
+
+echo "Current  is: $curr_ver"
+echo "Previous is: $prev_ver"
+
+echo "Removing old directories"
+[ -d "g10-$curr_ver" ] && rm -rf "g10-$curr_ver"
+[ -d "g10-$prev_ver" ] && rm -rf "g10-$prev_ver"
+ 
+echo "Unpacking previous and current tar" 
+tar xzf "g10-$curr_ver.tar.gz"
+tar xzf "g10-$prev_ver.tar.gz"
+
+echo "Diffing"
+tmp_name="g10-$curr_ver.diff.tmp"
+diff_name="g10-$curr_ver.diff"
+
+diff -urN "g10-$prev_ver/" "g10-$curr_ver/"  > $tmp_name || true
+
+echo "Making patch file"
+
+cat <<EOF > $diff_name
+
+This is a patch file against $prev_ver.
+
+Change to directory g10-$prev_ver (or however you renamed it)
+and give this command:
+
+     zcat somepath/g10-$curr_ver.diff.gz | patch -p1
+
+It is a good idea to rename your current directory to g10-$curr_ver now.
+
+
+
+Prereq: $prev_ver
+
+EOF
+
+sed -ne '/^diff.*VERSION/,/^+[0-9][0-9]*/ p' $tmp_name >> $diff_name
+sed -e '/^diff.*VERSION/,/^+[0-9][0-9]*/ d'  $tmp_name >> $diff_name
+
+rm $tmp_name
+
+echo "Compressing patch file"
+gzip -9 $diff_name
+
+echo "Checking patch file"
+cd g10-$prev_ver
+zcat ../$diff_name.gz | patch -s -p1 
+rm $(find . -name "*.orig")
+cd ..
+
+if ! diff -urN "g10-$prev_ver/" "g10-$curr_ver/" >/dev/null ; then
+   echo "compare failed"
+   exit 1
+fi
+
+
+echo "cleaning up"
+
+rm -rf "g10-$curr_ver"
+rm -rf "g10-$prev_ver"
+
+echo "Patch file $diff_name.gz is good."
+
+
+
diff -urN g10-0.2.0/tools/Makefile.am g10-0.2.1/tools/Makefile.am
--- g10-0.2.0/tools/Makefile.am	Mon Dec 22 22:02:56 1997
+++ g10-0.2.1/tools/Makefile.am	Tue Jan 27 15:57:16 1998
@@ -2,12 +2,15 @@
 
 INCLUDES = -I$(top_srcdir)/include
 
-bin_PROGRAMS = mpicalc
+noinst_PROGRAMS = mpicalc bftest
 
 mpicalc_SOURCES = mpicalc.c
 
+bftest_SOURCES = bftest.c
 
-LDADD = -L ../cipher -L ../mpi -L ../util  -lmpi -lutil
 
-$(PROGRAMS): ../mpi/libmpi.a
+LDADD = -L ../cipher -L ../mpi -L ../util -L ../cipher	\
+	-lmpi -lutil -lmpi -lutil -lcipher
+
+$(PROGRAMS): ../mpi/libmpi.a ../cipher/libcipher.a
 
diff -urN g10-0.2.0/tools/Makefile.in g10-0.2.1/tools/Makefile.in
--- g10-0.2.0/tools/Makefile.in	Sun Jan 25 20:22:14 1998
+++ g10-0.2.1/tools/Makefile.in	Wed Jan 28 16:36:57 1998
@@ -40,14 +40,17 @@
 
 INCLUDES = -I$(top_srcdir)/include
 
-bin_PROGRAMS = mpicalc
+noinst_PROGRAMS = mpicalc bftest
 
 mpicalc_SOURCES = mpicalc.c
 
-LDADD = -L ../cipher -L ../mpi -L ../util  -lmpi -lutil
+bftest_SOURCES = bftest.c
+
+LDADD = -L ../cipher -L ../mpi -L ../util -L ../cipher	\
+	-lmpi -lutil -lmpi -lutil -lcipher
 mkinstalldirs = $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ../config.h
-PROGRAMS = $(bin_PROGRAMS)
+PROGRAMS = $(noinst_PROGRAMS)
 
 
 CC = @CC@
@@ -65,6 +68,9 @@
 mpicalc_OBJECTS = mpicalc.o
 EXTRA_mpicalc_SOURCES =
 mpicalc_LDADD = $(LDADD)
+bftest_OBJECTS = bftest.o
+EXTRA_bftest_SOURCES =
+bftest_LDADD = $(LDADD)
 DIST_COMMON = Makefile.am Makefile.in
 
 
@@ -77,8 +83,8 @@
 	$(TEXINFOS) $(INFO_DEPS) $(MANS) $(EXTRA_DIST) $(DATA)
 
 TAR = tar
-SOURCES = $(mpicalc_SOURCES)
-OBJECTS = $(mpicalc_OBJECTS)
+SOURCES = $(mpicalc_SOURCES) $(bftest_SOURCES)
+OBJECTS = $(mpicalc_OBJECTS) $(bftest_OBJECTS)
 
 default: all
 
@@ -89,27 +95,14 @@
 Makefile: $(top_builddir)/config.status Makefile.in
 	cd $(top_builddir) && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= ./config.status
 
-mostlyclean-binPROGRAMS:
-
-clean-binPROGRAMS:
-	rm -f $(bin_PROGRAMS)
-
-distclean-binPROGRAMS:
+mostlyclean-noinstPROGRAMS:
 
-maintainer-clean-binPROGRAMS:
+clean-noinstPROGRAMS:
+	rm -f $(noinst_PROGRAMS)
 
-install-binPROGRAMS: $(bin_PROGRAMS)
-	$(mkinstalldirs) $(bindir)
-	list="$(bin_PROGRAMS)"; for p in $$list; do \
-	  if test -f $$p; then \
-	    $(INSTALL_PROGRAM) $$p $(bindir)/`echo $$p|sed '$(transform)'`; \
-	  else :; fi; \
-	done
+distclean-noinstPROGRAMS:
 
-uninstall-binPROGRAMS:
-	list="$(bin_PROGRAMS)"; for p in $$list; do \
-	  rm -f $(bindir)/`echo $$p|sed '$(transform)'`; \
-	done
+maintainer-clean-noinstPROGRAMS:
 
 .c.o:
 	$(COMPILE) $<
@@ -127,6 +120,10 @@
 
 mpicalc: $(mpicalc_OBJECTS) $(mpicalc_DEPENDENCIES)
 	$(LINK) $(mpicalc_OBJECTS) $(mpicalc_LDADD) $(LIBS)
+$(bftest_OBJECTS): ../config.h
+
+bftest: $(bftest_OBJECTS) $(bftest_DEPENDENCIES)
+	$(LINK) $(bftest_OBJECTS) $(bftest_LDADD) $(LIBS)
 
 ID: $(HEADERS) $(SOURCES)
 	here=`pwd` && cd $(srcdir) && mkid -f$$here/ID $(SOURCES) $(HEADERS)
@@ -153,6 +150,13 @@
 	  || ln $(srcdir)/$$file $(distdir)/$$file 2> /dev/null \
 	  || cp -p $(srcdir)/$$file $(distdir)/$$file; \
 	done
+bftest.o: bftest.c ../include/util.h ../include/types.h \
+ ../include/errors.h ../include/mpi.h ../include/iobuf.h \
+ ../include/memory.h ../include/cipher.h ../include/../cipher/md.h \
+ ../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+ ../include/../cipher/md5.h ../include/../cipher/rsa.h \
+ ../include/../cipher/blowfish.h ../include/../cipher/gost.h \
+ ../include/../cipher/elgamal.h
 mpicalc.o: mpicalc.c ../include/util.h ../include/errors.h \
  ../include/types.h ../include/mpi.h ../include/iobuf.h \
  ../include/memory.h
@@ -165,21 +169,20 @@
 
 installcheck:
 
-install-exec: install-binPROGRAMS
+install-exec: 
 
 install-data: 
 
 install: install-exec install-data all
 	@:
 
-uninstall: uninstall-binPROGRAMS
+uninstall: 
 
 all: $(PROGRAMS) Makefile
 
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' install
 installdirs:
-	$(mkinstalldirs)  $(bindir)
 
 
 mostlyclean-generic:
@@ -195,25 +198,25 @@
 maintainer-clean-generic:
 	test -z "$(MAINTAINERCLEANFILES)" || rm -f $(MAINTAINERCLEANFILES)
 	test -z "$(BUILT_SOURCES)" || rm -f $(BUILT_SOURCES)
-mostlyclean:  mostlyclean-binPROGRAMS mostlyclean-compile \
+mostlyclean:  mostlyclean-noinstPROGRAMS mostlyclean-compile \
 		mostlyclean-tags mostlyclean-generic
 
-clean:  clean-binPROGRAMS clean-compile clean-tags clean-generic \
+clean:  clean-noinstPROGRAMS clean-compile clean-tags clean-generic \
 		mostlyclean 
 
-distclean:  distclean-binPROGRAMS distclean-compile distclean-tags \
+distclean:  distclean-noinstPROGRAMS distclean-compile distclean-tags \
 		distclean-generic clean 
 	rm -f config.status
 
-maintainer-clean:  maintainer-clean-binPROGRAMS maintainer-clean-compile \
-		maintainer-clean-tags maintainer-clean-generic \
-		distclean 
+maintainer-clean:  maintainer-clean-noinstPROGRAMS \
+		maintainer-clean-compile maintainer-clean-tags \
+		maintainer-clean-generic distclean 
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
 
-.PHONY: default mostlyclean-binPROGRAMS distclean-binPROGRAMS \
-clean-binPROGRAMS maintainer-clean-binPROGRAMS uninstall-binPROGRAMS \
-install-binPROGRAMS mostlyclean-compile distclean-compile clean-compile \
+.PHONY: default mostlyclean-noinstPROGRAMS distclean-noinstPROGRAMS \
+clean-noinstPROGRAMS maintainer-clean-noinstPROGRAMS \
+mostlyclean-compile distclean-compile clean-compile \
 maintainer-clean-compile tags mostlyclean-tags distclean-tags \
 clean-tags maintainer-clean-tags distdir info dvi check installcheck \
 install-exec install-data install uninstall all installdirs \
@@ -221,7 +224,7 @@
 maintainer-clean-generic clean mostlyclean distclean maintainer-clean
 
 
-$(PROGRAMS): ../mpi/libmpi.a
+$(PROGRAMS): ../mpi/libmpi.a ../cipher/libcipher.a
 .SUFFIXES:
 .SUFFIXES: .c .o
 
diff -urN g10-0.2.0/tools/bftest.c g10-0.2.1/tools/bftest.c
--- g10-0.2.0/tools/bftest.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/tools/bftest.c	Tue Jan 27 12:42:59 1998
@@ -0,0 +1,94 @@
+/* bftest.c - Blowfish test program
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#ifdef __MINGW32__
+  #include <io.h>
+  #include <fcntl.h>
+#endif
+
+#include "util.h"
+#include "cipher.h"
+
+static void
+my_usage(void)
+{
+    fprintf(stderr, "usage: bftest [-e][-d] key\n");
+    exit(1);
+}
+
+const char *
+strusage( int level )
+{
+    return default_strusage(level);
+}
+
+int
+main(int argc, char **argv)
+{
+    int encode=0;
+    BLOWFISH_context ctx;
+    char buf[100];
+    char iv[BLOWFISH_BLOCKSIZE];
+    int n, size=8;
+
+  #ifdef __MINGW32__
+    setmode( fileno(stdin), O_BINARY );
+    setmode( fileno(stdout), O_BINARY );
+  #endif
+
+    if( argc > 1 && !strcmp(argv[1], "-e") ) {
+	encode++;
+	argc--; argv++;
+    }
+    else if( argc > 1 && !strcmp(argv[1], "-E") ) {
+	encode++;
+	argc--; argv++;
+	size = 10;
+    }
+    else if( argc > 1 && !strcmp(argv[1], "-d") ) {
+	argc--; argv++;
+    }
+    else if( argc > 1 && !strcmp(argv[1], "-D") ) {
+	argc--; argv++;
+	size = 10;
+    }
+    if( argc != 2 )
+	my_usage();
+    argc--; argv++;
+
+    blowfish_setkey( &ctx, *argv, strlen(*argv) );
+    memset(iv,0, BLOWFISH_BLOCKSIZE);
+    blowfish_setiv( &ctx, iv );
+    while( (n = fread( buf, 1, size, stdin )) > 0 ) {
+	if( encode )
+	    blowfish_encode_cfb( &ctx, buf, buf, n );
+	else
+	    blowfish_decode_cfb( &ctx, buf, buf, n );
+	if( fwrite( buf, 1, n, stdout) != n )
+	    log_fatal("write error\n");
+    }
+
+    return 0;
+}
+
diff -urN g10-0.2.0/util/Makefile.am g10-0.2.1/util/Makefile.am
--- g10-0.2.0/util/Makefile.am	Tue Nov 18 13:05:39 1997
+++ g10-0.2.1/util/Makefile.am	Wed Jan 28 09:55:15 1998
@@ -6,7 +6,7 @@
 
 
 util_SOURCES = logger.c fileutil.c miscutil.c strgutil.c  \
-	       ttyio.c	argparse.c memory.c errors.c iobuf.c
+	       ttyio.c	argparse.c memory.c secmem.c errors.c iobuf.c
 
 
 
diff -urN g10-0.2.0/util/Makefile.in g10-0.2.1/util/Makefile.in
--- g10-0.2.0/util/Makefile.in	Sun Jan 25 20:22:12 1998
+++ g10-0.2.1/util/Makefile.in	Wed Jan 28 16:36:56 1998
@@ -43,7 +43,7 @@
 noinst_LIBRARIES = util
 
 util_SOURCES = logger.c fileutil.c miscutil.c strgutil.c  \
-	       ttyio.c	argparse.c memory.c errors.c iobuf.c
+	       ttyio.c	argparse.c memory.c secmem.c errors.c iobuf.c
 mkinstalldirs = $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ../config.h
 LIBRARIES = $(noinst_LIBRARIES)
@@ -64,7 +64,7 @@
 LINK = $(CC) $(LDFLAGS) -o $@
 util_LIBADD =
 util_OBJECTS = logger.o fileutil.o miscutil.o strgutil.o ttyio.o \
-argparse.o memory.o errors.o iobuf.o
+argparse.o memory.o secmem.o errors.o iobuf.o
 EXTRA_util_SOURCES =
 LIBFILES =  libutil.a
 AR = ar
@@ -148,7 +148,7 @@
 	done
 argparse.o: argparse.c ../include/util.h ../include/types.h \
  ../include/errors.h ../include/mpi.h ../include/iobuf.h \
- ../include/memory.h
+ ../include/memory.h ../include/i18n.h
 errors.o: errors.c ../include/errors.h
 fileutil.o: fileutil.c ../include/util.h ../include/errors.h \
  ../include/types.h ../include/mpi.h ../include/iobuf.h \
@@ -165,6 +165,9 @@
 miscutil.o: miscutil.c ../include/types.h ../include/util.h \
  ../include/errors.h ../include/mpi.h ../include/iobuf.h \
  ../include/memory.h
+secmem.o: secmem.c ../include/types.h ../include/memory.h \
+ ../include/util.h ../include/errors.h ../include/mpi.h \
+ ../include/iobuf.h
 strgutil.o: strgutil.c ../include/types.h ../include/util.h \
  ../include/errors.h ../include/mpi.h ../include/iobuf.h \
  ../include/memory.h
diff -urN g10-0.2.0/util/argparse.c g10-0.2.1/util/argparse.c
--- g10-0.2.0/util/argparse.c	Sat Jan 24 12:38:36 1998
+++ g10-0.2.1/util/argparse.c	Tue Jan 27 15:52:55 1998
@@ -27,6 +27,7 @@
 #include <string.h>
 
 #include "util.h"
+#include "i18n.h"
 
 
 /*********************************
@@ -544,7 +545,7 @@
 	indent += 10;
 	puts("Options:");
 	for(i=0; opts[i].short_opt; i++ ) {
-	    s = opts[i].description;
+	    s = _( opts[i].description );
 	    if( s && *s== '\r' ) /* hide this line */
 		continue;
 	    if( opts[i].short_opt < 256 )
diff -urN g10-0.2.0/util/errors.c g10-0.2.1/util/errors.c
--- g10-0.2.0/util/errors.c	Mon Jan 19 18:01:31 1998
+++ g10-0.2.1/util/errors.c	Mon Jan 26 13:40:50 1998
@@ -66,6 +66,7 @@
       X(SIG_CLASS      ,"Unknown signature class")
       X(TRUSTDB        ,"TrustDB error")
       X(BAD_CERT       ,"Bad certificate")
+      X(INV_USER_ID    ,"malformed user id")
 
       default: p = buf; sprintf(buf, "g10err=%d", err); break;
     }
diff -urN g10-0.2.0/util/logger.c g10-0.2.1/util/logger.c
--- g10-0.2.0/util/logger.c	Fri Jan 16 12:24:10 1998
+++ g10-0.2.1/util/logger.c	Wed Jan 28 10:11:34 1998
@@ -111,6 +111,7 @@
     va_start( arg_ptr, fmt ) ;
     vfprintf(stderr,fmt,arg_ptr) ;
     va_end(arg_ptr);
+    secmem_dump_stats();
     exit(2);
 }
 
@@ -124,6 +125,7 @@
     vfprintf(stderr,fmt,arg_ptr) ;
     va_end(arg_ptr);
     fflush(stderr);
+    secmem_dump_stats();
     abort();
 }
 
diff -urN g10-0.2.0/util/memory.c g10-0.2.1/util/memory.c
--- g10-0.2.0/util/memory.c	Mon Dec 22 22:05:03 1997
+++ g10-0.2.1/util/memory.c	Wed Jan 28 09:59:07 1998
@@ -314,9 +314,10 @@
 
 
 static void
-out_of_core(size_t n)
+out_of_core(size_t n, int secure)
 {
-    log_fatal("out of memory while allocating %u bytes\n", (unsigned)n );
+    log_fatal("out of %s memory while allocating %u bytes\n",
+			secure? "secure":"" ,(unsigned)n );
 }
 
 /****************
@@ -329,7 +330,7 @@
     char *p;
 
     if( !(p = malloc( n + 5 )) )
-	out_of_core(n);
+	out_of_core(n,0);
     store_len(p,n,0);
     p[4+n] = MAGIC_END_BYTE; /* need to add the length somewhere */
     return p+4;
@@ -344,8 +345,8 @@
 {
     char *p;
 
-    if( !(p = malloc( n + 5 )) ) /* fixme: should alloc from the secure heap*/
-	out_of_core(n);
+    if( !(p = secmem_malloc( n + 5 )) )
+	out_of_core(n,1);
     store_len(p,n,1);
     p[4+n] = MAGIC_END_BYTE;
     return p+4;
@@ -408,7 +409,10 @@
     free_entry(p-4, info);
   #else
     m_check(p);
-    free(p-4);
+    if( m_is_secure(a) )
+	secmem_free(p-4);
+    else
+	free(p-4);
   #endif
 }
 
diff -urN g10-0.2.0/util/secmem.c g10-0.2.1/util/secmem.c
--- g10-0.2.0/util/secmem.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.1/util/secmem.c	Wed Jan 28 15:24:25 1998
@@ -0,0 +1,243 @@
+/* secmem.c  -	memory allocation from a secure heap
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <stdarg.h>
+#if defined(HAVE_MLOCK) || defined(HAVE_MMAP)
+  #include <unistd.h>
+  #include <sys/mman.h>
+  #include <sys/types.h>
+#endif
+
+#include "types.h"
+#include "memory.h"
+#include "util.h"
+
+
+#define DEFAULT_POOLSIZE 8196
+
+typedef struct memblock_struct MEMBLOCK;
+struct memblock_struct {
+    unsigned size;
+    union {
+	MEMBLOCK *next;
+	long align_dummy;
+	char d[1];
+    } u;
+};
+
+
+
+static void  *pool;
+static int   pool_okay;
+static int   pool_is_mmapped;
+static size_t poolsize; /* allocated length */
+static size_t poollen;	/* used length */
+static MEMBLOCK *unused_blocks;
+static unsigned max_alloced;
+static unsigned cur_alloced;
+static unsigned max_blocks;
+static unsigned cur_blocks;
+
+
+static void
+lock_pool( void *p, size_t n )
+{
+  #ifdef HAVE_MLOCK
+    uid_t uid;
+    int err;
+
+    err = mlock( p, n );
+    if( err && errno )
+	err = errno;
+
+    uid = getuid();
+    if( uid && !geteuid() ) {
+	if( setuid( uid ) )
+	    log_fatal("failed to reset uid: %s\n", strerror(errno));
+    }
+
+    if( err ) {
+	log_error("cant lock memory: %s\n", strerror(err));
+	log_info("Warning: using insecure memory!\n");
+    }
+
+  #else
+    log_info("Please note that you dont have secure memory on this system\n");
+  #endif
+}
+
+
+static void
+init_pool( size_t n)
+{
+    poolsize = n;
+
+  #if HAVE_MMAP && defined(MAP_ANONYMOUS)
+    poolsize = (poolsize + 4095) & ~4095;
+    pool = mmap( 0, poolsize, PROT_READ|PROT_WRITE,
+			      MAP_PRIVATE|MAP_ANONYMOUS, -1, 0);
+    if( pool == (void*)-1 )
+	log_error("cant mmap pool of %u bytes: %s - using malloc\n",
+			    (unsigned)poolsize, strerror(errno));
+    else {
+	pool_is_mmapped = 1;
+	pool_okay = 1;
+    }
+
+  #endif
+    if( !pool_okay ) {
+	pool = malloc( poolsize );
+	if( !pool )
+	    log_fatal("cant allocate memory pool of %u bytes\n",
+						       (unsigned)poolsize);
+	else
+	    pool_okay = 1;
+    }
+    lock_pool( pool, poolsize );
+    poollen = 0;
+}
+
+
+/* concatenate unused blocks */
+static void
+compress_pool(void)
+{
+
+}
+
+
+void
+secmem_init( size_t n )
+{
+    if( n < DEFAULT_POOLSIZE )
+	n = DEFAULT_POOLSIZE;
+    if( !pool_okay )
+	init_pool(n);
+    else
+	log_error("Oops, secure memory pool already initialized\n");
+}
+
+
+void *
+secmem_malloc( size_t size )
+{
+    MEMBLOCK *mb, *mb2;
+    int compressed=0;
+
+    if( !pool_okay )
+	init_pool(DEFAULT_POOLSIZE);
+
+    /* blocks are always a multiple of 32 */
+    size += sizeof(MEMBLOCK);
+    size = ((size + 31) / 32) * 32;
+
+  retry:
+    /* try to get it from the used blocks */
+    for(mb = unused_blocks,mb2=NULL; mb; mb2=mb, mb = mb->u.next )
+	if( mb->size >= size ) {
+	    if( mb2 )
+		mb2->u.next = mb->u.next;
+	    else
+		unused_blocks = mb->u.next;
+	    goto leave;
+	}
+    /* allocate a new block */
+    if( (poollen + size <= poolsize) ) {
+	mb = pool + poollen;
+	poollen += size;
+	mb->size = size;
+    }
+    else if( !compressed ) {
+	compressed=1;
+	compress_pool();
+	goto retry;
+    }
+    else
+	return NULL;
+
+  leave:
+    cur_alloced += mb->size;
+    cur_blocks++;
+    if( cur_alloced > max_alloced )
+	max_alloced = cur_alloced;
+    if( cur_blocks > max_blocks )
+	max_blocks = cur_blocks;
+    return &mb->u.d;
+}
+
+
+void
+secmem_free( void *a )
+{
+    MEMBLOCK *mb;
+    size_t size;
+
+    if( !a )
+	return;
+
+    mb = (MEMBLOCK*)((char*)a - ((size_t) &((MEMBLOCK*)0)->u.d));
+    size = mb->size;
+    memset(mb, 0xff, size );
+    memset(mb, 0xaa, size );
+    memset(mb, 0x55, size );
+    memset(mb, 0x00, size );
+    mb->size = size;
+    mb->u.next = unused_blocks;
+    unused_blocks = mb;
+    cur_blocks--;
+    cur_alloced -= size;
+}
+
+void
+secmem_term()
+{
+    if( !pool_okay )
+	return;
+
+    memset( pool, 0xff, poolsize);
+    memset( pool, 0xaa, poolsize);
+    memset( pool, 0x55, poolsize);
+    memset( pool, 0x00, poolsize);
+  #if HAVE_MMAP
+    if( pool_is_mmapped )
+	munmap( pool, poolsize );
+  #endif
+    pool = NULL;
+    pool_okay = 0;
+    poolsize=0;
+    poollen=0;
+    unused_blocks=NULL;
+}
+
+
+void
+secmem_dump_stats()
+{
+    fprintf(stderr,
+		"secmem usage: %u/%u bytes in %u/%u blocks of pool %lu/%lu\n",
+		cur_alloced, max_alloced, cur_blocks, max_blocks,
+		(ulong)poollen, (ulong)poolsize );
+}
+
diff -urN g10-0.2.0/util/strgutil.c g10-0.2.1/util/strgutil.c
--- g10-0.2.0/util/strgutil.c	Tue Jan 13 17:04:14 1998
+++ g10-0.2.1/util/strgutil.c	Mon Jan 26 13:51:08 1998
@@ -73,6 +73,31 @@
     return NULL ;
 }
 
+/****************
+ * Wie strncpy(), aber es werden maximal n-1 zeichen kopiert und ein
+ * '\0' angehngt. Ist n = 0, so geschieht nichts, ist Destination
+ * gleich NULL, so wird via m_alloc Speicher besorgt, ist dann nicht
+ * gengend Speicher vorhanden, so bricht die funktion ab.
+ */
+char *
+mem2str( char *dest , const void *src , size_t n )
+{
+    char *d;
+    const char *s;
+
+    if( n ) {
+	if( !dest )
+	    dest = m_alloc( n ) ;
+	d = dest;
+	s = src ;
+	for(n--; n && *s; n-- )
+	    *d++ = *s++;
+	*d = '\0' ;
+    }
+
+    return dest ;
+}
+
 
 /****************
  * remove leading and trailing white spaces
